{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 1991-1999 Peter Mandrella                                   }
{ (c) 2000-2001 OpenXP-Team                                       }
{ (c) 2002-2003 FreeXP, http://www.freexp.de                      }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/oldlicense.html.   }
{ --------------------------------------------------------------- }
{ $Id: uuz.pas,v 1.35.2.81 2003/01/19 08:29:11 mw Exp $ }

{ UUCP/RFC <-> ZConnect }
{ PM 10/92              }

{$I XPDEFINE.INC }
{$S-}
(* {$R+,Q+}  {nur zum Testen aktivieren!} *)

{$M 16384,$14000,655360}

program uuz;

uses  xpglobal,crt,dos,typeform,xpovl,fileio,xpdatum,mimedec,lfn,uuz0;


{ --- ZConnect-Header verarbeiten ----------------------------------- }

const ReadKoplist = false;
const ReadOEMList = false;

{$define uuzrefs}
{$define ulines}
{$define pgp}

{ 03.02.2000 robo }
{$define uuzmime }
{ /robo }

{$I xpmakehd.inc}


{ my: kompletter Rewrite 08/2002-04/2003 }

procedure WriteHeader;
var  i,j : integer;
      ss : Hugestring;
    dupe : boolean;

  procedure wrs(s:Hugestring);
  begin
    TruncStr(s,253);
    s:=s+#13#10;
    wrfs(s);
  end;

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003 }
  {     (Langes Char-Array schreiben)                    }
  procedure wrls(hdr:LongHdrP; len:word);
  begin
    if longint(outbufpos)+longint(len)>=longint(outbufsize) then
      FlushOutbuf;
    if len>outbufsize then
      blockwrite(f2,hdr^[1],len)
    else begin
      FastMove(hdr^[1],outbuf^[outbufpos],len);
      inc(outbufpos,len);
    end;
  end;

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003 }
  {     (Schreiben langer ZC-Header bis 65500 Zeichen)   }
  function WriteLongZcHdr(const n:byte; const Id:string):boolean;
  begin
    if (LongHdr[n].hdr<>nil) then
    begin
      WriteLongZcHdr:=true;
      ss:=Id+': '; wrfs(ss);
      wrls(LongHdr[n].hdr,LongHdr[n].len);
      wrs(iifs(LongHdr[n].trunc,LongHdr[n].rest+truncater,LongHdr[n].rest));
      freemem(LongHdr[n].hdr,LongHdr[n].len);
    end
    else WriteLongZcHdr:=false;
  end;

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003    }
  {     (Untersttzung langer U/X-Header bis 65500 Zeichen) }
  procedure WriteUHdr;
  begin
    if Ustart<>nil then                                  { Header schreiben }
    begin
      Ulauf:=Ustart;
      while Ulauf<>nil do
      begin
        ss:=Ulauf^.Id^+': '; wrfs(ss);
        wrls(Ulauf^.hdr,Ulauf^.len);
        wrs(iifs(Ulauf^.trunc,Ulauf^.rest+truncater,Ulauf^.rest));
        Ulauf:=Ulauf^.next;
      end;
      while assigned(Ustart) do              { Liste und Speicher freigeben }
      begin
        Ulauf:=Ustart^.next;
        freemem(Ustart^.hdr,Ustart^.len);
        freemem(Ustart^.Id,length(Ustart^.Id^)+1);
        dispose(Ustart);
        Ustart:=Ulauf;
      end;
    end;
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003            }
  {     (Untersttzung langer Stichwort-Header bis 65500 Zeichen }
  {      und Bercksichtigung von (auch gequoteten) Phrasen)     }
  procedure WriteStichworte(keywords:string);
  var p,p1,
      hlen,
      klen : word;
       stw : string;
      lstw : LongHdrP;
         q : word;
         t : boolean;  { fr Parameter 'truncated' in 'GetHeader' }

    function QuotedChar(const c:word):boolean;
    var qc : word;
    begin
      qc:=c;
      while (qc>1) and (LongHdr[LKey].hdr^[qc-1]='\') do dec(qc);
      QuotedChar:=odd(c-qc);
    end;

  begin
    q:=0;
    if LongHdr[LKey].hdr<>nil then                  { langer Keyword-Header }
    begin
      hlen:=LongHdr[LKey].len;
      ss:='Stichwort: ';
      lstw:=nil;
      while LongHdr[LKey].hdr<>nil do
      begin
        p:=0;
        repeat
          inc(p);
          case LongHdr[LKey].hdr^[p] of
            '"' : if q=0 then                      { nicht in quoted-string }
                  begin
                    q:=p+1;
                    while (q<hlen) and not     { schlieendes DQUOTE suchen }
                          ((LongHdr[LKey].hdr^[q]='"') and
                           not QuotedChar(q))
                      do inc(q);
                    if (LongHdr[LKey].hdr^[q]='"') and
                       not QuotedChar(q) then
                      q:=p                        { ffnendes DQUOTE merken }
                    else
                      q:=0;
                  end
                  else begin                             { in quoted-string }
                    move(LongHdr[LKey].hdr^[p+1],        { schlieendes     }
                         LongHdr[LKey].hdr^[p],          { DQUOTE entfernen }
                         hlen-p);
                    move(LongHdr[LKey].hdr^[q+1],        { ffnendes        }
                         LongHdr[LKey].hdr^[q],          { DQUOTE entfernen }
                         hlen-q-1);
                    dec(hlen,2);
                    dec(p,2);
                    q:=0;
                  end;
            '\' : if q>0 then                            { in quoted-string }
                  begin
                    move(LongHdr[LKey].hdr^[p+1],   { quoted-pair entfernen }
                         LongHdr[LKey].hdr^[p],
                         hlen-p);
                    dec(hlen);
                  end;
          end;
        until (p=hlen) or                                    { Komma suchen }
              ((LongHdr[LKey].hdr^[p]=',') and (q=0));
        p1:=p;
        while (p1>0) and                                 { 'p1' auf letztes }
              (LongHdr[LKey].hdr^[p1] in [',',' ']) do   { Zeichen vor ','  }
          dec(p1);
        while (p<hlen) and                               { 'p' auf erstes   }
              (LongHdr[LKey].hdr^[p] in [',',' ']) do    { Zeichen nach ',' }
          inc(p);
        if (p1>253) and (lstw=nil) and (maxavail>=p1)
        then begin
          wrfs(ss);                                         { 'Stichwort: ' }
          getmem(lstw,p1);
          fastmove(LongHdr[LKey].hdr^[1],lstw^[1],p1);
          if (p>=hlen) then
          begin
            t:=LongHdr[LKey].trunc;
            stw:=LongHdr[LKey].rest;    { 'stw' fr 'GetHeader' mibrauchen }
          end
          else begin
            t:=false;
            stw:='';
          end;
          klen:=p1;
          GetHeader(lstw,klen,stw,t,false,true,false,1); { MIME-Decodierung }
          if (p>=hlen) then
          begin
            LongHdr[LKey].trunc:=t;
            LongHdr[LKey].rest:=stw;
          end;
          wrls(lstw,klen);                       { langes Keyword schreiben }
          freemem(lstw,p1);
          lstw:=nil;
        end
        else if p1>0 then begin
          wrfs(ss);                                         { 'Stichwort: ' }
          fastmove(LongHdr[LKey].hdr^[1],stw[1],p1);
          stw[0]:=chr(p1);
          RFC2047_Decode(stw,1);
          wrfs(stw);       { kurzes oder langes Keyword (gekrzt) schreiben }
        end;
        if p>=hlen then                                   { letztes Keyword }
        begin
          if p1>0 then
            wrs(iifs(LongHdr[LKey].trunc,LongHdr[LKey].rest+truncater,
                LongHdr[LKey].rest));
          freemem(LongHdr[LKey].hdr,LongHdr[LKey].len);
          LongHdr[LKey].hdr:=nil;                    { hier notwendig wegen }
        end                                          { Schleifenbedingung!  }
        else begin
          if p1>0 then wrs('');
          dec(hlen,p-1);
          move(LongHdr[LKey].hdr^[p],LongHdr[LKey].hdr^[1],hlen);
        end;
      end;
    end
    else while keywords<>'' do             { Backdoor, falls Speicher knapp }
    begin                                  { bzw. Keyword nicht "lang" ist  }
      stw:=RfcUnquoteToken(keywords);
      RFC2047_Decode(stw,1);
      if stw<>'' then wrs('Stichwort: '+stw);
    end;
  end;

begin   { of WriteHeader }
  with hd do
  begin
    if (empfanz>0) and (xempf<>nil) then
      for i:=1 to empfanz do
        wrs('EMP: '+xempf^[i]^)
    else wrs('EMP: /UNZUSTELLBAR');

    if xoem<>nil then
    begin
      for i:=1 to oemanz do
      begin
        if (xoem^[i]^<>'') and
           (lstr(xoem^[i]^)<>lstr(xempf^[1]^)) then
          wrs('OEM: '+xoem^[i]^);
        freemem(xoem^[i],length(xoem^[i]^)+1);
        xoem^[i]:=nil;
      end;
      dispose(xoem);
    end;

    if (xempf<>nil) then          { hd.xempf erst jetzt freigeben/disposen, }
    begin                         { weil oben fr 'OEM:' noch bentigt!     }
      for i:=1 to empfanz do
      begin
        freemem(xempf^[i],length(xempf^[i]^)+1);
        xempf^[i]:=nil;
      end;
      dispose(xempf);
    end;

    if xkop<>nil then
    begin
      for i:=1 to kopanz do
      begin
        ss:='KOP: '; wrfs(ss);
        wrfs(xkop^[i].adr^);
        wrs(iifs(xkop^[i].name^<>'',' ('+xkop^[i].name^+')',''));
        freemem(xkop^[i].adr,length(xkop^[i].adr^)+1);
        freemem(xkop^[i].name,length(xkop^[i].name^)+1);
        xkop^[i].adr:=nil;
        xkop^[i].name:=nil;
      end;
      dispose(xkop);
    end;

    if xabs<>nil then         { hd.xabs darf hier eigentlich nie 'nil' sein }
    begin
      ss:='ABS: ';                                  { hd.xabs^[1] => 'ABS:' }
      for i:=1 to absanz do
      begin
        if i>1 then                     { ab hd.xabs^[2] => 'ANTWORT-AN:'   }
          ss:='ANTWORT-AN: ';           { (Versalien wegen Unterscheidung   }
        wrfs(ss);                       { zu "Antwort-an:" <=> "Reply-To:") }
        wrfs(xabs^[i].adr^);
        wrs(iifs(xabs^[i].name^<>'',' ('+xabs^[i].name^+')',''));
        if (i=1) and (wab<>'') then
        begin
          ss:='WAB: ';
          wrfs(ss);
          wrfs(wab);
          wrs(iifs(war<>'',' ('+war+')',''));
        end;
      end;
    end;

    if xreplyto<>nil then                      { "echte" Antwort-an:-Header }
    begin
      for i:=1 to replytoanz do
      begin
        for j:=1 to absanz do                               { Dupes filtern }
        begin
          dupe:=lstr(xreplyto^[i].adr^)=lstr(xabs^[j].adr^);
          if dupe then break;
        end;
        if not dupe then
        begin                                   { keine Versalien wegen     }
          ss:='Antwort-an: ';                   { Unterscheidung zu         }
          wrfs(ss);                             { "ANTWORT-AN:" <=> "From:" }
          wrfs(xreplyto^[i].adr^);
          wrs(iifs(xreplyto^[i].name^<>'',' ('+xreplyto^[i].name^+')',''));
        end;
        freemem(xreplyto^[i].adr,length(xreplyto^[i].adr^)+1);
        freemem(xreplyto^[i].name,length(xreplyto^[i].name^)+1);
        xreplyto^[i].adr:=nil;
        xreplyto^[i].name:=nil;
      end;
      dispose(xreplyto);
    end;

    if followup<>nil then
    begin
      for i:=1 to followups do
      begin
        wrs('Diskussion-in: '+followup^[i]^);
        freemem(followup^[i],length(followup^[i]^)+1);
        followup^[i]:=nil;
      end;
      dispose(followup);
    end;

    if not WriteLongZcHdr(LSub,'BET') then   { Langen BET:-Header schreiben }
      wrs('BET: '+betreff);                                 { Backdoor BET: }
    if not WriteLongZcHdr(LPath,'ROT') then  { Langen ROT:-Header schreiben }
      wrs('ROT: '+pfad);                                    { Backdoor ROT: }
    wrs('MID: '+msgid);
    wrs('EDA: '+zdatum);
    if typ='B'        then wrs('TYP: BIN');
    if datei<>''      then wrs('File: '   +datei);
    if ddatum<>''     then wrs('DDA: '    +ddatum);
    if InReplyTo<>'' then                { 'In-Reply-To:' mit 'References:' }
    begin                                { mergen, falls MsgID nicht in     }
      if ref='' then                     { 'References:' enthalten ist (es  }
      begin                              { gibt Mail-Clients wie Eudora,    }
        ref:=InReplyTo;                  { die zwar beide Header erzeugen,  }
        InReplyTo:='';                   { wo aber der direkte Bezug nur in }
      end                                { 'In-Reply-To:' enthalten ist)    }
      else if ref=InReplyTo then
        InReplyTo:=''
      else for i:=1 to addrefs do
      begin
        if addref[i]=InReplyTo then InReplyTo:='';
        if InReplyTo='' then break;
      end;
      if InReplyTo<>'' then             { MsgID aus 'In-Reply-To:' anhngen }
      begin
        if addrefs<maxrefs then
          inc(addrefs)
        else
          FastMove(hd.addref[2],hd.addref[1],
                  (maxrefs-1)*sizeof(hd.addref[1]));
        addref[addrefs]:=InReplyTo;
      end;
    end;
    if ref<>''        then wrs('BEZ: '    +ref);
    for i:=1 to addrefs do wrs('BEZ: '    +addref[i]);
    if ersetzt<>''    then wrs('ERSETZT: '+ersetzt);
    if error<>''      then wrs('ERR: '    +error);
    if not WriteLongZcHdr(LProg,'MAILER') and            { Langen MAILER:-  }
       (programm<>'') then                               { Header schreiben }
      wrs('MAILER: '+programm);                          { Backdoor MAILER: }
    if priority<>0    then wrs('U-X-Priority: '+strs(priority));
    if prio<>0        then wrs('Prio: '   +strs(prio));
    if not WriteLongZcHdr(LOrg,'ORG') and                { Langen ORG:-     }
       (organisation<>'') then                           { Header schreiben }
      wrs('ORG: '+organisation);                         { Backdoor ORG:    }
    if not WriteLongZcHdr(LPost,'Post') and              { Langen Post:-    }
       (postanschrift<>'') then                          { Header schreiben }
      wrs('Post: '+postanschrift);                       { Backdoor Post:   }
    if not WriteLongZcHdr(LTele,'Telefon') and          { Langen Telefon:-  }
       (telefon<>'') then                               { Header schreiben  }
      wrs('Telefon: '+telefon);                         { Backdoor Telefon: }
    if not WriteLongZcHdr(LHome,'U-X-Homepage') and    { Langen Homepage:-  }
       (homepage<>'') then                             { Header schreiben   }
      wrs('U-X-Homepage: '+homepage);                  { Backdoor Homepage: }
    if EmpfBestTo<>'' then wrs('EB: ' +
                                iifs(empfbestto<>xabs^[1].adr^,empfbestto,''));
    if attrib and attrIsEB<>0  then wrs('STAT: EB');

    if (xabs<>nil) then            { hd.xabs erst jetzt freigeben/disposen, }
    begin                          { weil oben fr 'Antwort-an:' und 'EB:'  }
      for i:=1 to absanz do        { noch bentigt!                         }
      begin
        freemem(xabs^[i].adr,adrlen+1);
        freemem(xabs^[i].name,realnlen+1);
        xabs^[i].adr:=nil;
        xabs^[i].name:=nil;
      end;
      dispose(xabs);
    end;

    if pm_reply       then wrs('STAT: PM-REPLY');
    if pgpflags and fPGP_encoded<>0 then wrs('CRYPT: PGP');
    WriteStichworte(keywords);         { Langen Stichwort:-Header schreiben }
    if not WriteLongZcHdr(LSum,'Zusammenfassung') and   { Lange Zusammen-   }
       (summary<>'') then                               { fassung schreiben }
      wrs('Zusammenfassung: '+summary);          { Backdoor Zusammenfassung }
    if mime.boundary<>'' then wrs('X-XP-Boundary: '+mime.boundary);
    if not WriteLongZcHdr(LGate,'X-Gateway') and         { Langen Gateway-  }
       (gateway<>'') then                                { Header schreiben }
      wrs('X-Gateway: '+gateway);                        { Backdoor Gateway }
    if control<>''    then begin
      if lstr(left(control,7))='cancel ' then wrs('STAT: CTL');
      wrs('CONTROL: '+control);
    end;
    if xpmode<>''   then wrs('X-XP-MODE: '+xpmode);
    if boxname<>''  then wrs('X-XP-BOX: '+boxname);
    wrs('X-XP-NTP: '+strs(netztyp));
    attrib:=attrib and not (attrReqEB+attrIsEB);
    if attrib<>0    then wrs('X-XP-ATT: '+hex(attrib,4));
    if fido_to<>''  then wrs('F-TO: '+fido_to);
    if XPointCtl<>0 then wrs('X-XP-CTL: '+strs(XPointCtl));
    WriteUHdr;                          { alle brigen U/X-Header schreiben }
    wrs('LEN: '+strs(groesse));     { LEN:-Header immer zuletzt schreiben,  }
    wrs('');                        { sonst kann PktXCode Probleme bekommen }
  end;
end;   { of WriteHeader }


{ --- UUCP/RFC -> ZConnect ------------------------------------------ }

var    { ok : boolean; }
       fpos : longint;
        eol : byte;     { ReadString ist am Zeilenende angekommen }
    lasteol : boolean;  { eol der vorausgehenden Zeile>0 }


procedure ReadBuf;
begin
  fpos:=filepos(f1);
  blockread(f1,buffer,bufsize,bufanz);
  bufpos:=0;
end;


procedure OpenFile(var fn:pathstr);
begin
  assign(f1,fn);
  reset(f1,1);
  ReadBuf;
  eol:=1;    { damit lasteol beim ersten RestString true wird }
end;


{$R-}
procedure ReadString(umbruch:boolean);
const l : Integer = 0;
      c : char = #0;

  procedure reload;  far;
  begin
    if eof(f1) then { ok:=false }
    else ReadBuf;
  end;

  procedure IncPos;
  begin
    inc(bufpos);
    if bufpos=bufanz then reload;
  end;

const
      savedi : word = 0;
      savebx : word = 0;
begin
  lasteol:=(eol>0);
  eol:=0;
   asm
     mov   si,bufpos
     mov   di,0                    { l:=0 }
     mov   dl,umbruch
     mov   bx,word ptr maxslen
     mov   dh,byte ptr maxslen+2   { maxslen>$ffff -> dh<>0 }
     or    dh,byte ptr maxslen+3
     mov   cx,bufanz
@@1: cmp   si,cx                   { bufpos>=bufanz? }
     jae   @@8                     { Ende der Eingabedatei }
     or    dh,dh                   { l<maxslen? }
     jnz   @@2
     cmp   di,bx
     jae   @@8
@@2: or    dl,dl                   { not umbruch or .. }
     jz    @@3
     cmp   di,253                  { .. l<253 }
     jae   @@8
@@3: mov   al,byte ptr buffer[si]
     inc   si                      { c:=buffer[bufpos] }
     cmp   al,13
     jz    @@4
     cmp   al,10                   { eol-Zeichen? }
     jz    @@4
     cmp   al,00h                  { #0 abfangen }
     jne   @3z
     mov   al,' '
@3z: cmp   al,1ah                  { Ctrl-Z abfangen }
     jne   @_3
     mov   al,'>'
@_3: cmp   di,253                  { max. Stringlnge erreicht? }
     ja    @@5
     inc   di                      { inc(l)  }
     mov   byte ptr s+di,al        { s[l]:=c }
     jmp   @@5
@@4: inc   eol
@@5: cmp   si,cx                   { bufpos = bufanz? }
     jb    @@7
     push  ax
     mov   savebx,bx
     mov   savedi,di
     mov   bufpos,si
     mov   bufanz,cx
     push  cs
     call  reload                  { nachladen }
     mov   si,bufpos
     mov   cx,bufanz
     mov   di,savedi
     mov   bx,savebx
     pop   ax
@@7: cmp   al,10
     jnz   @@1

     jmp @@9
     
@@8: cmp dl,0                     { Wenn Umbruch aktiv ist: }
     je @@9
     lea bx,[s+di+1]              { Vom Stringende zurueck bis zum }
     xor cx,cx
@_8: dec bx
     mov al,byte ptr[bx]          { letzten Trennzeichen gehen }
     cmp al,' '
     je @@9
     cmp al,','
     je @@9
     cmp al,';'
     je @@9
     cmp si,0           
     je @_9                       { Abbruch, wenn kein Trenner im Puffer ist }
     inc cx
     dec si
     dec di
     jne @_8
@_9: add si,cx          { wenn keine Trennmglichkeit gefunden wurde, }
     add di,cx          { Stringlnge und Bufferposition zurcksetzen }

@@9: mov   ax,di
     mov   byte ptr s,al           { s[0]:=char(l) }
     mov   bufpos,si
   end;
  MaxSlen:=255;
end;


procedure ReadBinString(bytesleft:longint);    { Base64-Codierung }
const b64chr : array[0..63] of char =
      'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
var   b1,b2,b3,p : byte;

  function getbyte:byte;
  begin
    if bufpos=bufanz then
      getbyte:=0
    else begin
      getbyte:=byte(buffer[bufpos]);
      inc(bufpos);
      if (bufpos=bufanz) and not eof(f1) then
        ReadBuf;
      end;
  end;

begin
  if (bytesleft>54) and (bufpos<bufanz-54) then
  asm
      cld
      mov   si,offset buffer
      add   si,bufpos
      mov   dx,18                { 18 byte-Tripel konvertieren }
      mov   cl,2
      mov   bx,offset b64chr
      mov   di,offset s[1]
      mov   ax,ds
      mov   es,ax
 @@1: lodsb                      { Byte 1 }
      mov   ah,al
      lodsb                      { Byte 2 }
      shr   ax,1
      rcr   ch,1
      shr   ax,1
      rcr   ch,1
      xchg  al,ah
      xlat
      stosb                      { Bit 7..2/1 }
      mov   al,ch
      shr   ax,cl
      xchg  al,ah
      xlat
      stosb                      { Bit 1..0/1 + Bit 7..4/2 }
      lodsb                      { Byte 3 }
      shr   ah,cl
      shr   ah,cl
      shl   ax,cl
      xchg  al,ah
      xlat
      stosb                      { Bit 3..0/2 + Bit 7..6/3 }
      mov   al,ah
      shr   al,cl
      xlat
      stosb                      { Bit 5..0/3 }
      dec   dx
      jnz   @@1
      mov   byte ptr s[0],72
      add   bufpos,54
  end else
  begin
    p:=0;
    repeat
      b1:=getbyte; b2:=getbyte; b3:=getbyte;
      s[p+1]:=b64chr[b1 shr 2];
      s[p+2]:=b64chr[(b1 and 3) shl 4 + b2 shr 4];
      s[p+3]:=b64chr[(b2 and 15) shl 2 + b3 shr 6];
      s[p+4]:=b64chr[b3 and 63];
      inc(p,4); dec(bytesleft,3);
      if bytesleft<0 then begin
        s[p]:='=';
        if bytesleft<-1 then s[p-1]:='=';
        end;
    until (p>70) or (bytesleft<=0);
    SetLength(s, p);
    end;
end;
{$IFDEF Debug }
  {$R+}
{$ENDIF }


{ my: Kompletter Rewrite 08/2002-04/2003 }

procedure ReadRFCheader(mail:boolean; s0:string);
const zz : string[40] = '';    { Datensegment-optimiert }
      s1 : string[40] = '';    { Original-Identifier    }
var  p,i : integer; { byte -> integer }

    HdrLine    : LongHdrP;
    HdrLen     : word;
    chkd_trunc : boolean;

    DonePath   : boolean;     { Pfad aus Received-Headern ist "voll"   }
    DoneProg   : boolean;     { 'MAILER:' aus 'X-XP-Version' ermittelt }
    structured : byte;        { strukturierter Header (fr 'context')  }

    drealn: string[realnlen]; { Realname verlngert }
    delivToEmpf  : string[AdrLen];
    delivToCount : byte;      { Counter fr Delivered-To-Header }
    delivToAlias : boolean;   { true nach erstem Delivered-To-Alias }

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003                     }
  { my: Langen ZC-Header bis 65500 Zeichen im Record-Array 'LongHdr' ablegen }
  procedure SaveLongHdr(const n:byte);
  begin
    if (LongHdr[n].hdr=nil) and                      { *mu* immer nil sein }
       (maxavail>=HdrLen) then
    begin                                 { Original-Header => 'LongHdr[n]' }
      getmem(LongHdr[n].hdr,HdrLen);
      fastmove(HdrLine^[1],LongHdr[n].hdr^[1],HdrLen);
      LongHdr[n].len:=HdrLen;
      LongHdr[n].rest:=rest;
      LongHdr[n].trunc:=truncated;
    end;
  end;

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003              }
  {     RFC-U/X-Header bis 65500 Zeichen in verketteter Liste ablegen }
  procedure AppUHdr(const Id:string; const MIMEdecode:boolean);
  begin
    if MIMEdecode then
      s0:=GetHeader(HdrLine,HdrLen,rest,truncated,
                    overflow,true,false,structured);
    if maxavail>=sizeof(Ustart^)+HdrLen+length(id)+1 then
    begin
      if Ustart=nil then
      begin
        new(Ustart);
        Ustart^.next:=nil;
        getmem(Ustart^.hdr,HdrLen);
        fastmove(HdrLine^[1],Ustart^.hdr^[1],HdrLen);
        Ustart^.len:=HdrLen;
        Ustart^.rest:=rest;
        Ustart^.trunc:=truncated;
        getmem(Ustart^.Id,length(Id)+1);
        Ustart^.Id^:=Id;
        Ulauf:=Ustart;
      end
      else begin                    { hinten anfgen }
        new(Ulauf^.next);
        Ulauf:=Ulauf^.next;
        Ulauf^.next:=nil;
        getmem(Ulauf^.hdr,HdrLen);
        fastmove(HdrLine^[1],Ulauf^.hdr^[1],HdrLen);
        Ulauf^.len:=HdrLen;
        Ulauf^.rest:=rest;
        Ulauf^.trunc:=truncated;
        getmem(Ulauf^.Id,length(Id)+1);
        Ulauf^.Id^:=Id;
      end;
    end;
  end;

  { my: Langen Header bis 65500 Zeichen vollstndig }
  {     MIME-decodieren und an 's0' zurckgeben     }
  function GetMimeString:string;
  begin
    s0:=GetHeader(HdrLine,HdrLen,rest,truncated,         { MIME-Decodierung }
                  overflow,true,false,structured);
    GetMimeString:=s0;
  end;

  { my: hd.xabs anlegen }
  procedure NewABS;
  begin
    releaseMem(LAbs);                     { reservierten Speicher freigeben }
    new(hd.xabs);
    fillchar(hd.xabs^,sizeof(hd.xabs^),0);
    hd.absanz:=0;
  end;

  { my: Neues Element in hd.xabs anlegen }
  {     ('absanz' wird *nicht* erhht!   }
  function CreateABS(const n:integer; const a,r:string):boolean;
  begin
    CreateABS:=false;
    { Fr hd.xabs Speicher in voller Variablenlnge  }
    { holen (wegen Vereinfachung einer mglichen     }
    { spteren Ersetzung durch Sender/WAB und des    }
    { Rotierens von Elementen innerhalb von hd.xabs) }
    if maxavail>=(adrlen+1)+(realnlen+1) then
    begin
      getmem(hd.xabs^[n].adr,adrlen+1);
      getmem(hd.xabs^[n].name,realnlen+1);
      hd.xabs^[n].adr^:=a;
      hd.xabs^[n].name^:=r;
      CreateABS:=true;
    end;
  end;

  { my: Element in hd.xabs entfernen      }
  {     ('absanz' wird *nicht* reduziert! }
  procedure RemoveABS(const n:integer);
  begin
    freemem(hd.xabs^[n].adr,adrlen+1);
    freemem(hd.xabs^[n].name,realnlen+1);
    hd.xabs^[n].adr:=nil;
    hd.xabs^[n].name:=nil;
  end;

  { my: Elemente in hd.xabs von [1] bis [pos-1] um eine Position }
  {     nach hinten schieben (und damit hd.xabs^[1] freimachen)  }
  procedure ShiftABS(const pos:integer);
  var i : integer;
  begin
    for i:=pos downto 2 do
    begin
      hd.xabs^[i].adr^:=hd.xabs^[i-1].adr^;       { Elemente um 1 aufrcken }
      hd.xabs^[i].name^:=hd.xabs^[i-1].name^;
    end;
  end;

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003      }
  {     (Untersttzung mehrerer Adressen im From:-Header)     }
  {     (Untersttzung langer From:-Header bis 65500 Zeichen) }
  procedure GetFrom;
  begin
    with hd do
    begin
      AppUHdr(BackupId+s1,false);             { Original-RFC-Header sichern }
      if xabs=nil then
        NewABS;
      while (HdrLen>0) and (absanz<maxabs) do
      begin
        oab:=''; oar:='';
        RfcToZcConv(HdrLine,HdrLen,adrlen,realnlen,oab,oar,
                    rest,truncated,overflow,0,'');
        if (oab<>'') or (oar<>'') then
          if CreateABS(absanz+1,oab,oar) then          { HdrLine => hd.xabs }
            inc(absanz)
          else
            exit;                                       { Speicher alle :-( }
      end;
    end;
  end;

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003        }
  {     (Realname wird jetzt nicht mehr weggeworfen)            }
  {     (Untersttzung langer Sender:-Header bis 65500 Zeichen) }
  procedure GetSender;
  begin
    with hd do
    begin
      AppUHdr(BackupId+s1,false);             { Original-RFC-Header sichern }
      oab:=''; oar:='';
      if xsender=nil then                   { nur ersten 'Sender:' beachten }
      begin
        RfcToZcConv(HdrLine,HdrLen,adrlen,realnlen,oab,oar,
                    rest,truncated,overflow,0,'');
        if (oab<>'') then
        begin
          releaseMem(LWab);                 { reservierten Speicher freigeben }
          new(xsender);
          fillchar(xsender^,sizeof(xsender^),0);
          if maxavail>=(length(oab)+1) +
                       (length(oar)+1) then
          begin
            getmem(xsender^.adr,length(oab)+1);
            getmem(xsender^.name,length(oar)+1);
            xsender^.adr^:=oab;
            xsender^.name^:=oar;
          end;
        end;
      end;
    end;
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003             }
  {     (Realname wird jetzt nicht mehr weggeworfen)              }
  {     (Untersttzung langer Reply-To:-Header bis 65500 Zeichen) }
  procedure GetPMReplyTo;
  begin
    with hd do
    begin
      AppUHdr(BackupId+s1,false);             { Original-RFC-Header sichern }
      if xreplyto=nil then
      begin
        releaseMem(LAnt);                 { reservierten Speicher freigeben }
        new(xreplyto);
        fillchar(xreplyto^,sizeof(xreplyto^),0);
        replytoanz:=0;
      end;
      while (HdrLen>0) and (replytoanz<maxreplyto) do
      begin
        oab:=''; oar:='';
        RfcToZcConv(HdrLine,HdrLen,adrlen,realnlen,oab,oar,
                    rest,truncated,overflow,0,'nobody@nowhere');

        if oab<>'' then                            { HdrLine => hd.xreplyto }
          if maxavail>=(length(oab)+1) +
                       (length(oar)+1) then
          begin
            inc(replytoanz);
            getmem(xreplyto^[replytoanz].adr,length(oab)+1);
            getmem(xreplyto^[replytoanz].name,length(oar)+1);
            xreplyto^[replytoanz].adr^:=oab;                     { Adresse  }
            xreplyto^[replytoanz].name^:=oar;                    { Realname }
          end
          else exit;                                    { Speicher alle :-( }
      end;
    end;
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003       }
  {     (Untersttzung langer To:-Header bis 65500 Zeichen) }
  procedure GetEmpf;
  begin
    with hd do
    begin
      if not mail then
        AppUHdr('U-'+s1,false)         { Bei Postings als U-Header sichern! }
      else begin
        AppUHdr(BackupId+s1,false);           { Original-RFC-Header sichern }
        if xempf=nil then
        begin
          releaseMem(LEmp);               { reservierten Speicher freigeben }
          new(xempf);
          fillchar(xempf^,sizeof(xempf^),0);
          empfanz:=0;
        end;
        while (HdrLen>0) and (empfanz<maxemp) do
        begin
          oab:='';
          RfcToZcConv(HdrLine,HdrLen,adrlen,realnlen,oab,drealn,
                      rest,truncated,overflow,0,'');
          if oab<>'' then                             { HdrLine => hd.xempf }
            if maxavail>=length(oab)+1 then
            begin
              inc(empfanz);
              getmem(xempf^[empfanz],length(oab)+1);
              xempf^[empfanz]^:=oab;
            end
            else exit;                                  { Speicher alle :-( }
        end;
      end;
    end;
  end;

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003 }
  procedure GetEnvEmp;
  begin
    AppUHdr('U-'+s1,false);                   { Original-RFC-Header sichern }
    RfcToZcConv(HdrLine,HdrLen,adrlen,realnlen,hd.envemp,drealn,
                rest,truncated,overflow,0,'');
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003       }
  {     (Untersttzung langer Cc:-Header bis 65500 Zeichen) }
  procedure GetKOPs;
  begin
    with hd do
    begin
      AppUHdr(BackupId+s1,false);             { Original-RFC-Header sichern }
      if xkop=nil then
      begin
        releaseMem(LKop);                 { reservierten Speicher freigeben }
        new(xkop);
        fillchar(xkop^,sizeof(xkop^),0);
        kopanz:=0;
      end;
      while (HdrLen>0) and (kopanz<maxkop) do
      begin
        oab:=''; oar:='';
        RfcToZcConv(HdrLine,HdrLen,adrlen,realnlen,oab,oar,
                    rest,truncated,overflow,0,'nobody@nowhere');
        if oab<>'' then                                { HdrLine => hd.xkop }
          if maxavail>=(length(oab)+1) +
                       (length(oar)+1) then
          begin
            inc(kopanz);
            getmem(xkop^[kopanz].adr,length(oab)+1);
            getmem(xkop^[kopanz].name,length(oar)+1);
            xkop^[kopanz].adr^:=oab;                             { Adresse  }
            xkop^[kopanz].name^:=oar;                            { Realname }
          end
          else exit;                                    { Speicher alle :-( }
      end;
    end;
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003              }
  {     (Untersttzung langer Newsgroup:-Header bis 65500 Zeichen) }
  procedure GetNewsgroups;
  begin
    with hd do
    begin
      AppUHdr(BackupId+s1,false);             { Original-RFC-Header sichern }
      if mail then exit;
      if xempf=nil then
      begin
        releaseMem(LEmp);                 { reservierten Speicher freigeben }
        new(xempf);
        fillchar(xempf^,sizeof(xempf^),0);
        empfanz:=0;
      end;
      while (HdrLen>0) and (empfanz<maxemp) do
      begin
        oab:='';
        RfcToZcConv(HdrLine,HdrLen,adrlen,realnlen,oab,drealn,
                    rest,truncated,overflow,1,'');
        if oab<>'' then                               { HdrLine => hd.xempf }
          if maxavail>=length(oab)+1 then
          begin
            inc(empfanz);
            getmem(xempf^[empfanz],length(oab)+1);
            xempf^[empfanz]^:=oab;
          end
          else exit;                                    { Speicher alle :-( }
      end;
    end;
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003                }
  {     (Untersttzung langer Followup-To:-Header bis 65500 Zeichen) }
  procedure GetFollowup;
  var  p : word;
  begin
    with hd do
    begin
      AppUHdr(BackupId+s1,false);             { Original-RFC-Header sichern }
      if mail then exit;
      p:=HdrLen;
      while (p>0) and (HdrLine^[p]<>'@') do dec(p);
      if p>0 then exit;
      if followup=nil then
      begin
        releaseMem(LDis);                 { reservierten Speicher freigeben }
        new(followup);
        fillchar(followup^,sizeof(followup^),0);
        followups:=0;
      end;
      while (HdrLen>0) and (followups<maxfollow) do
      begin
        oab:='';
        RfcToZcConv(HdrLine,HdrLen,adrlen,realnlen,oab,drealn,
                    rest,truncated,overflow,1,'');
        if lstr(oab)='/poster' then
          hd.pm_reply:=true
        else if oab<>'' then                       { HdrLine => hd.followup }
          if maxavail>=length(oab)+1 then
          begin
            inc(followups);
            getmem(followup^[followups],length(oab)+1);
            followup^[followups]^:=oab;
          end
          else exit;                                    { Speicher alle :-( }
      end;
    end;
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003 }
  {     Erste gltige bzw. einzige MsgID holen        }
  function GetMsgID(loop:boolean):string;
  var     p0,p1,p2 : word;
      BruteForceID : string[midlen];
  begin
    { Im Falle, da der Header keine RFC-konforme  }
    { MsgID enthlt, kann er dennoch eine/mehrere  }
    { nicht RFC-konforme MsgIDs enthalten (es      }
    { wurden schon defekte GMX-Header gesichtet    }
    { wie: "In-Reply-To: mid1@fqdn, mid2@fqdn").   }
    { Daher ermitteln wir mit einer Brute-Force-   }
    { Methode zunchst die einzige/letzte MsgID,   }
    { ohne auf Kommentare, Phrasen, WSPs  etc. zu  }
    { prfen. Bei Schleifenaufrufen mu der        }
    { Parameter 'loop' beim ersten Durchlauf mit   }
    { 'false', bei allen weiteren mit 'true'       }
    { bergeben werden, um sicherzustellen, da    }
    { diese Methode nur beim ersten Durchlauf und  }
    { nicht bei Headern angewandt wird, die sowohl }
    { RFC-konforme als auch nicht RFC-konforme     }
    { MsgIDs enthalten!                            }
    BruteForceID:='';
    if not loop then                             { "BruteForceID" ermitteln }
    begin
      p0:=HdrLen;
      while (p0>1) and (HdrLine^[p0]<>'@') do dec(p0); { letztes '@' suchen }
      if (p0>1) and (p0<HdrLen) and
         (HdrLine^[p0]='@') then
      begin
        p1:=p0; p2:=p0;
        while (p1>1) and not
              (HdrLine^[p1-1] in [' ',',',';','<','>']) do dec(p1);
        while (p2<HdrLen) and not
              (HdrLine^[p2+1] in [' ',',',';','<','>']) do inc(p2);
        if (p1<p0) and (p2>p0) then
        begin
          p0:=min((p2-p1)+1,midlen);
          fastmove(HdrLine^[p1],BruteForceID[1],p0);
          BruteForceID[0]:=chr(p0);
        end;
      end;
    end;
    RfcToZcConv(HdrLine,HdrLen,midlen,realnlen,s0,    { "echte" MsgID holen }
                drealn,rest,truncated,overflow,2,'');
    if not loop and (s0='') and (BruteForceID<>'') then
    begin
      HdrLen:=0;                  { nur zur Sicherheit fr Schleifenaufrufe }
      s0:=BruteForceID;
    end;
    GetMsgID:=s0;
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003 }
  function GetControl:string;
  var ts : string[7];
  begin
    s0:=trim(s0);
    ts:=left(s0,7);
    if (lstr(ts)='cancel ') and (length(s0)>7) then
    begin
      GetMsgID(false);                                        { MsgID => s0 }
      if left(s0,7)<>ts then s0:=ts+s0;
    end;
    GetControl:=s0;
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003               }
  {     (Untersttzung langer References:-Header bis 65500 Zeichen) }
  procedure GetReferences;
  var loop : boolean;

     function DupeID:boolean;
     var i : byte;
     begin
       DupeID:=false;
       if s0=hd.ref then
       begin
         DupeID:=true;
         exit;
       end;
       for i:=1 to hd.addrefs do
         if s0=hd.addref[i] then
         begin
           DupeID:=true;
           exit;
         end;
     end;

  begin
    hd.ref:='';
    loop:=false;
    while HdrLen>0 do
    begin
      GetMsgID(loop);                                         { MsgID => s0 }
      loop:=true;
      if s0<>'' then
      begin
        if (hd.ref='') then
          hd.ref:=s0                    { erste (= lteste) MsgID => hd.ref }
        else if not DupeID then begin
          if hd.addrefs<maxrefs then                { die 'maxrefs' letzten }
            inc(hd.addrefs)                         { MsgIDs => hd.addrefs  }
          else 
            FastMove(hd.addref[2],hd.addref[1],
                    (maxrefs-1)*sizeof(hd.addref[1]));
          hd.addref[hd.addrefs]:=s0;
        end;
      end;
    end;
  end;

  { --------------------------------------------------------------- }
  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003               }
  {     (Untersttzung langer In-Reply-To:-Header bis 65500 Zeichen }
  {      und Workaround fr DUUCP-Bug)                              }
  { --------------------------------------------------------------- }
  {                                                                 }
  {     Wir bercksichtigen bei mehreren MsgIDs jetzt die *letzte*  }
  {     MsgID, weil die am hufigsten benutzte ZC<=>RFC-Gatesoft    }
  {     "DUUCP" mehrere BEZ:-Header nicht, wie es korrekt wre,     }
  {     nach "References:", sondern in eine komma-separierte Liste  }
  {     nach "In-Reply-To:" bernimmt.                              }
  {     Dadurch wird das Problem verursacht, da bei einem Reply    }
  {     auf eine Mail in einem AM-Brett mit eingetragenem           }
  {     PM-Vertreter - hufige Konstellation bei Mailinglisten -    }
  {     bisher eine falsche Bezugsverkettung beim Empfnger des     }
  {     Replies hergestellt wird.                                   }
  {                                                                 }
  {     Hinsichtlich der RFC-Konformitt ist dies unproblematisch,  }
  {     weil alle MsgIDs in einem "In-Reply-To:"-Header direkte     }
  {     Bezge sind; da gem ZC-Draft mehrere direkte Bezge aber  }
  {     nicht untersttzt werden, kann ohnehin nur eine der MsgIDs  }
  {     im "In-Reply-To:"-Header bercksichtigt werden, und da ist  }
  {     die letzte genauso falsch oder richtig wie die erste.       }
  {                                                                 }
  { --------------------------------------------------------------- }
  procedure GetInReplyTo;
  var loop : boolean;
  begin
    loop:=false;
    while HdrLen>0 do
    begin
      GetMsgID(loop);                                         { MsgID => s0 }
      loop:=true;
      if s0<>'' then
        InReplyTo:=s0;
    end;
  end;

  { Mail - Pfad aus Received-Headern bilden ("Received: by ... from") }
  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003        }
  {     (Untersttzung langer ROT:-Header bis 65500 Zeichen) }
  procedure GetReceived;
  var by,from : string;
            l : integer;

    function GetRec(key:string):string;
    var p : byte;
    begin
      p:=pos(key,lstr(s0));
      if p>0 then begin
        key:=trim(mid(s0,p+length(key)));
        p:=blankpos(key);
        if p>0 then key[0]:=chr(p-1);
        if key[length(key)]=';' then dellast(key);
        GetRec:=key;
        end
      else
        GetRec:='';
    end;

    procedure AppShortPath;
    begin
      if (by<>'') and (lstr(by)<>lstr(right(hd.pfad,length(by)))) then
      begin
        if hd.pfad<>'' then hd.pfad:=hd.pfad+'!';
        hd.pfad:=hd.pfad+by;
      end;
      if from<>'' then
      begin
        if hd.pfad<>'' then hd.pfad:=hd.pfad+'!';
        hd.pfad:=hd.pfad+from;
      end;
    end;

    procedure AppLongPath;
    var i1,i2 : word;
           ok : boolean;

      procedure AppRecString(r:string);
      begin
        LongHdr[LPath].hdr^[LongHdr[LPath].len+1]:='!';
        fastmove(r[1],LongHdr[LPath].hdr^[LongHdr[LPath].len+2],length(r));
        inc(LongHdr[LPath].len,length(r)+1);
      end;

    begin
      if by<>'' then
      begin
        i1:=LongHdr[LPath].len;
        i2:=length(by);
        ok:=false;
        while not ok and (i1>0) and (i2>0) do
        begin
          ok:=LoCase(by[i2])<>LoCase(LongHdr[LPath].hdr^[i1]);
          dec(i1);
          dec(i2);
        end;
        if ok then AppRecString(by);
      end;
      if from<>'' then AppRecString(from);
    end;

  begin
    AppUHdr('U-'+s1,false);                   { Original-RFC-Header sichern }
    { "(qmail id xxx invoked from network)" enthlt "from " }
    RfcToZcConv(HdrLine,HdrLen,sizeof(s0)-1,realnlen,   { Kommentare/Quoting  }
                s0,drealn,rest,truncated,overflow,3,'');{ in Header entfernen }
    by:=GetRec('by ');
    from:=GetRec('from ');
    { Envelope-Empfnger ermitteln }
    if getrecenvemp and (hd.envemp='') then hd.envemp:=GetRec('for ');
    if DonePath then exit;
    if (LongHdr[LPath].hdr=nil) and ((by<>'') or (from<>'')) then
    begin
      l:=length(hd.pfad)+                                { Pfad + by + from }
         iif(by<>'',iif(hd.pfad<>'',length(by)+1,length(by)),0)+
         iif(from<>'',iif((hd.pfad<>'') or (by<>''),length(from)+1,
             length(from)),0);
      if l>min(sizeof(hd.pfad)-1,253) then            { langen Pfad anlegen }
      begin
        if maxavail>=l then
        begin
          getmem(LongHdr[LPath].hdr,l);
          fastmove(hd.pfad[1],LongHdr[LPath].hdr^[1],
                   length(hd.pfad));
          LongHdr[LPath].len:=length(hd.pfad);
          AppLongPath;                                 { by + from anhngen }
        end
        else DonePath:=true;      { nicht gengend Speicher fr langen Pfad }
        AppShortPath;                                  { by + from anhngen }
        hd.pfad:=left(hd.pfad,248)+truncater;         { hd.pfad formatieren }
      end
      else AppShortPath;                               { by + from anhngen }
    end
    else if (by<>'') or (from<>'') then        { LongPath existiert bereits }
    begin
      l:=LongHdr[LPath].len+iif(by<>'',length(by)+1,0)+  { Pfad + by + from }
                            iif(from<>'',length(from)+1,0);
      if (l<=sizeof(LongHdr[LPath].hdr^)) then                    { append: }
      begin
        fastmove(LongHdr[LPath].hdr^[1],HdrLine^[1],     { LongPath sichern }
                 LongHdr[LPath].len);
        freemem(LongHdr[LPath].hdr,LongHdr[LPath].len); { alten Pfad freig. }
        if maxavail>=l then
        begin
          getmem(LongHdr[LPath].hdr,l);                { neuen Pfad anlegen }
          fastmove(HdrLine^[1],LongHdr[LPath].hdr^[1],
                   LongHdr[LPath].len);
          AppLongPath;                                 { by + from anhngen }
        end
        else begin                 { nicht gengend Speicher fr neuen Pfad }
          getmem(LongHdr[LPath].hdr,LongHdr[LPath].len);  { *mu* frei sein }
          fastmove(HdrLine^[1],LongHdr[LPath].hdr^[1],     { zurckkopieren }
                   LongHdr[LPath].len);
          DonePath:=true;
          LongHdr[LPath].rest:='';
          LongHdr[LPath].trunc:=true;
        end;
      end
      else begin                                     { Arraygrenze erreicht }
        DonePath:=true;
        LongHdr[LPath].rest:='';
        LongHdr[LPath].trunc:=true;
      end;
    end;
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003                 }
  {     (Untersttzung langer Delivered-To:-Header bis 65500 Zeichen) }
  procedure GetDeliveredTo;
  begin
    AppUHdr('U-'+s1,false);                   { Original-RFC-Header sichern }
    if not UseEnvTo or delivToAlias then exit;
    hd.oab:='';
    RfcToZcConv(HdrLine,HdrLen,adrlen,realnlen,hd.oab,drealn,
                rest,truncated,overflow,0,'');
    if hd.oab<>'' then
    begin
      inc(delivToCount);
      if (lstr(left(hd.oab,6))='alias-') then      { Ersten Alias-Header    }
      begin                                        { immer bercksichtigen! }
        delivToAlias:=true;
        delivToEmpf:=mid(hd.oab,7);
      end
      else if (delivToCount<3) then { ansonsten zweiten Delivered-To nehmen }
        delivToEmpf:=hd.oab;
    end;
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003 }
  procedure GetDate;
  begin
    RfcToZcConv(HdrLine,HdrLen,sizeof(s0)-1,realnlen,   { Kommentare/Quoting  }
                s0,drealn,rest,truncated,overflow,3,'');{ in Header entfernen }
    hd.zdatum:=RFC2Zdate(s0);
    ZCtoZdatum(hd.zdatum,hd.datum);
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003 }
  procedure GetMime(p:mimeproc);
  begin
    AppUHdr('U-'+s1,structured=0);            { Original-RFC-Header sichern }
    RfcToZcConv(HdrLine,HdrLen,sizeof(s0)-1,realnlen,   { *nur* Kommentare in }
                s0,drealn,rest,truncated,overflow,4,'');{ Header entfernen!   }
    p(s0);
  end;

  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003 }
  procedure GetPriority;  { robo: (X)-Priority konvertieren }
  var p : integer;
  begin
    if hd.priority = 0 then   { nur ersten (X)-Priority Header beachten }
    begin  
      RfcToZcConv(HdrLine,HdrLen,sizeof(s0)-1,realnlen,   { Kommentare/Quoting  }
                  s0,drealn,rest,truncated,overflow,3,'');{ in Header entfernen }
      p := 1;
      { nur Zahl am Anfang beachten: }
      while (s0 [p] in ['0'..'9']) and (p <= length (s0)) do inc (p);
      if p = 1 then begin
        { keine Zahl: auf urgent/high, normal, low/non-urgent prfen }
        s0 := lstr (left (s0, 3));
        { laufzeitoptimierte Abfrage: das Wahrscheinlichste zuerst }
        if s0 = 'nor' then hd.priority := 3
        else if (s0 = 'hig') or (s0 = 'urg') then hd.priority := 1
        else if (s0 = 'low') or (s0 = 'non') then hd.priority := 5;
      end
      else begin
        { Zahl 1:1 konvertieren und auf 1..5 begrenzen }
        s0 := left (s0, p - 1);
        hd.priority := minmax (ival (s0), 1, 5);
      end;
    end;
  end;

  procedure LoZZ; assembler; {&uses esi }     { LoString(zz);  -  zz<>'' }
  asm
       cld
       mov   si,offset zz
       lodsb
       mov   cl,al
       mov   ch,0
  @@1: lodsb
       cmp   al,'A'
       jb    @@2
       cmp   al,'Z'
       ja    @@2
       add   byte ptr [si-1],32
  @@2: loop  @@1
  end;

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003   }
  {     (Ablegen langer unstrukturierter String-Header bis }
  {      65500 Zeichen im Array 'LongHdr')                 }
  procedure GetLongHdr(const LongHdrPos,maxLen:byte; var shortHdr:string;
                       const MIMEdecode:boolean);
  var ml : byte;
  begin
    ml:=min(maxLen,253);                        { auf 253 Zeichen begrenzen }
    if MIMEdecode then
      s0:=GetHeader(HdrLine,HdrLen,rest,truncated,       { MIME-Decodierung }
                    overflow,true,false,structured);
    if length(s0)>ml then
    begin
      shortHdr:=left(s0,ml-5)+truncater;        { s0 formatieren (Backdoor) }
      SaveLongHdr(LongHdrPos);                        { Header => 'LongHdr' }
    end
    else shortHdr:=s0;
  end;

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003       }
  {     Untersttzung langer Subject:-Header bis 65500 Zeichen }
  {     Original-RFC-Header sichern, wenn er MIME-codiert war  }
  procedure GetBetreff;
  var subjBak : LongHdrP;
      subjLen : word;
  begin
    subjBak:=nil;
    if maxavail>=HdrLen then                    { temporres Backup anlegen }
    begin
      subjLen:=HdrLen;
      getmem(subjBak,subjLen);
      fastmove(HdrLine^,subjBak^,subjLen);
    end;
    GetLongHdr(LSub,BetreffLen,hd.betreff,true);
    if subjBak<>nil then
    begin
      if subjLen>HdrLen then                      { Subject wurde verndert }
      begin
        fastmove(subjBak^,HdrLine^,subjLen);
        HdrLen:=subjLen;
        freemem(subjBak,subjLen);
        subjBak:=nil;
        AppUHdr(BackupId+s1,false);
      end
      else begin                            { Subject wurde nicht verndert }
        freemem(subjBak,subjLen);
        subjBak:=nil;
      end;
    end;
  end;

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003        }
  {     (Untersttzung langer MAILER:-Header bis 65500 Zeichen) }
  procedure GetProgramm(const is_xp:boolean);
  begin
    if not DoneProg then
    begin
      DoneProg:=is_xp;
      GetLongHdr(LProg,sizeof(hd.programm)-1,hd.programm,true);
    end;
  end;

  { read a string variable and remove comments        }
  { my: Anpassung im Zuge des Rewrite 08/2002-04/2003 }
  procedure GetVar(var r0,s0:string);
  begin
    RFC2822_Remove(s0,true);
    r0:=s0;
  end;

  { my: Neue Routine im Zuge des Rewrite 08/2002-04/2003 }
  {     (Gelesenen String ins Header-Array kopieren)     }
  procedure MoveString;
  begin
    fastmove(s[1],HdrLine^[HdrLen+1],min(length(s),sizeof(HdrLine^)-HdrLen));
    if not overflow then 
      overflow:=(sizeof(HdrLine^)-HdrLen)<(length(s));
    if overflow and not chkd_trunc then
    begin
      rest:=copy(s,sizeof(HdrLine^)-HdrLen,sizeof(rest)-1);
      truncated:=not (((length(rest)=3) and (mid(rest,2)='?=')) or
                      ((length(rest)=2) and (rest='?=')));
      chkd_trunc:=true;
      rest:=mid(rest,2);
    end;
    inc(HdrLen,min(length(s),sizeof(HdrLine^)-HdrLen));
  end;

begin   { of ReadRFCheader }
  delivToEmpf:='';
  delivToCount:=0;
  delivToAlias:=false;
  hd.mime.ctype:=tText;   { Default: Text }
  HdrLen:=0;
  overflow:=false;
  truncated:=false;
  rest:='';
  chkd_trunc:=false;
  DonePath:=false;
  DoneProg:=false;
  hd.xabs:=nil;
  hd.xsender:=nil;
  hd.xempf:=nil;
  hd.xoem:=nil; 
  hd.xkop:=nil; 
  hd.xreplyto:=nil;
  hd.followup:=nil;
  InReplyTo:='';
  Ustart:=nil;
  if mails+news>1 then                { ab 2. Nachricht erneut Speicher fr }
  begin                               { dynamische ZC-Header reservieren    }
    allocMem;                         { und Array 'LongHdr' zurcksetzen    }
    for i:=1 to LongHdrAnz do
    begin
      LongHdr[i].hdr:=nil;
      LongHdr[i].len:=0;
      LongHdr[i].rest:='';
      LongHdr[i].trunc:=false;
    end;
  end;
  new(HdrLine);
  { ----------------------------------------------------------------------- }
  repeat
    if HdrLen=0 then                                  { Beginn neuer Header }
    begin
      p:=cpos(':',s0);
      if p>1 then begin
        zz:=rtrim(left(s0,p-1));                               { Identifier }
        s0:=mid(s0,p+1);
      end;
   (* fillchar(HdrLine^,sizeof(HdrLine^),0); *)   { jm: Performance-Killer! }
      s0:=ltrim(s0);
      if s0<>'' then          { Kann '' werden, wenn 'readstring' keinen    }
      begin                   { Trenner hinter dem Identifier finden konnte }
        fastmove(s0[1],HdrLine^[1],length(s0));
        inc(HdrLen, length(s0));
      end;
    end;

    while eol=0 do                              { lange Zeile > 253 Zeichen }
    begin
      ReadString(true);
      if not overflow then MoveString;
    end;

    ReadString(true);

    if (s<>'') and ((s[1]=' ') or (s[1]=#9)) then         { gefoldete Zeile }
    begin
      if s0='' then                              { wenn Folding unmittelbar }
      begin                                      { hinter Identifier:       }
        s:=ltrim(s);                             { 's' links trimmen und    }
        if (s='') and (eol=0) then               { auf Trenner prfen (kein }
          ReadString(true);                      { Trenner gefunden wenn    }
      end;                                       { s='' und eol=0)          }
      s0:=s;
      if not overflow then MoveString;
    end
    { --------------------------------------------------------------------- }
    else with hd do
    begin

      { Die folgenden Header betrachten wir als strukturierte Header und }
      { ersetzen gem RFC2822 via 'GetHeader' mehrfache Leerzeichen     }
      { auerhalb von Kommentaren und quoted-strings durch eines (der    }
      { umgekehrte Weg, nur bei unstrukturierten Headern mehrfache Leer- }
      { zeichen nicht zu ersetzen, geht deshalb nicht, weil optionale    }
      { Header als unstrukturiert anzusehen und daher nicht eindeutig    }
      { definiert sind.                                                  }

      s1:=zz;
      lozz;

      structured:=
        minmax(
                 {*}                       { von UUZ interpretierte Header: }
        pos(';'+zz+';',';cc;content-type;content-transfer-encoding;control;'
                     + 'date;delivered-to;disposition-notification-to;'
                     + 'distribution;envelope-to;from;followup-to;') +
        pos(';'+zz+';',';in-reply-to;keywords;message-id;newsgroups;path;'
                     + 'references;received;reply-to;return-receipt-to;'
                     + 'sender;supersedes;to;x-envelope-to;') +
                 {*} { trace fields (RFC2822), von UUZ nicht interpretiert: }
        pos(';'+zz+';',';resent-date;resent-from;resent-sender;resent-to;'
                     + 'resent-cc;resent-bcc;resent-message-id;return-path;'
                     + 'resent-reply-to;delivery-date;') +
                 {*}    { seltene News-Header, von UUZ nicht interpretiert: }
        pos(';'+zz+';',';also-control;approved;article-names;article-updates;'
                     + 'expires;see-also;x-complaints-to;x-trace;xref;') +
                 {*}                   { einige weitere Header aus RFC2076: }
        pos(';'+zz+';',';disclose-recipients;content-disposition;for-comment;'
                     + 'for-handling;apparently-to;errors-to;content-id;'
                     + 'obsoletes;expiry-date;reply-by;')
               ,0,1);

      s0:=GetHeader(HdrLine,HdrLen,rest,truncated,   { TABs und Multi-WSPs   }
                    overflow,false,true,structured); { ersetzen, Hdr => 's0' }

      if p>1 then begin
        case zz[1] of
        'c': if zz='cc'           then GetKOPs else
             if zz='content-type' then getmime(GetContentType) else
             if zz='content-transfer-encoding' then getmime(GetCTencoding) else
             if zz='control'      then control:=GetControl
             else AppUHdr('U-'+s1,structured=0);
        'd': if zz='date'         then GetDate {argl!} else
             if zz='delivered-to' then GetDeliveredTo else
             if zz='disposition-notification-to' then
                      RfcToZcConv(HdrLine,HdrLen,adrlen,realnlen,EmpfBestTo,
                                  drealn,rest,truncated,overflow,0,'') else
             if zz='distribution' then
             begin
               RfcToZcConv(HdrLine,HdrLen,sizeof(s0)-1,realnlen,   { Kommentare }
                           s0,drealn,rest,truncated,overflow,4,'');{ entfernen  }
               AppUHdr('U-'+s1,false);
             end
             else AppUHdr('U-'+s1,structured=0);
        'm': if zz='message-id'   then msgid:=GetMsgID(false) else
             if zz='mime-version' then getmime(GetMimeVersion) else
             if zz='mailer' {RFC2076} then GetProgramm(false) else
             if zz='mail-system-version' {RFC2076} then GetProgramm(false)
             else AppUHdr('U-'+s1,structured=0);
        'o': if zz='organization' then GetLongHdr(LOrg,OrgLen,organisation,true) else
             if zz='organisation' then GetLongHdr(LOrg,OrgLen,organisation,true) else
             if zz='originating-client' {RFC2076} then GetProgramm(false) else
             if zz='obsoletes'    then ersetzt:=GetMsgID(false)
             else AppUHdr('U-'+s1,structured=0);
        'r': if zz='references'   then GetReferences else
             if zz='received'     then GetReceived else
             if zz='reply-to'     then GetPMReplyTo else
             if zz='return-receipt-to' then
                      RfcToZcConv(HdrLine,HdrLen,adrlen,realnlen,EmpfBestTo,
                                  drealn,rest,truncated,overflow,0,'')
             else AppUHdr('U-'+s1,structured=0);
        's': if zz='subject'      then GetBetreff else
             if zz='sender'       then GetSender else
             if zz='supersedes'   then ersetzt:=GetMsgID(false) else
             if zz='summary'      then GetLongHdr(LSum,sizeof(summary)-1,summary,true)
             else AppUHdr('U-'+s1,structured=0);
        'x': if zz='x-comment-to' then fido_to:=s0 else
             if zz='x-gateway'    then
                  GetLongHdr(LGate,sizeof(gateway)-1,gateway,true) else
             if zz='x-mailer'     then GetProgramm(false) else
             if zz='x-newsreader' then GetProgramm(false) else
             if zz='x-news-reader'then GetProgramm(false) else
             if zz='x-reader'     then GetProgramm(false) else  { my: Mozilla! }
             if zz='x-software'   then GetProgramm(false) else
             if zz='x-xp-version' then GetProgramm(true) else
             if zz='x-z-post'     then
                  GetLongHdr(LPost,PostAdrLen,postanschrift,true) else
             if zz='x-zc-post'    then
                  GetLongHdr(LPost,PostAdrLen,postanschrift,true) else
             if zz='x-z-telefon'  then
                  GetLongHdr(LTele,TeleLen,telefon,true) else
             if zz='x-zc-telefon' then
                  GetLongHdr(LTele,TeleLen,telefon,true) else
             if zz='x-xp-ctl'     then XPointCtl:=ival(s0) else

             { X-No-Archive Konvertierung }
             if zz='x-no-archive' then
             begin          { Kommentare/Quoting entfernen }
               RfcToZcConv(HdrLine,HdrLen,sizeof(s0)-1,realnlen,
                           s0,drealn,rest,truncated,overflow,3,'');
               if lstr(s0)='yes' then xnoarchive:=true;
               AppUHdr('U-'+s1,false);   { hier 'AppUHdr' ausnahmsweise     }
             end else                    { erst zum Schlu, weil der Wert   }
                                         { in XPMAKEHD.INC ausgewertet wird }
             if zz='x-priority'   then GetPriority else
             if zz='x-xp-mode'    then xpmode:=s0 else
             if zz='x-homepage'   then
                  GetLongHdr(LHome,homepagelen,homepage,true) else
             if zz='x-envelope-to' then GetEnvEmp else
             if (left(zz,4)<>'x-xp') then AppUHdr(s1,structured=0);
        else if zz='from'         then GetFrom else
             if zz='to'           then GetEmpf else
             if zz='newsgroups'   then GetNewsgroups else
             if zz='path'         then
                      GetLongHdr(LPath,sizeof(pfad)-1,pfad,true) else
             if zz='keywords'     then
                      GetLongHdr(LKey,sizeof(keywords)-1,keywords,false) else
             if zz='in-reply-to'  then GetInReplyTo else
             if zz='followup-to'  then getFollowup else
             if zz='newsreader'   then GetProgramm(false) else
             { User-Agent is new in grandson-of-1036 }
             if zz='user-agent'   then GetProgramm(false) else
             if zz='encrypted'    then pgpflags:=iif(ustr(s0)='PGP',fPGP_encoded,0) else
             if zz='priority'     then GetPriority else
             if zz='importance'   then GetPriority else
             if zz='envelope-to'  then GetEnvEmp else
             if zz<>'lines'       then AppUHdr('U-'+s1,structured=0);
        end; { case }
      end;
      s0:=s;
      HdrLen:=0;
      overflow:=false;
      truncated:=false;
      chkd_trunc:=false;
      rest:='';
    end;
  until ((s0='') and lasteol) or (bufpos>=bufanz);
  { ----------------------------------------------------------------------- }
  with hd do
  begin

    { ---------------------- kein From:-Header vorhanden => hd.xabs anlegen }
    if xabs=nil then
      NewABS
    { ----------------------------------------- From:-Header war vorhanden: }
    else if xabs^[1].adr<>nil then
    begin
      i:=0;
      while i<absanz do                                     { Dupes filtern }
      begin
        inc(i);
        while (i<absanz) and                        { gefilterte und leere  }
              ((xabs^[i].adr=nil) or                { Adressen berspringen }
               ((xabs^[i].adr<>nil) and
                (xabs^[i].adr^=''))) do
          inc(i);
        if xabs^[i].adr=nil then break;          { letzte existente Adresse }
        if (absanz>1) and (i<absanz) then for p:=i+1 to absanz do
        begin
          while (p<absanz) and                      { gefilterte und leere  }
                ((xabs^[p].adr=nil) or              { Adressen berspringen }
                 ((xabs^[p].adr<>nil) and
                  (xabs^[p].adr^=''))) do
            inc(p);
          if xabs^[p].adr=nil then break;        { letzte existente Adresse }
          if (lstr(xabs^[i].adr^)=lstr(xabs^[p].adr^)) then     { Dupe      }
            RemoveABS(p);                                       { entfernen }
        end;
      end;
      { -------------------------------- evtl. entstandene Lcken schlieen }
      i:=0;
      if absanz>1 then while i<absanz-1 do
      begin
        inc(i);
        while xabs^[i].adr<>nil do inc(i);             { erste Lcke suchen }
        if i<absanz then
          p:=i+1
        else break;                                 { keine Lcke vorhanden }
        while (p<absanz) and (xabs^[p].adr=nil) do    { nchsten ABS suchen }
          inc(p);
        if xabs^[p].adr=nil then break;       { kein nchster ABS vorhanden }
        absender:=xabs^[p].adr^;                  { Adresse  zwischenlagern }
        realname:=xabs^[p].name^;                 { Realname zwischenlagern }
        RemoveABS(p);                          { ABS hinter Lcke entfernen }
        if CreateABS(i,absender,realname) then    { ABS nach Lcke kopieren }
        begin
          absender:='';
          realname:='';
        end;
        if p=absanz then break;      { dann kann keine Lcke mehr kommen... }
      end;
    end;

    i:=0;
    while (i<absanz) and (xabs^[i+1].adr<>nil) do       { Aktuelle 'absanz' }
    begin                                               { ermitteln         }
      inc(i);
      if (i>1) and (xabs^[1].adr^='') and       { evtl. aktuell gltige     }
         (cpos('@',xabs^[i].adr^)>0) then       { Adresse => leere xabs^[1] }
      begin                      
        absender:=xabs^[i].adr^;                  { Adresse  zwischenlagern }
        realname:=xabs^[i].name^;                 { Realname zwischenlagern }
        ShiftABS(i);                         { Elemente nach hinten shiften }
        xabs^[1].adr^:=absender;
        xabs^[1].name^:=realname;
      end;
    end;
    absanz:=i;

    if (absanz=0) then                  { Kommt vor, wenn From:-Header      }
      if CreateABS(1,'','') then        { nicht vorhanden war oder nur      }
        inc(absanz);                    { leere Adressen/Realnames enthielt }

    { -------------------------------------------- Ende Analyse ABS:-Header }

    { Wenn hier 'xabs^[1].adr' immer noch leer ist, dann  }
    { sind auch die Adressen in allen folgenden Elementen }
    { leer bzw. es sind gar keine weiteren Elemente im    }
    { Array mehr vorhanden.                               }
    { Wenn 'xabs^[1]' das einzige Element und die Adresse }
    { leer ist, dann *kann* 'xabs^[1].name' dennoch einen }
    { Inhalt haben. Wenn mehr als ein Element vorhanden   }
    { und die Adresse in 'xabs^[1].adr' leer ist, dann    }
    { *mu* der Name in *allen* Elementen einen Inhalt    }
    { haben (sonst wrden die Elemente nicht existieren). }

    if (xsender<>nil) then             { WAB: setzen, Sender: hat Prioritt }
    begin
      if (cpos('@',xsender^.adr^)>0) then
      begin
        wab:=xsender^.adr^;
        war:=xsender^.name^;
      end;
      freemem(xsender^.adr,length(xsender^.adr^)+1);
      freemem(xsender^.name,length(xsender^.name^)+1);
      xsender^.adr:=nil;
      xsender^.name:=nil;
      dispose(xsender);
    end;

  (*
    { my: Schreiben des WAB nach ABS: bei leerem ABS:  }
    {     vorerst auskommentiert, Verhalten umstritten }

    if (xabs^[1].adr^='') and           { kein gltiger Absender vorhanden: }
       (wab<>'') then 
    begin
      if (xabs^[1].name^<>'') and (absanz<maxabs) then
        if (CreateABS(absanz+1,'','')) then
        begin
          inc(absanz);
          ShiftABS(absanz);                  { Elemente nach hinten shiften }
        end;
      xabs^[1].adr^:=wab;                                 { WAB => xabs^[1] }
      xabs^[1].name^:=war;
      wab:='';
      war:='';
    end;
  *)

    for i:=1 to absanz do if xabs^[i].adr^='' then       { alle leeren ABS: }
      xabs^[i].adr^:='unknown@sender';                   { fllen           }

    i:=0;                                    { Dupecheck WAB: <=> alle ABS: }
    while (i<absanz) and (wab<>'') do
    begin
      inc(i);
      if lstr(wab)=lstr(xabs^[i].adr^) then  { Wenn WAB: in ABS: vorhanden, }
      begin                                  { aktuelle Adresse => xabs^[1] }
        wab:='';
        if i>1 then
        begin
          absender:=xabs^[i].adr^;                { Adresse  zwischenlagern }
          realname:=xabs^[i].name^;               { Realname zwischenlagern }
          ShiftABS(i);                       { Elemente nach hinten shiften }
          xabs^[1].adr^:=absender;
          xabs^[1].name^:=realname;
        end;
      end;
    end;

    if (cpos('@',envemp)=0) and (cpos('@',delivToEmpf)>0) then
    begin
      envemp:=delivToEmpf;
      DelivToEnv:=true;
    end;

    if (empfanz=1) and (followups=1) and (xempf^[1]^=followup^[1]^) then
      followups:=0;
    MimeAuswerten;
  end;
  if HdrLine<>nil then
    dispose(HdrLine);
end;   { of ReadRFCheader }


function SetMailUser(mailuser:string):string;
begin
  if (OwnSite='') or (mailuser='') then
    if cpos('@',mailuser)=0 then
      SetMailUser:=''
    else
      SetMailUser:=mailuser
  else
    if cpos('@',mailuser)=0 then
      if cpos('!',mailuser)=0 then
        SetMailUser:=mailuser+'@'+OwnSite
      else
        SetMailUser:=mid(mailuser,rightpos('!',mailuser)+1)+'@'+OwnSite
    else
      SetMailUser:=left(mailuser,cpos('@',mailuser))+OwnSite;
end;


{ Envelope-Empfnger prfen, ggf. EMP: => OEM: }

procedure CheckEnvEmp(const s:string);
var        i : integer;
    EnvInEMP : boolean;
begin
  EnvInEMP:=false;
  if s<>'' then
  begin
    for i:=1 to hd.empfanz do                 { Envelope-Empf. in hd.xempf? }
    begin
      EnvInEMP:=s=hd.xempf^[i]^;
      if EnvInEMP then break;
    end;
    if not EnvInEMP then
    begin
      releaseMem(LOem);      { res. Speicher fr Envelope-Empf. (xempf^[1]) }
      if maxavail>=length(s)+1 +
                   (((sizeof(hd.xempf^) div 8)*8)+8) then
      begin
        hd.xoem:=hd.xempf;                   { Envelope-Empfnger einsetzen }
        hd.oemanz:=hd.empfanz;
        new(hd.xempf);
        fillchar(hd.xempf^,sizeof(hd.xempf^),0);
        getmem(hd.xempf^[1],length(s)+1);
        hd.xempf^[1]^:=s;
        hd.empfanz:=1;
      end;
    end;
  end;
end;


{ UUCP-Mail -> ZCONNECT }

procedure ConvertMailfile(fn:pathstr; mailuser:string);
var   p,p2 : byte;
        p3 : byte;
         i : integer;
     fp,bp : longint;
         c : char;
    binaer : boolean;
begin
  write('mail: ',fn);
  inc(mails);
  OpenFile(fn);
{  ok:=true; }
  fillchar(hd,sizeof(hd),0);
  if client then
    hd.netztyp:=nt_Client
  else
    hd.netztyp:=nt_RFC;
  repeat             { Envelope einlesen }
    ReadString(true);
    p:=cpos(' ',s);
    if p=0 then p:=cpos(#9,s);
    if (p<=1) then p:=length(s)+1;
    c:=s[1];
    for i:=1 to p-1 do
      s[i]:=LoCase(s[i]);
    if s[p-1]<>':' then begin
      if (left(s,p-1)='from') or (left(s,p-1)='>from') then begin
        s:=trim(mid(s,p));                           { Envelope-Absender }
        p:=cpos(' ',s);
        if p>0 then begin
          hd.wab:=left(s,p-1);
          delete(s,1,p);
          p:=cpos('!',hd.wab);
          if cpos('!',hd.wab)>0 then begin
            p2:=length(hd.wab);
            while hd.wab[p2]<>'!' do dec(p2);   { rechtes "!" suchen }
            p:=p2-1;
            while (p>0) and (hd.wab[p]<>'!') do dec(p);   { nchstes "!" suchen }
            p3:=cpos('@',mid(hd.wab,p2+1));
            if p3>0 then
              if stricmp(copy(hd.wab,p2+1,p3-1)+'@'+copy(hd.wab,p+1,p2-p-1),
                         hd.absender) then
                hd.wab:=''
              else
                hd.wab:=copy(hd.wab,p2+1,p3-1)+'%'+copy(hd.wab,p+1,p2-p-1)+
                       mid(hd.wab,p2+p3)
            else
              hd.wab:=mid(hd.wab,p2+1)+'@'+copy(hd.wab,p+1,p2-p-1);
            end
          else if cpos('@',hd.wab)=0 then begin
            p:=pos('remote from',s);
            if p>0 then hd.wab:=hd.wab+'@'+mid(s,p+12)
            else hd.wab:='';   { war wohl nix }
            end;
          end;
        end;
      p:=0;
      end;
    if (eol=0) and ((p=0) or (s[p-1]<>':')) then
      ReadString(false);
  until ((p>0) and (s[p-1]=':')) or (bufpos=bufanz);
  if bufpos<bufanz then
  begin
    writeln(' from ',hd.wab);
    s[1]:=c;
    ReadRFCheader(true,s);
    (* no decoding for MIME multipart messages *)
    binaer:=(hd.typ='B');
    mpart:=(hd.typ='M') or (hd.mime.ctype=tMultipart);

    if UseEnvTo and (mailuser='') and (hd.envemp<>'') then
      mailuser:=SetMailuser(hd.envemp);

    if mailuser<>'' then CheckEnvEmp(mailuser);

    fp:=fpos; bp:=bufpos;
    hd.groesse:=0;
    while bufpos<bufanz do
    begin
      ReadString(true);
      UnQuotePrintable(s,qprint,b64,eol>0);
      if not binaer then Charset2IBM;
      inc(hd.groesse,length(s));
    end;
    seek(f1,fp); ReadBuf; bufpos:=bp;
    WriteHeader;
  end
  else writeln;
  while bufpos<bufanz do
  begin
    ReadString(true);
    UnQuotePrintable(s,qprint,b64,eol>0);
    if not binaer then Charset2IBM;
    wrfs(s);
  end;
  close(f1);
  setfattr(f1,0);   { Archivbit abschalten }
end;


{ SMTP-Mail -> ZCONNECT }

procedure ConvertSmtpFile(fn:pathstr; compressed:boolean);
var        f : file;
     fp,bp,n : longint;
          rr : word;
       p1,p2 : byte;
       mempf : string[AdrLen];
       ende,
     binaer,
     nofrom,
    smtpende : boolean;

  function GetAdr:string;
  var p : byte;
  begin
    p:=cpos('<',s);
    if p=0 then GetAdr:=''
    else begin
      if lastchar(s)='>' then dellast(s);
      GetAdr:=copy(s,p+1,length(s)-p);
    end;
  end;

begin
  n:=0;
  write('mail: ',fn);
  if compressed then begin
    assign(f,fn);
    reset(f,1);
    setlength(s, 4);
    blockread(f,s[1],4,rr);
    close(f);
    if (left(s,2)=#$1f#$9d) or (left(s,2)=#$1f#$9f) or
       (left(s,2)=#$1f#$8b) then begin
      rename(f,fn+'.Z');
      case s[2] of
        #$9d : begin
                 write(' - uncompressing SMTP mail...');
                 shell(uncompress+fn,500);
               end;
        #$9f : begin
                 write(' - unfreezing SMTP mail...');
                 shell(unfreeze+fn,500);
               end;
        #$8b : begin
                 write(' - unzipping SMTP mail...');
                 shell(ungzip+fn,500);
               end;
      end;
      end;
    end;
  write(sp(7));
  OpenFile(fn);
  repeat
    fillchar(hd,sizeof(hd),0);
    if client then
      hd.netztyp:=nt_Client
    else
      hd.netztyp:=nt_RFC;
    ende:=false;
    repeat
      ReadString(false);
      if ustr(left(s,9))='MAIL FROM' then hd.wab:=GetAdr else  { Envelope-From }
      if ustr(left(s,7))='RCPT TO'   then
        hd.empfaenger:=GetAdr;   { Envelope-To }
      ende:=(bufpos>=bufanz) {or (s='QUIT')};
    until ende or (s='DATA') or (s='QUIT');
    if s='DATA' then begin
      with hd do
        if wab<>'' then begin
          p1:=cpos('@',wab);
          if p1=0 then p1:=length(wab)+1;
          p2:=cpos('!',wab);
          if ((p2>0) and (p2<p1)) then begin
            p2:=p1-1;
            wab:=left(wab,p1-1);
            while wab[p2]<>'!' do dec(p2);   { rechtes "!" suchen }
            p1:=p2-1;
            while (p1>0) and (wab[p1]<>'!') do dec(p1);
            wab:=mid(wab,p2+1)+'@'+copy(wab,p1+1,p2-p1-1);
            end;
          end;
      inc(n); inc(mails);
      write(#8#8#8#8#8,n:5);
      repeat                       { UUCP-Envelope berlesen }
        ReadString(true);
        nofrom:=(lstr(left(s,5))<>'from ') and (lstr(left(s,5))<>'>from');
        if (eol=0) and not nofrom then
          ReadString(false);
      until nofrom;
      mempf:=SetMailUser(hd.empfaenger);
      ReadRFCheader(true,s);
      binaer:=(hd.typ = 'B');
      mpart:=(hd.typ='M') or (hd.mime.ctype=tMultipart);

      if UseEnvTo and (hd.envemp<>'') then
        mempf:=hd.envemp;

      if mempf<>'' then CheckEnvEmp(mempf);

      fp:=fpos; bp:=bufpos;
      hd.groesse:=0;
      smtpende:=false;
      while (bufpos<bufanz) and not smtpende do begin   { Mailgre berechnen }
        ReadString(true);
        smtpende:=(s='.') and LastEol;
        if not smtpende then begin
          if (s<>'') and (s[1]='.') and LastEol then     { SMTP-'.' entfernen }
            delfirstHuge(s);
          UnQuotePrintable(s,qprint,b64,eol>0);    { hngt CR/LF an, falls kein Base64 }
          if not binaer then Charset2IBM;
          inc(hd.groesse,length(s));
          end;
        end;
      seek(f1,fp); ReadBuf; bufpos:=bp;
      WriteHeader;
      smtpende:=false;
      while (bufpos<bufanz) and not smtpende do begin
        ReadString(true);
        smtpende:=(s='.') and lastEol;
        if not smtpende then begin
          if (s<>'') and (s[1]='.') and LastEol then    { SMTP-'.' entfernen }
            delfirstHuge(s);
          UnQuotePrintable(s,qprint,b64,eol>0);    { hngt CR/LF an, falls kein Base64 }
          if not binaer then Charset2IBM;
          wrfs(s);
          end;
        end;
      end;
  until ende;
  close(f1);
  setfattr(f1,0);   { Archivbit abschalten }
  writeln(' - ok');
end;


function unbatch(s:string):boolean;
begin
  unbatch:=(left(s,11)='#! cunbatch') or (left(s,11)='#! funbatch') or
           (left(s,11)='#! gunbatch') or (left(s,11)='#! zunbatch');
end;


{ Newsbatch -> ZCONNECT }

procedure ConvertNewsfile(fn:pathstr);
var f       : file;
    size,ss : longint;
    fp,bp,n : longint;
    freeze  : boolean;
    gzip    : boolean;
    p       : byte;
    newfn   : pathstr;
    dir     : dirstr;
    name    : namestr;
    ext     : extstr;
    binaer  : boolean;
label ende;
begin
  write('news: ',fn);
  OpenFile(fn);
  ReadString(false);
  while unbatch(s) do begin
    freeze:=(pos('funbatch',lstr(s))>0);
    gzip:=(pos('gunbatch',lstr(s))>0) or (pos('zunbatch',lstr(s))>0);
    seek(f1,length(s)+1);
    fsplit(fn,dir,name,ext);
{$IFDEF Linux}
    if (ext<>'.Z') or (ext<>'.gz') or (ext<>'.xz') then begin
      if (freeze) then
        newfn:=fn+'.xz'
      else if (gzip) then
        newfn:=fn+'.gz'
      else
        newfn:=fn+'.Z';
    end;
{$ELSE}
    if ext='' then newfn:=fn+'.Z'
    else
      if freeze then newfn:=dir+name+left(ext,2)+'XZ'
      else newfn:=dir+name+left(ext,3)+'Z';
{$ENDIF}
    assign(f,newfn);
    rewrite(f,1);
    fMove(f1,f);
    close(f);
    close(f1);
    close(f2);
    if freeze then begin
      write(' - unfreezing news...');
      shell(unfreeze+newfn,500);
      end
    else if gzip then begin
      write(' - unzipping news...');
      shell(ungzip+newfn,500);
      end
    else begin
      write(' - uncompressing news...');
      shell(uncompress+newfn,500);
      end;
    reset(f2,1); seek(f2,filesize(f2));
    if exist(newfn) then begin
      writeln(' - Fehler beim Entpacken');
      writeln(uncompress+newfn);halt;
      assign(f,newfn); erase(f);
      exit;
      end;
    OpenFile(fn);
    ReadString(false);
    end;
  n:=0;
  if left(s,2)='#!' then
    if left(s,8)<>'#! rnews' then begin
      writeln(' - unbekanntes Batchformat');
      goto ende;
      end
    else begin
      write(sp(7));
      repeat
        while ((pos('#! rnews',s)=0) or (length(s)<10)) and
              (bufpos<bufanz) do
          ReadString(false);
        if bufpos<bufanz then begin
          p:=pos('#! rnews',s);
          if p>1 then delete(s,1,p-1);
          inc(n);
          write(#8#8#8#8#8,n:5);
          inc(news);
          size:=minmax(ival(mid(s,10)),0,maxlongint);
          fp:=fpos; bp:=bufpos;
          fillchar(hd,sizeof(hd),0);
          if client then
            hd.netztyp:=nt_Client
          else
            hd.netztyp:=nt_RFC;
          ReadString(true);
          ReadRFCheader(false,s);
          binaer := (hd.typ = 'B');
          mpart := (hd.typ='M') or (hd.mime.ctype=tMultipart);
          seek(f1,fp); ReadBuf; bufpos:=bp;
          { ------------------------------------------------------- }
    {*}   { my: Die so gekennzeichneten Zeilen sind ein Bugfix      }
          {     gem (son-of-)RFC1036, wonach EOLs nur als 1 Byte  }
          {     gezhlt werden drfen, auch wenn es sich um CRLF,   }
          {     CRCRLF o.. handelt.                                }
          {     Mit diesem Fix werden auch News-Batches, die CRLFs  }
          {     als Zeilenabschlu und eine RFC-konforme Lngenan-  }
          {     gabe in der rnews-Zeile haben, korrekt und verlust- }
          {     frei konvertiert (was bisher nicht der Fall ist).   }
          {     Da jedoch einige Clients (z.B. XPNews, UKAW v1.37g) }
          {     sich diesbzgl. nicht RFC-konform verhalten und die  }
          {     tatschliche EOL-Lnge in die rnews-Zeile schreiben,}
          {     wird dieser Bugfix dort Datenverlust verursachen.   }
          {     MK (XPNews) ist ber die Problematik informiert (er }
          {     hat diesen Bugfix in 05/2002 selbst in den UUZ von  }
          {     OpenXP/32 eingebaut), bei lteren UKAW-Versionen    }
          {     wie v1.37g kann der Datenverlust vermieden werden,  }
          {     indem man in der Datei <Server>.RC nicht den        }
          {     Default-Eintrag "$newline: crlf" beibehlt, sondern }
          {     ihn in "$newline: lf" abndert.                     }
          {                                                 05/2003 }
          { ------------------------------------------------------- }
          {     Nachtrag: Seit dem 06.06.2003 ist eine gefixte      }
          {     XPNews-Version (v1.2.3) verfgbar, mit der kein     }
          {     Datenverlust mehr entsteht (es werden bei News      }
          {     reine LF-Zeilenenden geschrieben).                  }
          { ------------------------------------------------------- }
          repeat                           { Header berlesen }
            ReadString(true);
         (* dec(size,length(s)+eol); *)
    {*}     dec(size,length(s)+minmax(eol,0,1));
          until (s='') and (lasteol or (bufpos>=bufanz));
          fp:=fpos; bp:=bufpos;
          ss:=size;
          while (ss>0) and (bufpos<bufanz) do begin     { Gre des Textes berechnen }
            MaxSlen:=ss;
            ReadString(true);
         (* dec(ss,length(s)+eol); *)
    {*}     dec(ss,length(s)+minmax(eol,0,1));
            UnQuotePrintable(s,qprint,b64,eol>0);
            if not binaer then Charset2IBM;
            inc(hd.groesse,length(s));
            end;
          WriteHeader;                     { ZC-Header erzeugen }
          seek(f1,fp); ReadBuf; bufpos:=bp;
          while (size>0) and (bufpos<bufanz) do begin    { ZC-Text anhngen }
            MaxSlen:=size;
            ReadString(true);
          { if length(s)+eol>size then
              s[0]:=chr(size-eol); }
         (* dec(size,length(s)+eol); *)
    {*}     dec(size,length(s)+minmax(eol,0,1));
            UnQuotePrintable(s,qprint,b64,eol>0);
            if not binaer then Charset2IBM;
            wrfs(s);
            end;
          if bufpos<bufanz then
            ReadString(false);
          end;
      until (bufpos>=bufanz{-8}) or (s='');
      writeln(' - ok');
      end;
ende:
  close(f1);
  setfattr(f1,0);   { Archivbit abschalten }
  if n=0 then writeln;
end;


procedure UtoZ;
var sr    : searchrec;
    spath : pathstr;
    s     : string;
    typ   : string[10];   { 'mail' / 'news'   }
    dfile : string[12];   { Name des D.-files }
    p     : byte;
    n     : longint;
    mailuser: string;
    dir,name,ext,bak: string;

  procedure GetStr;   { eine Textzeile aus X.-File einlesen }
  var c : char;
  begin
    s:='';
    repeat
      blockread(f1,c,1);
      if (c=#9) or (c>=' ') then s:=s+c;
    until (c=#10) or eof(f1);
  end;

  function U2DOSfile(s:string):string;
  var i : integer;
      b : byte;
  begin
    s:=s[1]+'-'+right(s,5);
    b:=0;
    for i:=0 to 3 do            { Schreibweise in einem Byte codieren }
      if (s[i+4]>='A') and (s[i+4]<='Z') then
        inc(b,1 shl i);
    U2DOSfile:=s+hex(b,1);
  end;

  procedure ReadXfile;
  begin
    assign(f1,spath+sr.name);
    reset(f1,1);
    typ:=''; dfile:='';
    mailuser:='';
    while not eof(f1) do begin
      GetStr;
      if s<>'' then
        case UpCase(s[1]) of
          'C' : if typ='' then begin    { Befehl: 'rmail' / 'rnews' / 'rsmtp' }
                  s:=trim(mid(s,2));
                  p:=blankpos(s);
                  if p>0 then begin
                    typ:=left(s,p-1); mailuser:=trim(mid(s,p+1));
                    p:=blankpos(mailuser);
                    if p>0 then truncstr(mailuser,p-1);
                    end
                  else typ:=s;
                end;
          'F' : if dfile='' then begin  { zugehriges Datenfile }
                  s:=trim(mid(s,2));
                  dfile:=U2DOSfile(s);
                end;
        end;
      end;
    close(f1);
  end;

  function FileType:shortint;
  var f  : file;
      s  : string[12];
      rr : word;
  begin
    assign(f,spath+sr.name);
    reset(f,1);
    blockread(f,s[1],12,rr);
    close(f);
    s[0]:=chr(rr);
    if left(s,8)='#! rnews' then
      FileType:=1
    else if unbatch(s) then       { '#! cunbatch' / '#! funbatch' }
      FileType:=2
    else if left(ustr(s),5)='HELO ' then
      FileType:=3
          else if left(lstr(s),5)='from ' then
      FileType:=4
    else if left(lstr(s),6)='>from ' then
      FileType:=4
    else
      FileType:=0;
  end;

begin
  allocMem;                            { Vor evtl. Umbenennung Speicher fr }
  if exist(dest) then                  { dynamische ZC-Header reservieren   }
  begin
    FSplit(dest, dir, name, ext);
    if UStr(ext) = '.BAK' then
      bak := dir + name + '.BA1'
    else
      bak := dir + name + '.BAK';
    era(bak); if ioresult = 0 then ;
    _rename(dest, bak);
  end;
  assign(f2,dest);
  rewrite(f2,1);
  outbufpos:=0;
  spath:=GetFileDir(source);
  n:=0;
  findfirst(source,ffAnyFile,sr);
  while doserror=0 do
  begin
    if left(sr.name,2)='X-' then
    begin
      incr(TotalSize,sizeKB(spath+sr.name));
      ReadXFile;                          { X.-file interpretieren }
      LoString(typ);
      if exist(spath+dfile) then
      begin
        incr(TotalSize,sizeKB(spath+dfile));
        inc(n);
        if (typ='rnews') or (typ='crnews') or
           (typ='frnews') or (typ='grnews') then
          ConvertNewsfile(spath+dfile)
        else if typ='rmail' then ConvertMailfile(spath+dfile,SetMailuser(mailuser))
        else if (typ='rsmtp') or (typ='crsmtp') or (typ='rcsmtp') or
                (typ='frsmtp') or (typ='rfsmtp') or
                (typ='rzsmtp') or (typ='zrsmtp') or
                (typ='rgsmtp') or (typ='grsmtp') then
          ConvertSmtpFile(spath+dfile,typ<>'rsmtp');
      end;
    end
    else begin
      incr(TotalSize,sizeKB(spath+sr.name));
      inc(n);
      case FileType of
        1,2 : ConvertNewsfile(spath+sr.name);
        3   : ConvertSmtpFile(spath+sr.name,false);
        4   : ConvertMailfile(spath+sr.name,'');
      else
        dec(n);
      end;
    end;
    findnext(sr);
  end;
  findclose(sr);
  if n>0 then writeln;
  writeln('Mails:',mails:6);
  writeln('News :',news:6);
  flushoutbuf;
  close(f2);
  TotalMsgs:=mails+news;
end;


{ --- ZConnect -> UUCP/RFC ------------------------------------------ }

{$I xpfiles.inc}    { Unix2DOSfile }


function NextUunumber:word;
begin
  NextUunumber:=uunumber;
  if uunumber=65535 then uunumber:=0
  else inc(uunumber);
end;


procedure wrs(var f:file; s:string);
begin
  if length(s)>254 then SetLength(s,254);
  s:=s+#10;
  blockwrite(f,s[1],length(s));
end;

procedure wrs_nolf(var f:file; s:string);
begin
  blockwrite(f,s[1],length(s));
end;


{ my: weitgehender Rewrite 11/2002-04/2003 }

procedure WriteRFCheader(var f:file; mail:boolean);
const smtpfirst : boolean = true;
var dat    : string[30];
    s,rfor : string;
    first  : boolean;
    i,j,p  : integer;
    xdate  : boolean;
    ep     : empfnodep;

const mlm =  78; { max. Lnge nicht codierter Zeilen bei Folding (Mail) }
      mel =  76; { max. Lnge codierter Zeilen                          }
      mln = 998; { max. Zeilenlnge (News)                              }

  { --------------------------------------------------------------------- }
  { my: 'EncodeFoldQuote' - Neue Routine 11-12/2002                       }
  {                                                                       }
  {     Headerzeile ggf. MIME-decodieren, quoten und/oder folden und in   }
  {     RFC-Header schreiben.                                             }
  { --------------------------------------------------------------------- }
  {                                                                       }
  { - Der Parameter 'LF' definiert, ob bei gefoldeten Headern die letzte  }
  {   Zeile mit einem LF abgeschlossen wird. Dies ist relevant fr den    }
  {   mehrfachen Aufruf dieser Routine hintereinander, wenn mehrere Teile }
  {   eines Headers (z.B. Adresse und Realname oder mehrere Keywords)     }
  {   unabhngig voneinander behandelt, aber unmittelbar nacheinander     }
  {   geschrieben werden sollen.                                          }
  { - In Verbindung damit kann der Routine ber den Parameter 'len' die   }
  {   Zeichenanzahl bergeben werden, die in der (aktuell letzten)        }
  {   Headerzeile bereits geschrieben wurde. Dadurch ist die Routine in   }
  {   der Lage, selbst bei mittels Mehrfach-Aufrufen zusammengesetzten    }
  {   Headerzeilen an der richtigen Stelle zu folden. Wird an 'len' ein   }
  {   negativer Wert bergeben, bedeutet dies, da in der Zeile bereits   }
  {   ein EW vorhanden ist (was Einflu auf die max. zulssige Zeilen-    }
  {   lnge hat).                                                         }
  { - Der Parameter 'id' ist fr den Bezeichner (z.B. "Keywords: ")       }
  {   bestimmt (er darf daher bei Mehrfach-Aufrufen nur beim ersten       }
  {   Aufruf bergeben werden). Der Parameter 'txt' definiert einen       }
  {   String (i.d.R. ein Trennzeichen wie Komma), der nach der Verarbei-  }
  {   tung des bergebenen Strings an diesen angehngt werden soll, z.B.  }
  {   um einen strukturierten Header danach fortzusetzen (siehe z.B. in   }
  {   'WriteKeywords').                                                   }
  { - Rckgabewert der Funktion ist die Anzahl der Zeichen, die in die    }
  {   (letzte) Headerzeile geschrieben wurden und kann dann als Parameter }
  {   'len' z.B. in einem Schleifenaufruf wiederum an die Routine         }
  {   bergeben werden.                                                   }
  { - Auch wenn die Headerzeile MIME-codiert oder gequotet wird und sich  }
  {   dadurch die Gesamtanzahl der Zeichen auf ber 254 erhht, ist unab- }
  {   hngig von der Lnge des bergebenen Strings jetzt sichergestellt,  }
  {   da keine Zeichen mehr verlorengehen oder defekte MIME-Header       }
  {   erzeugt werden (wir arbeiten nicht mit 'insert' und addieren keine  }
  {   Strings).                                                           }
  { - Der Parameter 'quote' bestimmt, ob strukturierte Header gequotet    }
  {   werden sollen (alle 'uline's z.B., die hinsichtlich der bei der     }
  {   Codierung angewandten Regeln als strukturierte Header behandelt     }
  {   werden, drfen nicht gequotet, wohl aber MIME-codiert werden!).     }
  { - Die Routine bercksichtigt hinsichtlich der zu codierenden Zeichen  }
  {   den jeweiligen Kontext (strukturierter/unstrukturierter Header),    }
  {   die in diesem Kontext geltende max. Zeilenlnge bei Mail von 76     }
  {   Zeichen (fr codierte Zeilen) bzw. 78 Zeichen (fr nicht codierte   }
  {   Zeilen) sowie die brigen in RFC2822 niedergelegten Regeln.         }
  { - Bei News werden nur noch Header gefaltet, die lnger als 998        }
  {   Zeichen sind. Folding ist bei News nach wie vor weder blich noch   }
  {   erwnscht und kann zu Problemen bei bestimmten Funktionen ("NOV")   }
  {   mit manchen Newsservern und -Clients fhren, andererseits ist bei   }
  {   Zeilen, die lnger als 998 Zeichen sind, u.U. der sichere Transport }
  {   nicht immer gewhrleistet.                                          }
  { - Es wird jetzt prinzipiell "minimal invasiv" MIME-codiert, d.h. es   }
  {   werden nur noch die Worte codiert, die im jeweiligen Kontext auch   }
  {   zu codierende Zeichen enthalten. Dabei wird fr jedes zu codierende }
  {   Wort der zu verwendende Zeichensatz separat ermittelt. Mehrere zu   }
  {   codierende Words hintereinander, auf die derselbe Zeichensatz ange- }
  {   wandt werden kann, werden zusammengefat und gemeinsam codiert.     }
  { - Die Header "Newsgroups:" und "References:" werden generell nicht    }
  {   gefolded.                                                           }
  { - Nicht codierte Headerzeilen oder Teile davon, die mangels eines     }
  {   Trenners nicht gefolded werden knnen, werden in der vollen Lnge   }
  {   in den RFC-Header geschrieben, auch wenn sie die empfohlene Lnge   }
  {   von max. 76 bzw. 78 Zeichen (Mail) Zeichen berschreiten sollten.   }
  { - Im Subject werden "falsche" Prefixe wie "RE: ", "re:", "AW: " und   }
  {   "Sv: " sowie alle Inkarnationen davon durch das korrekte "Re: "     }
  {   ersetzt.                                                            }
  { - In strukturierten Headern werden Mehrfach-Leerzeichen entfernt.     }
  {                                                                       }
  { --------------------------------------------------------------------- }

  function EncodeFoldQuote(id,txt,hdr:string; len:integer;
                           const MIMEencode,quote,structured,LF:boolean):integer;
  var  cs,firstcs : string[11];
            s1,s2 : string;
      isoCs,hasEW,
           lastEW : boolean;
         c,p,p0,r,
          t,w1,w2,
             fold : integer;

  const mew        = 75;  { max. Lnge von 'encoded words' }
        minEWchars =  5;  { Wenn soviele Zeichen bei gesplitteten EWs }
                          { nicht mehr in das nchste EW in derselben }
                          { Zeile passen, wird der Header gefolded    }

  { Laut RFC2047 5.(3) drfen die folgenden Zeichen in einem   }
  { 'encoded word' in einer "Phrase" eines strukturierten      }
  { Headers (z.B. Realname vor angle-address) nicht vorkommen  }
  { und mssen daher codiert werden. Die ABNF gibt zwar nichts }
  (*dafr her, da das auch fr die Zeichen "#$%&'^`{|}~"     *)
  { gilt, aber getreu dem Motto "be conservative in what you   }
  { send" halten wir uns vorsichtshalber daran und wenden dies }
  { auf strukturierte Header generell (also nicht nur auf      }
  { "Phrasen") an. Dies dient auch der Vereinfachung, weil wir }
  { dann nicht mehr zwischen Kommentar, Phrase usw. unter-     }
  { scheiden mssen und sicher sind, eher zuviel als zuwenig   }
  { zu codieren und somit immer in jedem Kontext gltige       }
  { 'encoded words' zu erzeugen.                               }

  const encodeChars = '"#$%&''(),.:;<>@[\]^`{|}~';

  { Wenn eines der folgenden Zeichen in einem strukturierten  }
  { Header vorkommt, mu der String "gequotet" werden (falls  }
  { er nicht wegen anderer Zeichen ohnehin MIME-codiert wird, }
  { dann mssen diese Zeichen ebenfalls codiert werden). In   }
  { einem 'quoted-string' mssen die Zeichen '"' und '\' dann }
  { als 'quoted-pair' erscheinen.                             }

  const specials2822 = '()<>@,;:\".[]';

    { Prfen, ob Word/String MIME-codiert werden }
    { mu, korrekten Charset setzen und Anzahl   }
    { der zu codierenden Zeichen zurckgeben.    }

    function encodeAnz(s0:string; var w:integer; const HeaderIsEncoded:boolean):integer;
    var anz,ii : integer;

      { RFC2047 fordert im Abschnitt 7, da jeder String,  }
      { der mit '=?' beginnt und mit '?=' endet und keine  }
      { WSPs enthlt, ein gltiges 'encoded word' zu sein  }
      { hat. Wenn von Hand ein entsprechender String in    }
      { den Header geschrieben wurde (' =?abc?= '), mu er }
      { daher codiert werden.                              }
      { Da aber viele Mail-/Newsreader beim Decodieren     }
      { nach dem "robustness principle" verfahren und auch }
      { ungltige EWs (z.B. mit WSPs) decodieren, codieren }
      { wir sicherheitshalber jeden String, der ein '=?'   }
      { oder ein '?=' enthlt.                             }

      function hasDelimiter:boolean;
      begin
        if (pos('=?',s0)>0) or (pos('?=',s0)>0) then
          hasDelimiter:=true
        else 
          hasDelimiter:=false;
      end;

    begin  { of encodeAnz }
      anz:=0;
      cs:='';
      iso15:=not noEuro and (cpos(chr(euro),s0)>0);
      { Sonderfall: Word enthlt sowohl Euro als auch '' oder '' }
      { => Word mu gesplittet werden, weil diese Zeichen in ISO15 }
      {    nicht existieren (wohl aber in CP437 und ISO1)!         }
      if iso15 and HeaderIsEncoded and
         ((cpos('',s0)>0) or (cpos('',s0)>0)) then
      begin
        ii:=1;
        while not (s0[ii] in [chr(euro),'','']) do inc(ii);
        if s0[ii]=chr(euro) then
          while not (s0[ii+1] in ['','']) do inc(ii)
        else begin
          iso15:=false;
          while not (s0[ii+1]=chr(euro)) do inc(ii);
        end;
        dec(w,length(s0)-ii);
        s0:=left(s0,ii);
        s2:=s0;
      end;
      setIBM2ISO;
      IBM2ISO(s0,255,false);
      isoCs:=containsumlaut(s0);
      if isoCs or
         (cpos(#0,s0)>0) or
         (cpos(#10,s0)>0) or
         (cpos(#13,s0)>0) or
         (HeaderIsEncoded and structured and multipos(specials2822,s0)) or
         hasDelimiter then
        for ii:=1 to length(s0) do
          if ((s0[ii] in [#0..#31,#127..#255,'_','?','=']) or
              (structured and (cpos(s0[ii],encodeChars)>0))) then
          begin
            inc(anz);
            if not HeaderIsEncoded then break; { beim ersten zu codierenden }
          end;                                 { Zeichen abbrechen          }
      if anz>0 then
        if not isoCs then
          cs:=CharsetName(cs_us_ascii)
        else
          cs:=CharsetName(iif(iso15,cs_iso8859_15,cs_iso8859_1));
      encodeAnz:=anz;
    end;

    { Beginn des nchsten Words ermitteln, }
    { dabei fhrende WSPs ignorieren       }

    function NextWord(const LastWord:integer):integer;
    var p0,p1,p2:integer;
    begin
      p0:=LastWord+1;
      while hdr[p0] in [' ',#9] do inc(p0);
      if p0<length(hdr) then
      begin
        p1:=posn(' ',hdr,p0);
        p2:=posn(#9,hdr,p0);
        if p1=0 then
          p0:=p2
        else if p2=0 then
          p0:=p1
        else p0:=min(p1,p2);
      end;
      if p0=0 then p0:=length(hdr);
      if p0<length(hdr) then dec(p0);
      NextWord:=p0;
    end;

    { encoded word bei Erreichen der max. EW-Lnge }
    { abschlieen und in nchstem EW fortsetzen }

    procedure splitEW;
    begin
      s1:=s1+'?=';
      if mail or (not mail and                           { Folding bei Mail }
         (t+length(cs)+8+minEWchars>fold)) then          { Folding bei News }
      begin
        wrs(f,s1);
        t:=0;
      end
      else wrs_nolf(f,s1);                          { kein Folding bei News }
      id:='';
      dec(p);
      s1:=' =?'+cs+'?Q?';
      r:=mew+1;
      c:=length(s1)+2;
      inc(t,c);
    end;

  begin
    hasEW:=len<0;
    len:=abs(len);
    c:=0;
    w1:=0;
    w2:=0;
    t:=len;                   { Anzahl bereits geschriebener Zeichen => 't' }
    firstcs:='';
    s1:='';
    s2:='';
    lastEW:=false;
    if structured then                               { Multi-WSPs entfernen }
    begin
      repeat
        p:=pos('  ',hdr);
        if p>0 then delete(hdr,p,1);
      until p=0;
      repeat
        p:=pos(#9' ',hdr);
        if p>0 then delete(hdr,p,1);
      until p=0;
      repeat
        p:=pos(' '#9,hdr);
        if p>0 then delete(hdr,p+1,1);
      until p=0;
      repeat
        p:=pos(#9#9,hdr);
        if p>0 then delete(hdr,p,1);
      until p=0;
    end;
    if (lstr(left(id,8))='subject:') then         { Bestimmte Prefixe durch }
    begin                                         { 'Re: ' ersetzen         }
      p:=cpos(':',hdr);
      if p>0 then
      begin
        s2:=trim(lstr(left(hdr,p-1)));
        if pos(';'+s2+';',';re;aw;sv;')>0 then
        begin
          id:=id+'Re: ';
          hdr:=ltrim(mid(hdr,p+1));
        end;
      end;
    end;
    p:=0;
    if id<>'' then                                   { Bezeichner schreiben }
    begin
      wrs_nolf(f,id);
      inc(t,length(id));
    end;
    { --------------------------------------------------------------------- }
                                                     { Header MIME-codieren }
    if MIMEencode and (encodeAnz(hdr,w1,false)>0) then while p<length(hdr) do
    begin                                            

      {    r = max. verfgbare Lnge in aktueller     }
      {        Zeile fr aktuelles/nchstes EW (inkl. }
      {        fhrender WSPs!)                       }
      {    c = aktuelle Anzahl der Zeichen im EW      }
      {        (inkl. fhrender WSPs!)                }
      {    t = aktuelle Gesamt-Zeichenanzahl in       }
      {        Headerzeile                            }
      {    p = aktuell bearbeitetes Zeichen in 'hdr'  }
      {   w1 = letztes Zeichen des aktuell in 'hdr'   }
      {        bearbeiteten Teilstrings               }
      { fold = Position, an der gefolded werden *mu* }

      if mail then
        fold:=mel
      else
        fold:=mln;                                { Nchstes Word ermitteln }
      p:=w1;                                      { ('w1' ist das letzte    }
      w1:=NextWord(w1);                           {  Zeichen des Words vor  }
      s2:=copy(hdr,p+1,w1-p);                     {  dem ersten WSP danach) }

      c:=encodeAnz(s2,w1,true);       { 'c' und 'r' temporr fr Anzahl der }
      w2:=w1;  { 'w1' sichern }       { zu codierenden Zeichen mibrauchen  }

      if c>0 then                     { (1): zu codierendes Word bearbeiten }
      begin
        r:=c;
        firstcs:=cs;
        while (r>0) and                             { Mehrere mit demselben }
              (w1<length(hdr)) and                  { Charset zu codierende }
              (cs=firstcs) do                       { Words hintereinander  }
        begin                                       { sammeln               }
          p0:=w2;
          w2:=NextWord(w2);
          s2:=copy(hdr,p0+1,w2-p0);
          r:=encodeAnz(s2,w2,true);
          if (r>0) and (cs=firstcs) then
          begin
            inc(c,r);
            w1:=w2;
          end;
        end;
        cs:=firstcs;                                    { Charset resetten! }

        s2:='=?'+cs+'?Q?';                            { Delimiter EW-Anfang }

        if id='' then
        begin
          s2:=' '+s2;                           { nchstes Leerzeichen nach }
          if not lastEW and (hdr[p+1]=' ') then { Nicht-EW skippen, weil    }
            inc(p);                             { jetzt vor Delimiter       }
        end;

        c:=(w1-p)+(2*c)+length(s2)+2+             { Lnge nchstes EW inkl. }
           iif(w1=length(hdr),                    { evtl. WSPs und 'txt'    } 
               length(txt),0);
        r:=min(mew+(cpos('=',s2)-1),fold-t);       { max. Lnge nchstes EW }
        if (((c>fold-t) and (c<=fold)) or        { Folding vor nchstem EW? }
            (t+length(s2)+minEWchars>fold)) and
            (id='') then
        begin
          wrs(f,s1);                           { vorheriges Word schreiben, }
          t:=0;                                { dann Header folden         }
          r:=mew+(cpos('=',s2)-1);
        end
        else if s1<>'' then                     { vorheriges Word schreiben }
          wrs_nolf(f,s1);

        { --------- bis hier enthielt 's1' das *vorherige* Word! ---------- }

        s1:=s2;                                       { Delimiter EW-Anfang }
        c:=length(s1)+2;                      { '+2' fr Abschlu-Delimiter }
        inc(t,c);

        s2:=hdr;                                        { ISO-Konvertierung }
        iso15:=not noEuro and
               (cpos(chr(euro),copy(hdr,p+1,w1-p))>0); { Teilstring auf     }
        setIBM2ISO;                                    { Charset prfen und }
        IBM2ISO(s2,255,false);                         { ISO-Tabelle setzen }

        while p<w1 do                                    { Word(s) codieren }
        begin
          inc(p); inc(c); inc(t);
          if (s2[p]<=#31) or                 { (1a): zu codierendes Zeichen }
             (s2[p]>=#127) or
             (s2[p] in ['_','?','=']) or
             (structured and (cpos(s2[p],encodeChars)>0)) then
          begin                                    { zu codierendes Zeichen }
            if (c+2+iif(w1=length(hdr),length(txt),0)<=r) and
               (t<=fold) then
            begin                                            { qp-Codierung }
              s1:=s1+'='+hex(ord(s2[p]),2);
              inc(c,2);
              inc(t,2);
            end
            else begin                       { pat nicht mehr, EW splitten }
              splitEW;
              continue;      { Teil des EW geschrieben, Schleife fortsetzen }
            end;
          end
          else begin                   { (1b): nicht zu codierendes Zeichen }
            if (c+iif(w1=length(hdr),length(txt),0)<=r) and
               (t<=fold) then
            begin
              s1:=s1+s2[p];                           { uncodiertes Zeichen }
              if s2[p]=' ' then                       { in EW => s1         }
                s1[length(s1)]:='_';
            end
            else begin                       { pat nicht mehr, EW splitten }
              splitEW;
              continue;      { Teil des EW geschrieben, Schleife fortsetzen }
            end;
          end;
        end;
        s1:=s1+'?=';                   { Ende EW, Abschlu-Delimiter setzen }
        hasEW:=true;
        lastEW:=true;
        id:='';
      end

      else begin                { (2): nicht zu codierendes Word bearbeiten }
        c:=(w1-p)+                           { Lnge neues Word inkl. 'txt' }
           iif(w1=length(hdr),length(txt),0);
        r:=iif(mail,iif(hasEW,mel,mlm),mln)-t;    { max. Lnge neues Word   }

        if (c>r) and (id='') then                 { Folding vor neuem Word? }
        begin
          wrs(f,s1);                           { vorheriges Word schreiben, }
          t:=0;                                { dann Header folden         }
          s1:='';
          hasEW:=false;
        end;

        if s1<>'' then                          { vorheriges Word schreiben }
          wrs_nolf(f,s1);

        s1:=copy(hdr,p+1,w1-p);                      { aktuelles Word => s1 }
        inc(t,length(s1));
        lastEW:=false;
        id:='';
      end;

      if p>=length(hdr) then                       { letztes Word schreiben }
        if LF then
        begin
          wrs_nolf(f,s1);
          wrs(f,txt);
          t:=0;
        end
        else begin
          wrs_nolf(f,s1);
          wrs_nolf(f,txt);
          inc(t,length(txt));
        end;

    end
    { --------------------------------------------------------------------- }
    else if quote and structured and                        { Header quoten }
            multipos(specials2822,hdr) then
    begin
      {  r = max. Restanzahl der pro Zeile zur }
      {      Verfgung stehenden Zeichen       }
      {  p = aktuelle Position in 'hdr'        }
      {  c = aktuelle Position in 's1'         }
      {  t = aktuelle Gesamt-Zeichenanzahl in  }
      {      Headerzeile                       }
      { w1 = Position des letzten WSP in 'hdr' }
      { w2 = Position des letzten WSP in 's1'  }
      if len=0 then              { fortgesetzter Header (z.B. 'Keywords:')? }
      begin
        w1:=-1; w2:=-1;          { wenn nicht, erst ab zweitem Word folden, }
      end;                       { um keine leeren Headerzeilen zu erzeugen }
      r:=1;
      while hdr[r] in [' ',#9] do inc(r);
      if r>1 then                    { DQUOTE *hinter* fhrende WSPs setzen }
      begin
        s1:=left(hdr,r-1);
        inc(p,r-1);
        inc(c,r-1);
        inc(t,r-1);
        if w2>=0 then
        begin
          w1:=r-1; w2:=r-1;
        end;
      end;
      s1:=s1+'"'; inc(c); inc(t);
      r:=iif(mail,iif(hasEW,mel,mlm),mln);          { max. Zeichen in Zeile }
      while p<length(hdr) do
      begin
        inc(p); inc(c); inc(t);
        if (hdr[p] in [' ',#9]) then
        begin
          if w2>=0 then
          begin
            w1:=p;                            { letztes WSP in 'hdr' merken }
            w2:=c;                            { letztes WSP in 's1'  merken }
          end;
        end
        else begin                            { Zeichen <> WSP => ab jetzt  }
          if w2<0 then                        { WSPs merken und ggf. folden }
          begin
            w1:=0; w2:=0;
          end;
          if hdr[p] in ['"','\'] then
          begin
            s1:=s1+'\';
            inc(c); inc(t);
          end;
        end;
        s1:=s1+hdr[p];
        if (((p<length(hdr)) and (t>r)) or      { Folding ntig und mglich }
            ((p=length(hdr)) and               { Damit Zeile nicht wegen    }
             (t+1+length(txt)>r))) and         { abschlieendem DQUOTE bzw. }
           (w2>0) then                         { 'txt' lnger als 'r' wird  }
        begin
          s2:=mid(s1,w2);
          s1:=left(s1,w2-1);                       { zurck zum letzten WSP }
          wrs(f,s1);
          s1:=s2;
          c:=length(s1); t:=c;
          w1:=-1; w2:=-1;          { erst wieder ab zweitem Word folden, um }
          hasEW:=false;            { keine leeren Headerzeilen zu erzeugen  }
          if mail then
            r:=mlm
          else
            r:=mln;
          if p=length(hdr) then            { wenn am Headerende angekommen, }
            wrs_nolf(f,s1);                { letztes Word schreiben         }
        end
        else if (c>=sizeof(s1)-3) or                         { berlauf von }
                (p=length(hdr)) then                         { s1 vermeiden }
        begin
          wrs_nolf(f,s1);
          s1:='';
          c:=0; w1:=0; w2:=0;
        end;
      end;
      if LF then
      begin
        wrs_nolf(f,'"');
        wrs(f,txt);
        t:=0;
      end
      else begin
        wrs_nolf(f,'"');
        wrs_nolf(f,txt);
        inc(t,1+length(txt));                { fr letztes DQUOTE und 'txt' }
      end;
    end
    { --------------------------------------------------------------------- }
    else while hdr<>'' do          { Header weder MIME-codieren noch quoten }
    begin
      { r = max. Anzahl der pro Zeile zur }
      {     Verfgung stehenden Zeichen   }
      { p = aktuelle Position in 'hdr'    }
      r:=max(0,iif(mail,iif(hasEW,mel,mlm),mln)-t); { max. Zeichen in Zeile }
      p:=length(hdr)+length(txt);
      if p>r then               { Headerlnge > max. Zeilenlnge => Folding }
      begin
        p:=min(r+1,length(hdr));
        while (p>0) and                        { letztes WSP vor 'r' suchen }
              not (hdr[p] in [' ',#9]) do
          dec(p);
        if (p<1) or                          { kein WSP vorhanden oder      }
           ((trim(left(hdr,p))='') and       { String nur aus WSPs gefunden }
            (((len>0) and (t=0)) or
             ((len=0) and (t<=length(id))))) then
          p:=NextWord(r);                      { erstes WSP nach 'r' suchen }
        if (hdr[p] in [' ',#9]) then
          dec(p);
        id:='';
        hasEW:=false;
      end;
      s1:=left(hdr,p);
      hdr:=mid(hdr,p+1);
      if LF or (hdr<>'') then   { Jede nicht-letzte bzw. einzige (wenn 'LF' }
      begin                     { true) Headerzeile mit LF abschlieen      }
        wrs_nolf(f,s1);
        wrs(f,iifs(hdr='',txt,''));     { Bei letzter Zeile 'txt' schreiben }
        t:=0;
      end
      else begin                         { Einzige bzw. letzte Zeile eines  }
        wrs_nolf(f,s1);                  { langen Headers ohne LF schreiben }
        wrs_nolf(f,txt);
        inc(t,length(s1)+length(txt));
      end;
    end;
    EncodeFoldQuote:=iif(hasEW,t*-1,t);
  end;


  function month(m:string):string;
  begin
    month:=copy('Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec ',
                ival(m)*4-3,4);
  end;

  function ZtoRFCdate(date,zdate:string):string;
  var p : byte;
  begin
    p:=cpos(':',zdate);
    if p=0 then p:=length(zdate)+1;
    ZtoRFCdate:=copy(date,5,2)+' '+month(copy(date,3,2))+left(zdate,2)+
         left(date,2)+' '+copy(date,7,2)+':'+copy(date,9,2)+':'+
         copy(zdate,13,2)+' '+zdate[16]+formi(ival(copy(zdate,17,p-17)),2)+
         formi(ival(mid(zdate,p+1)),2);
  end;

  function formnews(s:string):string;
  var p : byte;
  begin
    if s[1]='/' then delfirst(s);
    repeat
      p:=cpos('/',s);
      if p>0 then s[p]:='.';
    until p=0;

{ 03.09.1999 robo - bei Netztyp RFC Gruppennamen nicht nach }
{ lowercase wandeln wegen Macrosuff-Schrottnewsservern }

    if hd.netztyp in [nt_RFC, nt_Client]
      then formnews:=s
      else

{ /robo }

    formnews:=lstr(s);
  end;

  { my: eMail-Adresse (auch mit Realname)          }
  {     codieren/quoten/folden/schreiben   12/2002 }

  procedure WriteAddress(const id:string; var adr,rn:string);
  begin
    if rn<>'' then
    begin
      p:=EncodeFoldQuote(id,'',rn,0,true,true,true,false);
      if abs(p)+length(adr)+3 >                     { '3' = ' ' + '<' + '>' }
         iif(mail,iif(p<0,mel,mlm),mln) then         { 'p<0' = EW vorhanden }
        wrs(f,'');
      wrs(f,' <'+adr+'>');
    end
    else wrs(f,id+'<'+adr+'>');
  end;

  { my: Cc:-Header folden/schreiben   01/2003 }

  procedure WriteCCs;
  var   id : string;
         t : integer;
      more : boolean;

    function moreCCs:boolean;            { weitere Cc-Empfnger vorhanden? }
    var p : empfnodep;
    begin
      p:=empflist^.next;
      while (p<>nil) and
            (cpos('@',p^.empf)=0) do
        p:=p^.next;
      moreCCs:=p<>nil;
    end;

  begin
    id:='Cc: ';
    t:=0;
    first:=true;
    while empflist<>nil do
    begin
      if not hd.nokop then
      begin
        if cpos('@',empflist^.empf)>0 then               { Mail-Empfnger? }
        begin
          more:=moreCCs;
          t:=EncodeFoldQuote(id,iifs(more,',',''),
                             iifs(first,'',' ')+'<'+empflist^.empf+'>',t,
                             false,false,true,not more);
          id:='';
          first:=false;
        end;
      end;
      ep:=empflist^.next;
      dispose(empflist);
      empflist:=ep;
    end;
  end;

  procedure WriteNewsgroups;   { Newsgroups nicht folden! }
  var s : string;
      p : empfnodep;
  begin
    s:='Newsgroups: '+formnews(hd.empfaenger);
    wrs_nolf(f,s);
    while empflist<>nil do begin
      s:=','+formnews(empflist^.empf);
      wrs_nolf(f,s);
      p:=empflist^.next;
      dispose(empflist);
      empflist:=p;
    end;
    wrs(f,'');
  end;

  { my: Keywords codieren/quoten/folden/schreiben   12/2002 }

  procedure WriteKeywords;
  var  t : integer;
      id : string;
  begin
    t:=0;
    id:='Keywords: ';
    if keystart<>nil then
    begin
      first:=true;
      keylauf:=keystart;
      while keylauf<>nil do
      begin
        t:=EncodeFoldQuote(id,iifs(keylauf^.next=nil,'',','),
                           iifs(first,'',' ')+keylauf^.s^,t,
                           true,true,true,keylauf^.next=nil);
        keylauf:=keylauf^.next;
        id:='';
        first:=false;
      end;
      DisposeKeywordList;
    end;
  end;

  function maintype(ctype:byte):string;
  begin
    case ctype of
      tText        : maintype:='text';
      tApplication : maintype:='application';
      tImage       : maintype:='image';
      tMessage     : maintype:='message';
      tMultipart   : maintype:='multipart';
      tAudio       : maintype:='audio';
      tVideo       : maintype:='video';
      tModel       : maintype:='model';
      else           maintype:='application';
    end;
  end;


begin  { of WriteRFCheader }
  with hd do
  begin
    dat:=ZtoRFCdate(datum,zdatum);
    if mail then begin
      if wab='' then s:=absender          { Envelope erzeugen }
      else s:=wab;
      p:=cpos('@',s);
      if SMTP then begin
        if smtpfirst or client then begin
          wrs(f,'HELO '+mid(s,p+1));
          smtpfirst:=false;
        end;
        wrs(f,'MAIL FROM:<'+s+'>');
        if cpos('@',hd.empfaenger)>0 then
          wrs(f,'RCPT TO:<'+hd.empfaenger+'>');
        ep:=empflist;
        while ep<>nil do begin
          if cpos('@',ep^.empf)>0 then
            wrs(f,'RCPT TO:<'+ep^.empf+'>');
          ep:=ep^.next;
        end;
        wrs(f,'DATA');
      end
      else
        wrs(f,'From '+left(s,p-1)+' '+dat+' remote from '+mid(s,p+1));
      if (wab<>'') and (cpos('@',oem)>0) and not smtp   { (*1) - s.u. }
        then rfor:=empfaenger
        else rfor:='';
      wrs(f,'Received: by '+mid(s,cpos('@',s)+1)+
            iifs(programm<>'',' ('+programm+')','')+
            iifs(rfor<>'',#10#9'for '+rfor+';',';'));
      wrs(f,#9+left(date,2)+' '+month(copy(date,4,2))+right(date,4)+' '+
            time+' '+right(dat,5));   { akt. Datum/Uhrzeit }
    end
    else
      wrs(f,'Path: '+addpath+pfad);
    wrs(f,'Date: '+dat);
    WriteAddress('From: ',absender,realname);
    if wab<>'' then
      WriteAddress('Sender: ',wab,war);
    if mail then
    begin
      if (wab<>'') and (cpos('@',oem)>0)   { s. (*1) }
        then wrs(f,'To: <'+oem+'>')
        else wrs(f,'To: <'+empfaenger+'>');
      first:=true;
      uuz0.s:='';
      WriteCCs;
    end else
      WriteNewsgroups;
    wrs(f,'Message-ID: <'+msgid+'>');
    if ref<>'' then
    begin

      { 03.09.1999 robo - References einigermassen RFC-konform krzen }
      { 30.11.2002   my - von 980 auf 998 Zeichen erweitert (RFC2822) }

      repeat
        j:=12+length(ref)+2;
        for i:=1 to addrefs do j:=j+length(addref[i])+3;
        if j>mln then begin
          FastMove(addref[2],addref[1],(maxrefs-1)*sizeof(addref[1]));
          dec(addrefs);
        end;
      until j<=mln;

      { /robo }

      if mail then
        wrs(f,'In-Reply-To: <'+iifs(addrefs>0,addref[addrefs],ref)+'>');

      { my: References bei News nicht mehr folden, manche }
      {     News-Server/Clients kommen mit gefoldeten     }
      {     References:-Headern nicht zurecht.    11/2002 }

      wrs_nolf(f,'References: <'+ref+'>'+iifs(mail or (addrefs=0),#10,''));
      for i:=1 to addrefs do
        wrs_nolf(f,' <'+addref[i]+'>'+iifs(mail or (i=addrefs),#10,''));

      { /my }

    end;

    if (attrib and attrControl<>0) and (Pos ('cancel ',control)<>0) then begin
      Insert ('<',control,8);
      wrs(f,'Control: '+control+'>');
    end;
    if mail and (lstr(betreff)='<none>') then
      betreff:='';
    if (betreff<>'') then
      EncodeFoldQuote('Subject: ','',betreff,0,true,false,false,true)
    else if not mail then                       { 'Subject: ' bei News auch }
      wrs(f,'Subject: ');                       { erzeugen, wenn leer!      }
    if keystart<>nil then
      WriteKeywords;
    if summary<>'' then
      EncodeFoldQuote('Summary: ','',summary,0,true,false,false,true);

    if not nomailer and (programm<>'') then
    begin
      if mail then
        EncodeFoldQuote('X-Mailer: ','',programm,0,true,false,false,true)
      else
        EncodeFoldQuote('X-Newsreader: ','',programm,0,true,false,false,true)
        { User-Agent is new in grandson-of-1036 }
        { EncodeFoldQuote('User-Agent: ','',programm,0,true,false,false,true) }
    end;

    { X-No-Archive Konvertierung }
    if xnoarchive then wrs(f,'X-No-Archive: yes');

    { X-Priority Konvertierung }
    if priority<>0 then wrs(f,'X-Priority: '+strs(priority));

    { my: Bei Singleparts in US-ASCII keinen Content-Type-Header schreiben! }
    {     (auskommentiert wegen news.t-online.de)                           }

    if mpart or (x_charset<>'') then
    (* ((x_charset='') or (x_charset=CharsetName(cs_us_ascii))) then *)
    with mime do begin
      wrs(f,'MIME-Version: '+mversion);
      s:=maintype(ctype)+'/'+subtype;
      datei:=trim(datei);
      QuoteStr(datei,true);
      case ctype of
        tText        : s:=s+'; charset='+charset;
        tApplication : if datei<>''  then s:=s+'; name='+datei;
        tMultipart   : s:=s+'; boundary="'+xpboundary+'"'
                          +iifs(mimereltyp='','','; type="'+mimereltyp+'"');
        else           if datei<>''  then s:=s+'; x-filename='+datei;
      end;
      xdate:=(typ='B') and (ddatum<>'') and (attrib and AttrMPbin=0);
      if xdate then s:=s+';';
      wrs(f,'Content-Type: '+s);
      if xdate then
        wrs(f,#9'x-date="'+ZtoRFCdate(copy(ddatum,3,10),ddatum+'W+0')+'"');

      { my: CTE-Header immer schreiben! }

      case encoding of
        enc7bit   : s:='7bit';
        enc8bit   : s:='8bit';
        encQP     : s:='quoted-printable';
        encBase64 : s:='base64';
        encBinary : s:='binary';
      end;
      wrs(f,'Content-Transfer-Encoding: '+s);

    end;

    if not mail and (distribution<>'') then
      wrs(f,'Distribution: '+distribution);
    if PmReplyTo<>'' then
      wrs(f,'Reply-To: '+pmreplyto);
    if pm_reply then
      wrs(f,'Followup-To: poster')
    else
      if not mail and (AmReplyTo<>'') then
        wrs(f,'Followup-To: '+formnews(AmReplyTo));
    if mail and (attrib and attrReqEB<>0) then
      wrs(f,'Return-Receipt-To: '+iifs(empfbestto<>'',empfbestto,
            iifs(wab<>'',wab,iifs(pmReplyTo='',absender,pmReplyTo))));
    if mail and (pgpflags and fPGP_encoded<>0) then
      wrs(f,'Encrypted: PGP');
    if organisation<>'' then
      EncodeFoldQuote('Organization: ','',organisation,0,true,false,false,true);
    if postanschrift<>'' then
      EncodeFoldQuote('X-ZC-Post: ','',postanschrift,0,true,false,false,true);
    if telefon<>'' then
      EncodeFoldQuote('X-ZC-Telefon: ','',telefon,0,true,false,false,true);
    if homepage<>'' then
      wrs(f,'X-Homepage: '+homepage);
    if XPointCtl<>0 then
      wrs(f,'X-XP-Ctl: '+strs(XPointCtl));
    if ersetzt<>'' then
      wrs(f,'Supersedes: <'+ersetzt+'>');
    if fido_to<>'' then
      wrs(f,'X-Comment-To: '+fido_to);
    if not gate and (programm<>'') then
      EncodeFoldQuote('X-XP-Version: ','',programm,0,true,false,false,true);
    wrs(f,'X-RFC-Converter: UUZ ['+trim(xp_display)+' '+
        verstr+betastr+'] @ '+uuztime);
    for i:=1 to ulines do
    begin
      p:=cpos(':',uline^[i]);
      if p>1 then
      begin
        s:=mid(uline^[i],p+1);
        if s[1] in [' ',#9] then delfirst(s);
        EncodeFoldQuote(left(uline^[i],p)+' ','',s,0,true,false,true,true);
      end;
    end;
    if not mail then
      wrs(f,'Lines: '+strs(lines+iif(attrib and AttrMPbin<>0,16,0)));
    for i:=1 to addhds do
      if mail=addhdmail[i] then
        wrs(f,addhd[i]);
    wrs(f,'');
    if attrib and AttrMPbin<>0 then begin
      { Anzahl der Zeilen incl. Trailer oben bei Lines einsetzen! }
      wrs(f,'--'+xpboundary);
      wrs(f,'Content-Type: text/plain');
      wrs(f,'');
      wrs(f,'Diese Nachricht enthaelt eine MIME-codierte Binaerdatei. Falls Ihr');
      wrs(f,'Mailer die Datei nicht decodieren kann, verwenden Sie dafuer bitte');
      wrs(f,'ein Tool wie ''munpack'' oder ''udec''.');
      wrs(f,'');
      wrs(f,'This message contains a MIME encoded binary file. If your mailer');
      wrs(f,'cannot decode the file, please use a decoding tool like ''munpack''.');
      wrs(f,'');
      wrs(f,'--'+xpboundary);
      GetBinType(datei);
      wrs(f,'Content-Type: '+maintype(mime.ctype)+'/'+mime.subtype+
            iifs(datei<>'','; name="'+datei+'"','')+
            iifs(ddatum<>'',';',''));
      if ddatum<>'' then wrs(f,#9'x-date="'+ZtoRFCdate(copy(ddatum,3,10),ddatum+'W+0')+'"');
      wrs(f,'Content-Transfer-Encoding: base64');

      { RFC 2183 }
      wrs(f,'Content-Disposition: attachment'+
            iifs(datei<>'','; filename="'+datei+'"','')+
            iifs(ddatum<>'',';',''));
      if ddatum<>'' then wrs(f,#9'modification-date="'+ZtoRFCdate(copy(ddatum,3,10),ddatum+'W+0')+'"');

      wrs(f,'');
    end;
  end;
end;  { of WriteRFCheader }


procedure WriteRfcTrailer(var f : file);
begin
  if hd.attrib and AttrMPbin <>0 then
    wrs(f,'--'+xpboundary+'--');
end;


procedure ZtoU;
const maxqplines = 11;  { (254*3)/76=10.03 }
      maxqplen   = 76;
      maxlinelen = 998;
var hds,adr : longint;
    fs,n,gs : longint;
    mail,ok : boolean;
    f       : file;
    fn      : string[12];
    fc      : text;
    server  : string;       { Adresse UUCP-Fileserver }
    files   : longint;
    binmail : boolean;
    copycount : integer;    { fr Mail-'CrossPostings' }
    ldstr   : string[2];
    ovrwrt  : boolean;
    qplines : array[1..maxqplines] of string[maxqplen+1];
    bodyline,
    nextline: array[1..maxlinelen] of char;
    linelen,
    nextlen : word;
    DotAdded: boolean;

  procedure resetVars;
  var i : byte;
  begin
    for i:=1 to maxqplines do qplines[i]:='';
    linelen:=0; nextlen:=0;
    DotAdded:=false;
    fillchar(bodyline,sizeof(bodyline),#0);
    fillchar(nextline,sizeof(bodyline),#0);
  end;

  procedure FlushOutbuf(var f:file);
  begin
    if outbufpos>0 then
      blockwrite(f,outbuf^,outbufpos);
    outbufpos:=0;
  end;

  procedure wrbuf(var f:file; var ss:string; const LF:boolean);
  begin
    if LF then
    begin
      if length(ss)<255 then inc(byte(ss[0]));
      ss[length(ss)]:=#10;
    end;
    if outbufpos+length(ss)>=outbufsize then
      FlushOutbuf(f);
    FastMove(ss[1],outbuf^[outbufpos],length(ss));
    inc(outbufpos,length(ss));
  end;

  procedure MakeXfile(sender:string);
  var name,name2 : string[14];
      mail,smtp  : boolean;
      nr         : string[4];
      fs         : longint;
  begin
    mail:=(sender='mail');
    smtp:=(sender='smtp');
    nr:=hex(NextUunumber,4);
    assign(f2,dest+'X-'+nr+'.OUT');
    rewrite(f2,1);
    if mail or smtp then wrs(f2,'U '+MailUser+' '+_from)
    else wrs(f2,'U '+NewsUser+' '+_from);
    name:=fn[1]+'.'+left(_from,7)+iifc(mail or smtp,'C','d')+right(fn,4);
    wrs(f2,'F '+name);
    wrs(f2,'I '+name);
    if smtp and csmtp then
      wrs(f2,'C rcsmtp')
    else if smtp and fsmtp then
      wrs(f2,'C rfsmtp')
    else if smtp and zsmtp then
      wrs(f2,'C rgsmtp')
    else
      wrs(f2,'C r'+sender+iifs(mail,' '+hd.empfaenger,''));
    fs:=filesize(f2);
    close(f2);
    name2:=fn[1]+'.'+left(_to,7)+'D'+right(fn,4);
    write(fc,'S ',name2,' ',name,' ',iifs(mail or smtp,MailUser,NewsUser),
             ' - ',name2,' 0666');
    if ParSize then writeln(fc,' "" ',_filesize(dest+fn+'.OUT'))
    else writeln(fc);
    name2:='D.'+left(_to,7)+'X'+nr;
    write(fc,'S ',name2,' X.',left(_from,7),iifc(mail or smtp,'C','d'),nr,' ',
             iifs(mail or smtp,MailUser,NewsUser),' - ',name2,' 0666');
    if ParSize then writeln(fc,' "" ',fs)
    else writeln(fc);
  end;

  procedure WrFileserver;
  var p        : byte;
      fromfile : string;
      tofile   : string[40];
      request  : boolean;
      transfer : boolean;
      tfiles   : integer;

    function slashs(fn:pathstr):pathstr;
    var i : byte;
    begin
      for i:=1 to length(fn) do
        if fn[i]='\' then fn[i]:='/';
      slashs:=fn;
    end;

    procedure WriteTransfer(s:string);
    begin
      writeln(fc,'S ',slashs(fromfile),' ',s,' ',FileUser,' - ',
              getfilename(fromfile),' 0666' +
              iifs(ParSize,' "" '+strs(_filesize(fromfile)),''));
    end;

  begin
    request:=(ustr(hd.betreff)='REQUEST');
    transfer:=(hd.attrib and attrFile)<>0;
    if transfer then begin
      fromfile:=hd.betreff;
      if not exist(fromfile) then begin
        writeln(' warning: ',fromfile,' not found!');
        exit;
        end;
      tfiles:=0;
      end;
    seek(f1,adr+hds);
    ReadBuf;
    while fpos+bufpos<adr+hds+hd.groesse do begin
      ReadString(false);
      s:=trim(s);
      if (s<>'') and (s[1]<>'#') then begin
        if request then begin
          p:=blankpos(s);
          if p=0 then begin
            fromfile:=s;
            if Uselfn then tofile:=Unix2LFNfile(s,'');
            if not Uselfn then tofile:=Unix2DOSfile(s,'');
            end
          else begin
            fromfile:=left(s,p-1);
            tofile:=trim(mid(s,p+1));
            end;
          writeln(fc,'R ',fromfile,' ',tofile,' ',FileUser,' -');
          end
        else begin
          WriteTransfer(s);
          inc(tfiles);
          end;
        inc(files);
        end;
      end;
    if transfer and (tfiles=0) then
      WriteTransfer(lstr(getfilename(fromfile)));
  end;

  { String abkrzen, falls Zeile nicht mit CR/LF beendet }
  { und nachfolgendes EMP: angehngt wurde               }

  procedure ShortS;
  begin
    s:=left(s,max(0,integer(length(s))-(fpos+bufpos-gs)+2));
  end;

  { ------------------------------------------------- }
  { my: Body-Zeile ISO-konvertieren, ggf. qp-codieren }
  {     und schreiben                         03/2003 }
  { ------------------------------------------------- }
  {     Bugfixes/nderungen:                          }
  {     - Lange nicht qp-codierte Zeilen werden nicht }
  {       mehr nach 253 Zeichen umbrochen (sondern    }
  {       gem RFC1036/2882 nach 998 Zeichen bzw.    }
  {       dem letzten WSP davor).                     }
  {     - Beim berschreiten der max. Zeilenlnge von }
  {       998 Zeichen und anschlieendem Umbruch bzw. }
  {       bei fortgesetzten qp-Zeilen wird in SMTP-   }
  {       Mails jetzt auch in diesen Fllen der evtl. }
  {       notwendige zustzliche "." hinzugefgt      }
  {       (wenn die neue Zeile mit einem "." beginnt).}
  {       Bei NNTP-Postings wird er ebenfalls hinzu-  }
  {       gefgt, aber vor dem Schreiben wieder ent-  }
  {       fernt, weil diese Aufgabe vom Client ber-  }
  {       nommen wird. Das Hinzufgen dient nur dazu, }
  {       die Zeilenlnge korrekt zu berechnen und    }
  {       ein Zeichen "Reserve" zu schaffen, damit    }
  {       durch das Hinzufgen des "." durch den      }
  {       Client keine unzulssig langen Zeilen       }
  {       entstehen knnen.                           }
  {     - Bei der qp-Codierung kann kein Zeichen-     }
  {       verlust bei langen Strings durch 'insert'   }
  {       mehr entstehen.                             }
  {     - Lo-ASCIIs und die EBCDIC-kritischen Zeichen }
  (*      !"#$@[\]`{|}~ werden bei -qp jetzt codiert.*)
  {     - WSPs am Ende von Sigtrennern werden bei -qp }
  {       jetzt codiert.                              }
  {     - Sonstige WSPs am Zeilenende werden jetzt    }
  {       entfernt (speziell wegen der XP-typischen   }
  {       zwei Spaces am Zeilenende).                 }
  {                                                   }
  { Diese Routine setzt auf der momentanen Logik von  }
  { 'readstring' auf! Sollte diese Logik gendert     }
  { werden, sind mglicherweise auch hier Anpassungen }
  { erforderlich.                                     }
  { ------------------------------------------------- }

  procedure WriteS(var f0:file; const write:boolean);
  var qp,sMoved : boolean;
              i : word;

    function EndOfLine:boolean;
    begin
      EndOfLine:=(eol>0) or (buffer[bufpos] in [#13,#10]);
    end;

    function sigdashes:boolean;
    begin
      sigdashes:=((s='-- ') or (s='--'#9)) and (eol>0) and lasteol;
    end;

    { Hier wird geprft, ob es machbar und sinnvoll ist, den Anfang   }
    { von 'nextline' an das Ende von 'bodyline' zu verschieben. Das   }
    { ist dann der Fall, wenn im entsprechenden Teil von 'nextline'   }
    { WSPs vorkommen oder wenn in 'nextline' bzw. 's' gar keine WSPs  }
    { vorkommen und das Wort daher ohnehin auseinandergerissen wrde. }
    { Sinn und Zweck ist, einerseits die max. Zeilenlnge mglichst   }
    { vollstndig auszunutzen, andererseits aber Worte nicht durch    }
    { Zeilenumbrche mitten im Wort auseinanderzureien (vorausge-    }
    { setzt, das Wort wrde vollstndig in die nchste Zeile passen). }

    function rewrap:boolean;
    var p0 : word;
    begin
      rewrap:=false;
      if nextlen=0 then exit;
      DotAdded:=DotAdded and (client or (mail and SMTP)) and   { sicher ist }
                (nextlen>=2) and (nextline[1]='.') and         { sicher ... }
                (nextline[2]='.');
      p0:=(maxlinelen-linelen)+byte(DotAdded);
      if p0>0+byte(DotAdded) then
      begin
        if not (nextline[p0+1] in [' ',#9]) then  { genau Ende eines Worts? }
        begin
          while (p0>0+byte(DotAdded)) and not (nextline[p0] in [' ',#9]) do dec(p0);
          while (p0>0+byte(DotAdded)) and (nextline[p0] in [' ',#9]) do dec(p0);
        end;
        if p0<=0+byte(DotAdded) then                   { kein vollstndiges }
        begin                                          { Wort links von p0  }
          p0:=(maxlinelen-linelen)+byte(DotAdded)+1;
          while (p0<=nextlen) and not (nextline[p0] in [' ',#9]) do inc(p0);
          if (p0>nextlen) and (sMoved or (not sMoved and
             (blankpos(left(s,maxlinelen-nextlen))=0))) then { null WSPs in }
            p0:=(maxlinelen-linelen)+byte(DotAdded)          { Folgezeile   }
          else
            p0:=0+byte(DotAdded);              { WSPs rechts von p0 in      }
        end;                                   { Folgezeile => kein rewrap! }
      end;
      if p0>0+byte(DotAdded) then    { Anfang 'nextline' => Ende 'bodyline' }
      begin
        rewrap:=true;
        dec(p0,byte(DotAdded));
        fastmove(nextline[1+byte(DotAdded)],bodyline[linelen+1],p0);
        inc(linelen,p0);
        inc(p0,byte(DotAdded));
        dec(nextlen,p0);
        DotAdded:=(client or (mail and SMTP)) and (nextline[p0+1]='.');
        if DotAdded then nextline[1]:='.';
        move(nextline[p0+1],nextline[1+byte(DotAdded)],nextlen);
        inc(nextlen,byte(DotAdded));
      end;
    end;

    { lange Zeile bis 998 Zeichen schreiben }

    procedure WrBodyline(const next2body:boolean);
    var bs    : string;
        ll,ls : word;
    begin
      ll:=0;                         { Anzahl bereits geschriebener Zeichen }
      if write and client and not mail and  { Bei NNTP '.' wieder entfernen }
         (bodyline[1]='.') and (bodyline[2]='.') then
      begin
        dec(linelen);
        move(bodyline[2],bodyline[1],linelen);
      end;
      while ll<linelen do
      begin
        ls:=min(254,linelen-ll);
        fastmove(bodyline[ll+1],bs[1],ls);
        bs[0]:=chr(ls);
        inc(ll,ls);
        if write then wrbuf(f0,bs,ll>=linelen)       { Teilstring schreiben }
        else if ll>=linelen then inc(hd.lines);
      end;
      linelen:=0;
      fillchar(bodyline,sizeof(bodyline),#0);
      if next2body then
      begin
        bodyline:=nextline;                      { 'nextline' => 'bodyline' }
        linelen:=nextlen;
        nextlen:=0;
        fillchar(nextline,sizeof(nextline),#0);
      end;
      DotAdded:=false;
    end;

    procedure sMoveToNextline;
    begin
      if (client or (mail and SMTP)) and (nextlen=0) and (firstchar(s)='.') then
      begin
        nextline[1]:='.';
        inc(nextlen);
        DotAdded:=true;
      end;
      fastmove(s[1],nextline[nextlen+1],byte(s[0]));
      inc(nextlen,byte(s[0]));
    end;

    procedure MakeQuotedPrintable;
    var      ii,p : byte;                    {EBCDIC}     { ------- EBCDIC ------ }
    const qprchar = [#0..#8,#11,#12,#14..#31,'!'..'$','=','@','['..'^','`','{'..'~',#127..#255];
    begin
      ii:=1;
      p:=1;
      if sigdashes then                          { white spaces am Ende von }
      begin                                      { Sigtrennern codieren     }
        qplines[1]:=s;
        qplines[1][3]:='=';
        qplines[1]:=qplines[1]+'20';
      end
      else while (p<=length(s)) and (ii<=maxqplines) do
      begin
        if length(qplines[ii]) >
           ((maxqplen-iif(not EndOfLine or (p<length(s)),4,3)) +
            iif(s[p] in qprchar,0,2)) then
        begin
          qplines[ii]:=qplines[ii]+'='#10;             { soft line break    }
          inc(ii);                                     { (Zeile fortsetzen) }
        end;
        if (client or (mail and SMTP)) and  { '.' bei fortgesetzten Zeilen  }
           (ii>1) and (qplines[ii]='') and  { in SMTP- und NNTP-Nachrichten }
           (s[p]='.') then                  { hinzufgen, falls ntig       }
          qplines[ii]:='.';
        if s[p] in qprchar then
          qplines[ii]:=qplines[ii]+'='+hex(ord(s[p]),2)      { qp-Codierung }
        else
          qplines[ii]:=qplines[ii]+s[p];
        inc(p);
      end;
      if eol>0 then qplines[ii]:=qplines[ii]+#10;
    end;

  begin
    qp:=MakeQP and (hd.mime.encoding=encQP);
    if EndOfLine and not sigdashes then    { rechte WSPs entfernen (mten  }
      s:=rtrim(s);                         { bei -qp sonst codiert werden!) }
    if (write and convibm and not mpart) or qp then
      IBM2ISO(s,254,false);
    { ===================================== qp-codierte Zeile schreiben === }
    if qp then
    begin
      MakeQuotedPrintable;
      i:=1;
      while (qplines[i]<>'') and (i<=maxqplines) do
      begin
        if (eol=0) and                         { wenn Body-Zeile noch nicht }
           ((i=maxqplines) or                  { beendet ist, letzte qpline }
            (qplines[i+1]='')) then            { nicht schreiben, sondern   }
        begin                                  { nach qplines[1] sichern!   }
          if i>1 then
          begin
            qplines[1]:=qplines[i];
            qplines[i]:='';
          end;
          break;
        end;
        if write then
        begin
          if client and not mail and        { Bei NNTP '.' wieder entfernen }
             (qplines[i][1]='.') and (qplines[i][2]='.') then
            delete(qplines[i],1,1);
          wrbuf(f0,qplines[i],false);                     { Zeile schreiben }
        end
        else inc(hd.lines);
        qplines[i]:='';
        inc(i);
      end;
    end
    { =============================== nicht qp-codierte Zeile schreiben === }
    else begin
      { -------------------------------- Zeile <= 254 Zeichen schreiben --- }
      if lasteol and (eol>0) then 
      begin
        if write then
        begin
          if client and not mail and        { Bei NNTP '.' wieder entfernen }
             (left(s,2)='..') then
            delete(s,1,1);
          wrbuf(f0,s,true);
        end
        else inc(hd.lines);
      end
      else begin
        { ---------------------------- Zeile 254..998 Zeichen schreiben --- }
        if (nextlen=0) and (linelen+byte(s[0])<=maxlinelen) then
        begin
          fastmove(s[1],bodyline[linelen+1],byte(s[0]));
          inc(linelen,byte(s[0]));
          if eol>0 then WrBodyline(false);       { aktuelle Zeile schreiben }
        end
        { ------------------------------- Zeile > 998 Zeichen schreiben --- }
        else begin
          if nextlen+byte(s[0])<=maxlinelen then
          begin
            sMoveToNextline;
            if eol>0 then
            begin
              rewrap;
              WrBodyline(true);                 { vorherige Zeile schreiben }
              WrBodyline(false);                { aktuelle  Zeile schreiben }
            end;
          end
          else begin                    { 's' pat nicht mehr in 'nextline' }
            sMoved:=false;
            if rewrap and                                  { pat 's' jetzt }
               (nextlen+byte(s[0])<=maxlinelen) then       { in 'nextline'? }
            begin
              sMoveToNextline;
              sMoved:=true;
            end;
            WrBodyline(true{!});                { vorherige Zeile schreiben }
            if not sMoved then    { *mu* passen, 'nextline' ist jetzt leer }
              sMoveToNextline;
            if eol>0 then
            begin
              { 'sMoved' kann (und mu!) hier nur dann false  }
              { sein, wenn 's' in der unmittelbar vorherigen  }
              { Anweisung nach 'nextline' gemoved wurde. Es   }
              { wird hier temporr auf true gesetzt, damit    }
              { 'rewrap' nicht unntig auf WSPs in 's' prft  }
              { und daraus evtl. falsche Schlsse zieht ('s'  }
              { befindet sich in Wirklichkeit ja bereits in   }
              { 'nextline', aber 'sMoved' mu fr den Aufruf  }
              { von 'WrBodyline' weiterhin auf false stehen). }
              if not sMoved then
              begin
                sMoved:=true;
                rewrap;
                sMoved:=false;
              end;
              WrBodyline(not sMoved);           { aktuelle Zeile schreiben }
              if not sMoved then
                WrBodyline(false);      { evtl. berhang aus 's' schreiben }
            end;
          end;
        end;
      end;
    end;
  end;

  procedure CreateNewfile;
  begin
    repeat
      fn:=ldstr+hex(NextUunumber,4);
    until not exist(dest+fn+'.OUT') or ovrwrt;
    assign(f2,dest+fn+'.OUT');
    rewrite(f2,1);
  end;

  { my: Gate-Modus - Bei ZConnect-Nachrichten (= nicht mit }
  {     einer RFC-Box von XP erzeugt) Body auf Hi-ASCIIs   }
  {     prfen und Charset/Encoding entsprechend setzen    }

  procedure checkBody4CharsetEncoding;
  var is8bit : boolean;
  begin
    with hd.mime do
    begin
      if mpart then exit;
      is8bit:=false;
      iso15:=false;
      charset:=CharsetName(cs_us_ascii);
      encoding:=enc7bit;
      seek(f1,adr+hds);
      ReadBuf;
      gs:=adr+hds+hd.groesse;
      while (fpos+bufpos<gs) and not (is8bit and (noEuro or iso15)) do
      begin
        ReadString(true);
        if fpos+bufpos>gs then ShortS;
        if convibm then
        begin
          iso15:=not noEuro and (cpos(chr(euro),s)>0);
          setIBM2ISO;
          IBM2ISO(s,254,false);
        end;
        if containsumlaut(s) then
        begin
          if convibm then
            charset:=CharsetName(iif(iso15,cs_iso8859_15,cs_iso8859_1))
          else
            { bei ISO-Nachrichten Charset aus CHARSET:-Header bernehmen! }
            charset:=CharsetName(ival(mid(hd.charset,4)));
          if MakeQP then
            encoding:=encQP
          else
            encoding:=enc8bit;
          is8bit:=true;
        end;
      end;
      hd.x_charset:=charset;
    end;
  end;

  procedure WriteNews(const write:boolean);
  begin
    if bufpos=0 then eol:=1;            { damit lasteol am Anfang true wird }
    ReadString(true);
    if fpos+bufpos>gs then ShortS;
    if client and lasteol and (firstchar(s)='.') then     { '.' nur bei     }
      s:='.'+s;                                           { NNTP hinzufgen }
    WriteS(f,write);
  end;

begin
  new(uline);
  keystart:=nil;
  incr(TotalSize,sizeKB(source));
  assign(f1,source);
  reset(f1,1);
  adr:=0; n:=0;
  if not client then begin
    assign(fc,dest+'C-'+hex(NextUunumber,4)+'.OUT');   { "C."-File }
    rewrite(fc);
  end;
  if filesize(f1)<10 then
  begin
    close(f1);
    if not client then close(fc);
    exit;
  end;
  assign(f,'UUZ.TMP');
  rewrite(f,1);
  server:=ustr(UUserver+'@'+_to);
  files:=0;

  ldstr:=iifs(client,'N','D-');
  ovrwrt:=not client;
  mail:=false;

  if not client then CreateNewfile;           { 1. Durchgang: News }
  fs:=filesize(f1);
  repeat
    resetVars;
    seek(f1,adr);
    empflist:=nil;
    makeheader(true,f1,1,0,hds,hd,ok,false);
    if not ok then begin
      close(f1);
      error('fehlerhafter Eingabepuffer!');
    end;
    convibm:=(lstr(left(hd.charset,3)) <> 'iso');
    binmail:=(hd.typ <> 'T') and (hd.typ <> 'M');
    SetMimeData;
    gs:=adr+hds+hd.groesse;
    if cpos('@',hd.empfaenger)=0 then      { AM }
    begin
      inc(n); write(#13'News: ',n);
      if client then CreateNewFile;
      seek(f1,adr+hds);
      if binmail then
        hd.lines:=(hd.groesse+53) div 54    { Anzahl Base64-Zeilen }
      else begin
        ReadBuf;                            { Zeilen zhlen }
        while fpos+bufpos<gs do
          WriteNews(false);
        resetVars;
        if gate then checkBody4CharsetEncoding;
      end;
      seek(f,0);
      WriteRFCheader(f,false);
      seek(f1,adr+hds);   { Text kopieren }
      ReadBuf;
      outbufpos:=0;
      iso15:=not noEuro and
             (lstr(hd.x_charset)=lstr(CharsetName(cs_iso8859_15)));
      setIBM2ISO;
      if binmail then
        while fpos+bufpos<gs do
        begin
          ReadBinString(gs-fpos-bufpos);
          wrbuf(f,s,true);
        end
      else while fpos+bufpos<gs do
        WriteNews(true);
      flushoutbuf(f);
      WriteRfcTrailer(f);
      truncate(f);
      if not client then wrs(f2,'#! rnews '+strs(filesize(f)));
      seek(f,0);
      fmove(f,f2);
      if client then close(f2);
    end;
    disposeempflist(empflist);
    inc(adr,hds+hd.groesse);
  until adr>fs-10;
  empflist:=nil;
  if not client then close(f2);
  if n=0 then
  begin
    if not client then erase(f2);
  end
  else begin
    if not client then MakeXfile('news');
    writeln;
  end;
  close(f); erase(f);
  inc(TotalMsgs,n);

  adr:=0; n:=0;                     { 2. Durchgang: Mail }

  ldstr:=iifs(client,'M','D-');
  mail:=true;

  if SMTP and not client then CreateNewfile;
  repeat
    resetVars;
    copycount:=1;
    repeat
      seek(f1,adr);
      makeheader(true,f1,copycount,0,hds,hd,ok,false);
      convibm:=(lstr(left(hd.charset,3)) <> 'iso');
      binmail:=(hd.typ <> 'T') and (hd.typ <> 'M');
      SetMimeData;
      if cpos('@',hd.empfaenger)>0 then
        if ustr(left(hd.empfaenger,length(server)))=server then
        begin
          if not client then WrFileserver;
        end
        else begin
          inc(n); write(#13'Mails: ',n);
          if not SMTP or client then
            CreateNewfile;
          if binmail then
            seek(f1,adr+hds)
          else if gate then
            checkBody4CharsetEncoding;
          WriteRFCheader(f2,true);
          seek(f1,adr+hds);   { Text kopieren }
          ReadBuf;
          gs:=adr+hds+hd.groesse;
          outbufpos:=0;
          iso15:=not noEuro and
                 (lstr(hd.x_charset)=lstr(CharsetName(cs_iso8859_15)));
          setIBM2ISO;
          if binmail then
            while fpos+bufpos<gs do begin
              ReadBinString(gs-fpos-bufpos);
              wrbuf(f2,s,true);
            end
          else
            while fpos+bufpos<gs do
            begin
              if bufpos=0 then eol:=1;  { damit lasteol am Anfang true wird }
              ReadString(true);
              if fpos+bufpos>gs then ShortS;
              if SMTP and lasteol and (firstchar(s)='.') then s:='.'+s;
              WriteS(f2,true);
            end;
          flushoutbuf(f2);
          WriteRfcTrailer(f2);
          if SMTP then begin
            wrs(f2,'.');          { Ende der Mail }
            if client then begin
              wrs(f2,'QUIT');
              close(f2);
            end;
          end
          else begin
            close(f2);
            if not client then MakeXfile('mail');
          end;
        end;
      disposeempflist(empflist);
      if SMTP then copycount:=hd.empfanz;
      inc(copycount);
    until copycount>hd.empfanz;
    inc(adr,hds+hd.groesse);
  until adr>fs-10;
  if n>0 then writeln;
  if files>0 then
    writeln('Files: ',files);
  if SMTP and not client then begin
    wrs(f2,'QUIT');
    close(f2);
    if n=0 then erase(f2)
    else if not client then MakeXfile('smtp');
  end;
  close(f1);
  if not client then close(fc);
  dispose(uline);
  inc(TotalMsgs,n);
end;


procedure SetWindow;
var y : byte;
begin
  y:=wherey;
  close(output); assigncrt(output); rewrite(output);
  window(1,4,80,xpwindow-2);
  gotoxy(1,y-3);
end;



begin
  Randomize;
  logo;
  initvar;
  getpar;
  testfiles;
  if XpWindow>0 then SetWindow;
  uuzstart:=get_time;
  if u2z then UtoZ
  else ZtoU;
  run_time:=time_diff(uuzstart,get_time);
  if (TotalSize>0) and (TotalMsgs>0) then
  begin
    writeln;
    if run_time>0 then 
      writeln(strsr(TotalSize,2) + ' KB processed in ' + strSecs(run_time) +
              ' at ' + strsr(TotalSize/run_time,2) + ' KB/sec and ' +
              strsr(TotalMsgs/run_time,2) + ' messages/sec')
    else
      writeln(strsr(TotalSize,2) + ' KB processed in less than 1/100 sec');
  end;
  donevar;
end.

{
  $Log: uuz.pas,v $
  Revision 1.35.2.81  2003/01/19 08:29:11  mw
  MW: - nderungen bezglich Wiedercompilierbarkeit einer XT-Version entfernt.
        Eine XT-Version von Openxp/16 V3.40 ist nicht mehr mglich !!!

  Revision 1.35.2.80  2003/01/17 17:01:26  mw
  MW: - Make XT-Version compile again (Part 1)

  Revision 1.35.2.79  2002/07/11 12:27:11  my
  MY:- Betrefflnge von 245 auf 248 Zeichen erhht (255-CRLF-"BET: ").
       Vorgriff auf die genderte Betreffbehandlung im UUZ, der zuknftig
       beliebig lange Betreffs ausgehend verarbeiten knnen wird, weshalb
       die Lnge des Strings "Subject: " nicht mehr bercksichtigt werden
       mu (in XP bleibt es aber b.a.w. bei der 255-Zeichen-Beschrnkung).

  Revision 1.35.2.78  2002/06/10 13:49:42  my
  MY:- Fix: Wenn die max. zulssige Betrefflnge von 250 Zeichen
       ausgenutzt wurde, wurde der Betreff in XP auf 248 und im UUZ auf
       245 Zeichen gekrzt. Max. Betrefflnge daher auf 245 Zeichen
       reduziert (mehr passt nun mal nicht eine max. 255 Zeichen lange
       Zeile, wenn noch die Headerbezeichnung "Subject: " und das
       abschlieende LF hinzukommen).

  Revision 1.35.2.77  2002/05/09 22:12:08  my
  MY:- Fix: Singlepart-Nachrichten mit einem anderen Zeichensatz als
       ISO-8859-1 (z.B. ISO-8859-15) im X-Charset-Header und ohne
       ZConnect-Charset-Header "ISOx" (x=1-15) wurden nach der Konver-
       tierung durch UUZ hufig dennoch mit der Zeichensatzdeklaration
       ISO-8859-1 versandt. Variable 'convibm' wurde in "SetMimeData"
       geprft, bevor sie gesetzt wurde und hatte dadurch einen zuflligen
       Wert - als Folge dieses Fixes mute das Setzen der Variable 'mpart'
       bei ausgehenden Nachrichten nach "SetMimeData" verlegt werden, weil
       ansonsten Multipart-Nachrichten einer Zeichensatzkonvertierung
       unterzogen worden wren.

  MY:- Vorbereitung fr zuknftige Zeichensatzerweiterungen unter
       ZConnect: Beim Betrieb eines externen Clients in einer ZConnect-Box
       wird bei der UUZ-Konvertierung von ISO-Nachrichten jetzt nicht mehr
       stur der Zeichensatz ISO-8859-1 deklariert, sondern die Deklaration
       richtet sich nach der jeweiligen Bezeichnung im ZConnect-Charset-
       Header ("ISO15" wird zu "ISO-8859-15"). Die Existenz eines
       ZConnect-Headers "CHARSET: ISOx" (x=1-15) verhindert nach wie vor
       eine Zeichensatzkonvertierung.

  Revision 1.35.2.76  2002/04/28 17:53:26  my
  MY:- Vorletzten Commit korrigiert: Wir entfernen jetzt doch Kommentar
       *und* die schlieende spitze Klammer und stellen uns auf den
       Standpunkt, da ein Kommentar in einer MsgID nichts verloren hat
       und die Server dafr zu sorgen haben, auch eine MsgID ohne
       Kommentar korrekt zu behandeln.

  MY:- Fix: Bei Verwendung des Schalters "-UseEnvTo" wird nicht mehr
       u.a. auf "U-Delivered-To", sondern auf "Delivered-To" geprft
       (Delivered-To-Untersttzung ist damit aber noch noch nicht
       komplett erledigt).

  Revision 1.35.2.75  2002/04/26 23:11:51  my
  MY:- Ein paar Commit-Texte gendert/przisiert.

  Revision 1.35.2.74  2002/04/26 22:44:59  my
  MY:- Fix: Beim Entfernen von Kommentaren aus der Message-ID wurde die
       schlieende spitze Klammer nicht entfernt. Der Fix besteht darin,
       den Kommentar berhaupt nicht mehr zu entfernen, da es ansonsten
       Probleme bei der Zusammenarbeit mit externen Clients (ReplaceOwn,
       Mail auf dem Server lschen, Message-ID-Request) geben kann.

  Revision 1.35.2.73  2002/04/18 22:16:49  my
  JG+MY:- Untersttzung aller derzeit bei der IANA registrierten Alias-
          Namen fr die von XP bei eingehenden Nachrichten untersttzten
          Zeichenstze (US-ASCII, ISO-8859-x und Windows-1252)
          implementiert.

  Revision 1.35.2.72  2002/04/13 12:43:00  sv
  - Spitze Klammern wurden bei eingehenden Cancels nicht korrekt entfernt

  Revision 1.35.2.71  2002/04/09 21:48:04  my
  MY:- Typo im Commit-Text entfernt.

  Revision 1.35.2.70  2002/04/09 21:45:32  my
  MY:- Anzahl der erforderlichen UUZ-Parameter bei ausgehenden Nachrichten
       auf 3 (vorher 4) reduziert. Routine erfllt ohnehin nicht ihren
       vermutlichen Zweck (nmlich die Angabe von <fromSite> und <toSite>
       zu erzwingen) und mte mal komplett berarbeitet werden.

  Revision 1.35.2.69  2002/04/09 21:40:44  my
  MY[+JG]:- Der From:-Header durchluft jetzt die MIME-Decodierung nach
             RFC 1522, *bevor* er in 'GetAdr' in Adresse und Realname
             zerlegt wird (vorher wurde ein Header wie
             'From: "Christian =?Iso-8859-1?Q?R=F6=DFler"?= <...>' nicht
             korrekt decodiert).

  Revision 1.35.2.68  2002/03/30 12:49:05  my
  MY:- Wir erzeugen ausgehend jetzt einen Header "X-XP-Version", der ein
       Duplikat der Mailerzeile enthlt. Eingehend wird dieser Header,
       sofern vorhanden, nach "MAILER:" zurckgeschrieben, ansonsten wie
       bisher einer der anderen Software-Header. Manahme, um von Clients
       wie UKAW berschriebene Software-Header zu retten.

  Revision 1.35.2.67  2002/03/29 22:46:10  my
  MY:- UUZ-Schalter "-client" fr eingehende Nachrichten implementiert
       (damit der korrekte Header "X-XP-NTP: 41" geschrieben wird).
       UUZ-Hilfeausgabe angepat.

  Revision 1.35.2.66  2002/03/29 16:37:31  my
  MY:- Text des letzten Commits vervollstndigt.

  Revision 1.35.2.65  2002/03/29 16:22:01  my
  MY:- Ausgehende MIME-Multipart-Nachrichten werden jetzt auch dann keiner
       Zeichensatzkonvertierung unterzogen, wenn der Header "CHARSET: ISO1"
       nicht vorhanden ist. Der Header "CHARSET: ISO1" verhindert aber
       (wie bisher) ebenfalls eine Zeichensatzkonvertierung.

  MY:- Eingehende MIME-Multipart-Nachrichten erhalten keinen Header
       "TYP: MIME" mehr (Kompatibilitt mit anderen XP-Versionen).

  MY:- Ein- wie ausgehende Nachrichten werden dann als MIME-Multipart-
       Nachrichten betrachtet, wenn sie einen entsprechenden Content-Type-
       Header *oder* den Header "TYP: MIME" (oder beides) tragen.

  MY:- Fix: Bei ausgehenden RFC-Nachrichten werden Headerzeilen jetzt
       *immer* vom IBM- in den ISO1-Zeichensatz konvertiert (vorher
       geschah dies nur, wenn der Header "CHARSET: ISO1" nicht vorhanden
       war).

  Revision 1.35.2.64  2002/03/29 15:29:50  my
  MY:- Support des Headers "U-Delivered-To" fr eingehende SMTP-Mails
       implementiert: Bei Angabe des Schalters "-UseEnvTo" (beim Netztyp
       RFC/Client zu aktivieren ber "D/B/E/N/Envelope-Header_auswerten")
       wird statt des SMTP-Headers "RCPT TO" die im (letzten) Header
       "U-Delivered-To" befindliche Mail-Adresse in den ZConnect-Header
       "EMP:" geschrieben. Falls zustzlich ein "(X-)Envelope-To"-Header
       vorhanden ist, hat dieser Vorrang.

  Revision 1.35.2.63  2002/03/13 23:05:41  my
  RB[+MY]:- Gesamte Zeichensatzdecodierung und -konvertierung entrmpelt,
            von Redundanzen befreit, korrigiert und erweitert:
            - Alle Decodier- und Konvertierroutinen in neue Unit
              MIMEDEC.PAS verlagert.
            - Nach RFC 1522 codierte Dateinamen in Attachments werden
              jetzt decodiert (XPMIME.PAS).
            - 'MimeIsoDecode' kann jetzt auch andere Zeichenstze als
               ISO-8859-1 konvertieren. Daher erfolgt bei nach RFC 1522
               codierten Headerzeilen im Anschlu an die qp- oder base64-
               Decodierung keine starre ISO-8859-1-Konvertierung mehr,
               sondern es wird der deklarierte Zeichensatz korrekt
               bercksichtigt.
            - Untersttzung fr Zeichenstze ISO-8859-15 und Windows-1252
              implementiert.

  Revision 1.35.2.62  2002/03/08 23:18:16  my
  MY:- Registrierungs-, Beta-, "ber OpenXP"- und sonstige Dialoge auf
       OpenXP/16 umgestellt und Copyright-Hinweise sowie Kontakte
       aktualisiert.

  RB:- Fix fr UUZ-Absturz bei "kaputten"  Reference-Headern (ohne
       schlieende spitze Klammern) korrigiert: String wird nicht mehr
       abgeschnitten, sondern es bleibt die volle Lnge erhalten.

  JG+MY:- Fix: MIME-Singlepart-Nachrichten vom Content-Type 'text/html'
          werden jetzt nicht mehr in den IBM-Zeichensatz konvertiert und
          daher bei Darstellung mit externen HTML-Viewern korrekt
          angezeigt. Andere Content-Types werden dann konvertiert, wenn
          einer der ISO-8859-Zeichenstze oder ein anderer von XP
          untersttzter Zeichensatz vorliegt, oder wenn der Nachrichten-
          teil keine Zeichensatzdeklaration enthlt (letzteres ist
          notwendig wegen diverser kaputter Outlook-Versionen, die keinen
          Charset-Header erzeugen).

  RB:- Fix: Bei "gefalteten" Headern wird beim "Entfalten" der
       Zeilenumbruch und die anschlieenden Leerzeichen jetzt nur noch
       durch *ein* Leerzeichen ersetzt.

  RB:- Fix fr RFC-1522-Codierung ("MIME in Headerzeilen verwenden"):
       'RFC1522form' codiert jetzt nicht mehr blind den gesamten String,
       sondern nur noch den Teil vom ersten bis zum letzten Wort, in dem
       ein Sonderzeichen vorkommt, das codiert werden mu (Annherung an
       Praxis von Mozilla und anderen).

  JG+MY:- Fix: Der Content-Type-Header wird jetzt auch bei ausgehenden
          MIME-Multipart-Postings nicht mehr entfernt, sofern ein
          Boundary-Header existiert (vorher war das nur dann der Fall,
          wenn die Nachricht Umlaute enthielt). Dadurch jetzt korrekter
          Versand von MIME-Multipart-Nachrichten auch in Newsgroups
          gewhrleistet.

  Revision 1.35.2.61  2002/01/11 23:05:54  mk
  - Fix: Endlosschleife bei kaputten Nachrichten

  Revision 1.35.2.60  2002/01/06 17:29:20  my
  MY:- Hilfeausgabe korrigiert und berarbeitet
  MY:- Ein paar CVS-Logs lesbarer gemacht

  Revision 1.35.2.59  2002/01/04 12:03:35  mk
  - implemented UseEnvTo

  Revision 1.35.2.58  2001/12/20 15:11:09  my
  MY:- Nur unwichtige Kosmetik

  Revision 1.35.2.57  2001/11/20 23:09:12  my
  MY:- Lizenz-Header aktualisiert

  Revision 1.35.2.56  2001/11/11 15:47:35  mk
  - range check error beseitigt

  Revision 1.35.2.55  2001/11/04 22:01:50  mk
  RB:- UTF-7 Support (dif from Andreas D. Bauer)

  Revision 1.35.2.54  2001/10/20 17:07:59  mk
  - support fuer CC-Header mit mehr als 255 Zeichen

  Revision 1.35.2.53  2001/09/16 21:19:27  mk
  - fixed fuer letzten checkin, uuz wieder compilierbar

  Revision 1.35.2.52  2001/09/11 12:07:31  cl
  - small fixes/adaptions for MIME support (esp. 3.70 compatibility).

  Revision 1.35.2.51  2001/09/09 03:01:04  mk
  - fixed crash in uuz with bad reference lines

  Revision 1.35.2.50  2001/08/11 22:43:51  mk
  - changed Pos() to cPos() when possible, saves additional 1000 Bytes ;)

  Revision 1.35.2.49  2001/08/11 22:17:53  mk
  - changed Pos() to cPos() when possible, saves 1814 Bytes ;)

  Revision 1.35.2.48  2001/08/11 13:12:17  mk
  - no stack checking in uuz

  Revision 1.35.2.47  2001/08/07 16:53:45  mk
  JG:- Ctrl-Z umwandeln

  Revision 1.35.2.46  2001/08/05 11:45:32  my
  - added new unit XPOVL.PAS ('uses')

  Revision 1.35.2.45  2001/07/08 21:34:01  my
  JG:- Fix: if sender<>'' then wrs(iifs(wab<>'','U-Sender: ','WAB: ')+sender)
       (prevents creation of wrong ABS headers when doing N/W/O with News)

  Revision 1.35.2.44  2001/07/08 15:21:57  mk
  - neue LFN/Windows-Erkennung aktiviert

  Revision 1.35.2.43  2001/07/01 23:04:16  mk
  - Fehler Base64-Dekodierung beseitigt
  - Routine DecodeBase64 von xpmime und uuz in typeform verlegt

  Revision 1.35.2.42  2001/06/09 18:41:53  mk
  - 32 Bit Teile entfernt

  Revision 1.35.2.41  2001/06/08 17:54:04  my
  JG:- Fixed last commit: if no split position is in the read
       buffer, routine aborts and splits line at current position

  Revision 1.35.2.40  2001/05/29 21:02:13  my
  JG:- Header longer than 255 characters are splitted correctly now
       (at the last " ", "," or ";" before pos 255 rather than exactly
       at pos 255).
  JG:- 'Xref' headers are not thrown away anymore

  Revision 1.35.2.39  2001/04/28 15:47:30  sv
  - Reply-To-All :-) (Reply to sender and *all* recipients of a message
                     simultaneously, except to own and marked addresses.
                     'Reply-To-Marked' also possible. Automatically
                     activated with <P>, <Ctrl-P> and <Shift-P> if not
                     disabled in Config and if more than one reply address
                     available after removal of dupes and invalid
                     addresses. ZConnect and RFC only.)
  - Changed C/O/N rsp. C/O/E for RTA (Reply-To-All) - removed "ask at
    Reply-To", added "User selection list" option.
  - Query upon first startup and after (first) creation of a ZConnect/RFC
    server if RTA shall be activated.
  - Bugfix: "Automatic PM archiving" didn't work if user had selected CC
    recipients in the send window with <F2> (sometimes XP even crashed).
  - When archiving PMs with <Alt-P>, headers EMP/KOP/OEM are not thrown
    away anymore.
  - OEM headers are read and stored in an internal list (needed for RTA
    and message header display).
  - All OEM headers are shown in the message header display now (rather
    than just the last).
  - DoSend: - When sending a mail to a CC recipient with a Stand-In/Reply-
              To address, the server of the Reply-To user is used (rather
              than the server of the 'original user').
            - When sending a reply to a 'unknown user' (not yet in user
              database) we try to catch the server from the message area
              where the replied message is stored upon creating the user
              (rather than using the 'default server' and unless the
              server can be determined through the path).
            - Fix: When sending a message to more than one user/newsgroup,
              the first user/newsgroup was indented by one character in
              the 'subject window'.
            - Limited CC recipients to 125 in the send window (instead of
              126 before).
  - All ASCII characters can be displayed in the online help now
    ("\axxx").

  Revision 1.35.2.38  2001/04/20 17:28:49  mk
  - misc updates

  Revision 1.35.2.37  2001/04/19 15:03:04  mk
  - -client

  Revision 1.35.2.36  2001/04/09 16:12:16  mk
  - MAILER: gross geschrieben

  Revision 1.35.2.35  2001/03/15 07:48:52  mw


  - UUCP-Filerequest: LFNs eingebaut.

  Revision 1.35.2.34  2001/01/30 10:01:20  mk
  - weitere arbeiten am Client-Modus

  Revision 1.35.2.33  2001/01/10 17:39:01  mk
  - client-Modus, unversandt, Ruecklaeufer ersetzen, VGA-Palette,
    UUZ und Bugfixes

  Revision 1.35.2.32  2001/01/07 15:41:00  mk
  - removed last patches (LFN)

  Revision 1.35.2.31  2001/01/05 09:31:33  mk
  - fehler in WAB-Handling behoben (teil 2)

  Revision 1.35.2.30  2001/01/05 09:25:28  mk
  - fehler in WAB-Handling behoben

  Revision 1.35.2.29  2001/01/01 22:03:03  mk
  - Dateien mit langen Dateinamen werden jetzt auch ohne
    Parameter lfn erstellt

  Revision 1.35.2.28  2001/01/01 21:01:15  mk
  - auf dest.bak pruefen

  Revision 1.35.2.27  2001/01/01 12:12:11  mk
  - verbesserte LFN-Untersttzung

  Revision 1.35.2.26  2001/01/01 01:09:11  mk
  - umbenennen des Zielfiles geht jetzt

  Revision 1.35.2.25  2000/12/31 15:02:05  mk
  - Backup von Zieldatei statt anhaengen

  Revision 1.35.2.24  2000/12/31 11:34:58  mk
  - nicht auf Zieldatei testen, sondern anhaengen

  Revision 1.35.2.23  2000/12/22 20:32:16  mk
  - fix fuer -client

  Revision 1.35.2.22  2000/12/19 22:09:54  mk
  RB:- Option -client implementiert

  Revision 1.35.2.21  2000/12/12 11:30:26  mk
  - FindClose hinzugefuegt

  Revision 1.35.2.20  2000/12/04 08:57:54  mk
  - Test, ob Zieldatei schon existiert

  Revision 1.35.2.19  2000/11/27 21:40:49  mk
  RB:- Trim in GetMsgId hinzugefuegt

  Revision 1.35.2.18  2000/10/18 21:37:34  mk
  - Typo in F-TO gefixt

  Revision 1.35.2.17  2000/10/18 20:05:16  mk
  - 312 wieder rausgenommen

  Revision 1.35.2.16  2000/10/18 08:49:38  mk
  - Switch -312 fuer XP Kompatibilitaetsmodus (F-TO -> X-XP-FTO)

  Revision 1.35.2.15  2000/10/15 08:51:59  mk
  - misc fixes

  Revision 1.35.2.14  2000/10/11 09:09:33  mk
  RB:- UTF-8 Unterstuetzung

  Revision 1.35.2.13  2000/10/06 08:37:28  sv
  - Spitze Klammern wurden bei eingehenden Cancels nicht entfernt

  Revision 1.35.2.12  2000/10/03 15:48:50  mk
  - Typo in UnQuotePrintable wegen doppeltem CRLF beseitigt

  Revision 1.35.2.11  2000/09/25 17:53:27  mk
  - Typ wird nicht mehr auf Binaer gesetzt, wenn Msg B64 codiert ist

  Revision 1.35.2.10  2000/09/21 16:18:31  mk
  RB:- (X-)-Envelope-To-Untersttzung
     - QP Decode fuer verschiedene Header
     - Zeilen lnger als 255 Zeichen werden nicht mehr abgeschnitten

  Revision 1.35.2.9  2000/09/12 12:41:59  fe
  1. Kleine Anpassung an Gatebau '97: Fido-To wird nicht mehr in der
     proprietaeren X-XP-FTO-Zeile, sondern in der Standard-Zeile F-TO
     untergebracht.  (X-XP-FTO wird aber weiterhin verarbeitet.)

  2. Kleine Anpassung an Gatebau '97: Fido-To wird auch aus und in
     RFC-Nachrichten konvertiert.  (X-Comment-To)

  3. Auch bei RFC wird bei oeffentlichen Antworten auf Nachrichten mit
     Fido-To eine Fido-To-Zeile erzeugt.  (Kleine Verbesserung fuer Leute,
     die mit RFC-Technik in Fido-Foren schreiben.)

  Revision 1.35.2.8  2000/09/08 11:15:04  sv
  - Fix (begin...end-Block vergessen)

  Revision 1.35.2.7  2000/09/07 12:56:53  sv
  - Cancelerstellung ueberarbeitet

  Revision 1.35.2.6  2000/08/28 23:15:00  mk
  - Unit LFN als letze Unit in Uses eingetragen, um FindFirst/FindNext
    usw. LFN-faehig zu machen; das muss bei den anderen Units noch
    nachgeholt werden

  Revision 1.35.2.5  2000/08/28 22:52:06  mk
  - LFN-Unterstuetzung freigeschaltet

  Revision 1.35.2.4  2000/08/25 22:25:15  mk
  - Update auf aktuellere Typeform

  Revision 1.35.2.3  2000/07/26 14:00:58  mk
  - Bug bei Zugriff auf XEmpf[1] behoben

  Revision 1.35.2.2  2000/07/12 07:58:53  mk
  RB:- XPBoundary Default in SetMimeData

  Revision 1.35.2.1  2000/07/02 10:42:59  mk
  - pformstr entfernt

  Revision 1.35  2000/06/21 20:40:25  mk
  RB: - Bugfix fuer fortgesetzte Headerzeilen

  Revision 1.34  2000/06/10 20:15:09  sv
  - Bei ZConnect/RFC koennen jetzt Ersetzt-/Supersedes-Nachrichten
    versendet werden (mit Nachricht/Weiterleiten/Ersetzen)
  - ZConnectler koennen jetzt auch canceln :-)
  - Fix beim Canceln von Crosspostings

  Revision 1.33  2000/06/05 16:16:22  mk
  - 32 Bit MaxAvail-Probleme beseitigt

  Revision 1.32  2000/06/04 16:57:23  sv
  - Unterstuetzung von Ersetzt-/Supersedes-Nachrichten implementiert
    (RFC/ZConnect)
  - Cancel-Auswertung ueberarbeitet und fuer ZConnect implementiert
  - Schalter, der das Ignorieren von Ersetzt- und Cancelmails moeglich
    macht in C/O/N eingefuehrt
  - Anzeige beim Puffereinlesen leicht ueberarbeitet

  Revision 1.31  2000/06/03 17:53:03  mk
  CL: - Verbesserte Kompatibilitt mit RFC 822: Kommentare (selten,
        kommen aber vor) werden nun entfernt
  - Erkennung von User-Agent
  - Content-Disposition (RFC 2183) wird erzeugt.

  Revision 1.30  2000/05/16 15:20:32  hd
  - Kleinere, unvollstaendige Anpassungen (UnixFS)

  Revision 1.29  2000/05/13 15:39:51  mk
  - Crashes wegen Hugestring beseitigt

  Revision 1.28  2000/05/11 17:01:04  ml
  Fr linux: uppercase fr Parameter rausgenommen (Gro-/Kleinschreibung
  nicht mehr ignoriert) + string-Access-Violation beseitigt.

  Revision 1.27  2000/05/10 07:47:15  mk
  RB: X-* -> U-X-*

  Revision 1.26  2000/05/05 18:13:00  mk
  - einige Limits beseitigt

  Revision 1.25  2000/05/05 15:27:58  ml
  zpr und uuz wieder unter linux lauffhig (ncrt)

  Revision 1.24  2000/05/04 10:26:03  mk
  - UUZ teils auf HugeString umgestellt

  Revision 1.23  2000/05/03 07:31:02  mk
  - unter FPC jetzt auch compilierbar

  Revision 1.22  2000/05/03 00:21:19  mk
  - unbenutzte Units aus uses entfernt

  Revision 1.21  2000/05/02 19:13:58  hd
  xpcurses statt crt in den Units

  Revision 1.20  2000/04/29 20:54:07  mk
  - LFN Support in fsbox und 32 Bit, ISO2IBM->Typeform

  Revision 1.19  2000/04/21 18:31:43  mk
  - Assembler-Routinen konvertiert, versch. Fixes

  Revision 1.18  2000/04/18 11:23:47  mk
  - AnyFile in ffAnyFile ($3F->$20) ersetzt

  Revision 1.17  2000/04/13 12:48:32  mk
  - Anpassungen an Virtual Pascal
  - Fehler bei FindFirst behoben
  - Bugfixes bei 32 Bit Assembler-Routinen
  - Einige unkritische Memory Leaks beseitigt
  - Einge Write-Routinen durch Wrt/Wrt2 ersetzt
  - fehlende CVS Keywords in einigen Units hinzugefuegt
  - ZPR auf VP portiert
  - Winxp.ConsoleWrite provisorisch auf DOS/Linux portiert
  - Automatische Anpassung der Zeilenzahl an Consolengroesse in Win32

  Revision 1.16  2000/04/04 21:01:22  mk
  - Bugfixes fr VP sowie Assembler-Routinen an VP angepasst

  Revision 1.15  2000/03/25 18:46:59  ml
  uuz lauffhig unter linux

  Revision 1.14  2000/03/24 15:41:01  mk
  - FPC Spezifische Liste der benutzten ASM-Register eingeklammert

  Revision 1.13  2000/03/17 11:16:34  mk
  - Benutzte Register in 32 Bit ASM-Routinen angegeben, Bugfixes

  Revision 1.12  2000/03/16 20:24:12  rb
  Bug beim Erzeugen des Received-Headers behoben

  Revision 1.11  2000/03/16 10:14:24  mk
  - Ver32: Tickerabfrage optimiert
  - Ver32: Buffergroessen fr Ein-/Ausgabe vergroessert
  - Ver32: Keypressed-Routine laeuft nach der letzen nderung wieder

  Revision 1.10  2000/03/14 18:47:13  rb
  'programm' (=x-mailer etc.) von 40 auf 60 Zeichen verlngert

  Revision 1.9  2000/03/14 15:15:37  mk
  - Aufraeumen des Codes abgeschlossen (unbenoetigte Variablen usw.)
  - Alle 16 Bit ASM-Routinen in 32 Bit umgeschrieben
  - TPZCRC.PAS ist nicht mehr noetig, Routinen befinden sich in CRC16.PAS
  - XP_DES.ASM in XP_DES integriert
  - 32 Bit Windows Portierung (misc)
  - lauffaehig jetzt unter FPC sowohl als DOS/32 und Win/32

  Revision 1.8  2000/02/25 20:01:46  rb
  unbentigte Funktion und Variable ausgeklammert

  Revision 1.7  2000/02/25 19:07:08  rb
  Untersttzung von 'Priority:' und 'urgent' (incoming)

  Revision 1.6  2000/02/21 00:36:56  rb
  X-Priority Konvertierung verbessert

  Revision 1.5  2000/02/16 22:49:36  mk
  RB: * Verbesserte X-Priority Konvertierung

}
