{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 1991-1999 Peter Mandrella                                   }
{ (c) 2000-2001 OpenXP-Team                                       }
{ (c) 2002-2003 FreeXP, http://www.freexp.de                      }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/oldlicense.html.   }
{ --------------------------------------------------------------- }
{ $Id$ }

{ Deklarationen und diverse ausgelagerte Routinen fuer UUZ.PAS }

{$I XPDEFINE.INC }

unit uuz0;

interface  { ---------------------------------------------------------- }

uses  xpglobal,ems,dos,typeform,xpovl,fileio,montage,clip,mimedec,lfn;

const
      midlen      = 160;
      orglen      = 80;
      adrlen      = 238;       { Lnge Adresse (255-CRLF-"Diskussion-in: ") }
      realnlen    = 160;       { Lnge Realname }
      hderrlen    = 60;
      maxabs      = 50;
      maxreplyto  = maxabs;
      maxemp      = 125;
      maxkop      = maxemp;
      maxulines   = 60;        { max. zustzliche U-Zeilen }
      maxrefs     = 20;        { max. gespeicherte References }
      maxfollow   = 50;        { max. Followup-To-Zeilen }
      bufsize     = 16384;
      outbufsize  = 16384;
      BetreffLen  = 248;
      readempflist= true;
      postadrlen  = 80;
      telelen     = 60;
      homepagelen = 90;
      custheadlen = 60;
      maxaddhds   = 10;

      attrFile    = $0010;     { File Attach }
      AttrMPbin   = $0040;     { Multipart-Binary }
      attrReqEB   = $1000;     { EB anfordern }
      attrIsEB    = $2000;     { EB }
      AttrPmReply = $0100;     { PM-Reply auf AM (Maus/RFC) }
      AttrControl = $0020;     { Cancel-Nachricht }
      AttrQPC     = $0001;

      fPGP_encoded  = $0001;   { Nachricht ist PGP-codiert  }
      fPGP_avail    = $0002;   { PGP-Key vorhanden          }
      fPGP_signed   = $0004;   { Nachricht ist mit PGP sign.}
      fPGP_clearsig = $0008;   { Clear-Signatur             }
      fPGP_sigok    = $0010;   { Signatur war ok            }
      fPGP_sigerr   = $0020;   { Signatur war fehlerhaft    }
      fPGP_please   = $0040;   { Verifikations-Anforderung  }
      fPGP_request  = $0080;   { Key-Request                }
      fPGP_haskey   = $0100;   { Nachricht enthlt PGP-Key  }
      fPGP_comprom  = $0200;   { Nachricht enthlt compromise }

      nt_ZConnect = 2;
      nt_RFC      = 40;
      nt_Client   = 41;
      uncompress  = 'compress.exe -df ';
      unfreeze    = 'freeze.exe -dif ';
      ungzip      = 'gzip.exe -df ';
      SwapFileName= 'UUZ.SWP';
      UUserver    = 'UUCP-Fileserver';
      tspecials   = '()<>@,;:\"/[]?=';       { RFC2045-Special Chars }
      tspecials2  = tspecials+' ';           { RFC1341-Special Chars }
      BackupId    = 'X-Orig-';               { Prefix fr Backup-Header }
      Truncater   = '[...]';

      XpWindow    : byte = 0;

      ParSize     : boolean = false;         { Size negotiation }
      SMTP        : boolean = false;
      cSMTP       : boolean = false;         { compressed SMTP  }
      fSMTP       : boolean = false;         { frozen SMTP      }
      zsmtp       : boolean = false;         { GNU-Zipped SMTP  }
      MakeQP      : boolean = false;         { -qp: MIME-quoted-printable }
{ Envelope-Empfnger aus Received auslesen? }
      getrecenvemp: boolean = false;
      client      : boolean = false;         { -client (fr UKA* etc.) }
      gate        : boolean = false;         { ZConnect- bzw. externer Modus }
      noEuro      : boolean = false;         { #238 nach #101 statt #164 }
      UseEnvTo    : boolean = false;
      DelivToEnv  : boolean = false;         { Envelope-Empf. aus Delivered-To geholt }
      MailUser    : string[30] = 'mail';     { fr U-Zeile im X-File }
      NewsUser    : string[30] = 'news';
      FileUser    : string[30] = 'root';
      OwnSite     : string[60] = '';         { fr Empfngeradresse von Mails }
      Boxname     : string[20] = '';         { Boxname fr "X-XP-BOX:" }
      xpboundary  : string = '-';            { 06.01.2000 robo }
      shrinkheader: boolean = false;         { uz: r-Schalter }
      nomailer    : boolean = false;
      UseLFN      : boolean = false;

      tText       = 1;        { Content-Types: plain, richtext       }
      tMultipart  = 2;        { mixed, parallel, alternative, digest }
      tMessage    = 3;        { rfc822, partial, external-body       }
      tApplication= 4;        { octet-stream, postscript, oda        }
      tImage      = 5;        { gif, jpeg                            }
      tAudio      = 6;        { basic                                }
      tVideo      = 7;        { mpeg                                 }
      tModel      = 8;        { model                                }

      encBase64   = 1;        { Content-Transfer-Encodings           }
      encQP       = 2;        { quoted-printable                     }
      enc8bit     = 3;
      enc7bit     = 4;
      encBinary   = 5;

      { Die folgenden Konstanten definieren, an welcher Position }
      { im Array 'LongHdr' welcher lange dynamische ZC-Header    }
      { (bis 65500 Zeichen) steht.                               }

      LSub  =  1;        { 'BET'             }
      LPath =  2;        { 'ROT'             }
      LProg =  3;        { 'MAILER'          }
      LOrg  =  4;        { 'ORG'             }
      LPost =  5;        { 'Post'            }
      LTele =  6;        { 'Telefon'         }
      LHome =  7;        { 'U-X-Homepage'    }
      LKey  =  8;        { 'Stichwort'       }
      LSum  =  9;        { 'Zusammenfassung' }
      LGate = 10;        { 'X-Gateway'       }

  (*  LFile = 11;        { 'Datei'           }  *)
  (*  LBdry = 12;        { 'X-XP-Boundary'   }  *)

      LongHdrAnz = 10;   { Anzahl Header in 'LongHdr' }

      { Array fr lange dynamische unstrukturierte ZC-Header bis 65500 }
      { Zeichen, die in voller Lnge in den Puffer geschrieben werden  }

      LongHdr : array[1..LongHdrAnz] of record
                                          hdr   : LongHdrP;
                                          len   : word;
                                          rest  : string[4];
                                          trunc : boolean;
                                        end =
        (
         { 1}  (hdr: nil; len: 0; rest: ''; trunc: false),
         { 2}  (hdr: nil; len: 0; rest: ''; trunc: false),
         { 3}  (hdr: nil; len: 0; rest: ''; trunc: false),
         { 4}  (hdr: nil; len: 0; rest: ''; trunc: false),
         { 5}  (hdr: nil; len: 0; rest: ''; trunc: false),
         { 6}  (hdr: nil; len: 0; rest: ''; trunc: false),
         { 7}  (hdr: nil; len: 0; rest: ''; trunc: false),
         { 8}  (hdr: nil; len: 0; rest: ''; trunc: false),
         { 9}  (hdr: nil; len: 0; rest: ''; trunc: false),
         {10}  (hdr: nil; len: 0; rest: ''; trunc: false)
        );

type  OrgStr  = string[orglen];
      mimedata= record
                  mversion : string[10];     { MIME-Version              }
                  encoding : byte;           { Content-Transfer-Encoding }
                  ctype    : byte;           { Content-Type              }
                  subtype  : string[20];     { Content-Subtype           }
                  charset  : string[30];     { text/*; charset=...       }
                  filetype : string[20];     { application/o-s; type=... }
                  boundary : string[100];    { multipart: boundary=...   }
                end;

      mimeproc  = procedure(var s:string);

      { Fr Variablen, die die folgenden Array-Typen verwenden, mu }
      { via 'DummyMem' entsprechend Speicher reserviert werden!     }

      abslistp  = ^abslistt;
      abslistt  = array[1..maxabs] of record
                                        adr  : ^string;
                                        name : ^string;
                                      end;
      senderp   = ^sendert;
      sendert   = record
                    adr  : ^string;
                    name : ^string;
                  end;
      rtolistp  = ^rtolistt;
      rtolistt  = array[1..maxreplyto] of record
                                            adr  : ^string;
                                            name : ^string;
                                          end;
      empflistp = ^empflistt;
      empflistt = array[1..maxemp] of ^string;
      koplistp  = ^koplistt;
      koplistt  = array[1..maxkop] of record
                                        adr  : ^string;
                                        name : ^string;
                                      end;
      fuplistp  = ^fuplistt;
      fuplistt  = array[1..maxfollow] of ^string;

      { /bis hier }

      { Verkettete Liste fr RFC-U/X-Header }

      UlisteP = ^UlisteT;
      UlisteT = record
                  hdr   : LongHdrP;           { Header (bis 65500 Zeichen)  }
                  len   : word;               { Headerlnge                 }
                  rest  : string[4];          { max. 4 berhngende Zeichen }
                  trunc : boolean;            { Header ist abgeschnitten    }
                  Id    : ^string;            { RFC-Identifier              }
                  next  : UlisteP;
                end;

      SlisteP = ^SlisteT;                   { Verkettete Liste fr Strings  }
      SlisteT = record                      { (z.B. Keywords bei "uuz -zu") }
                  s    : ^string; 
                  next : SlisteP;
                end;

      empfnodep =^empfnode;
      empfnode  = record
                    next   : empfnodep;
                    empf   : string[adrlen];
                  end;

      header  = record
                  netztyp    : byte;
                  ulines     : byte;          { Anzahl "U-"-Zeilen }
                  lines      : longint;       { "Lines:" }
                  archive    : boolean;       { archivierte PM }
                  empfaenger : string[AdrLen];
                  kopien     : empfnodep;
                  xempf      : empflistp;
                  empfanz    : integer;       { Anzahl EMP:-Zeilen }
                  xoem       : empflistp;
                  oemanz     : integer;       { Anzahl OEM:-Zeilen }
                  xkop       : koplistp;
                  kopanz     : integer;       { Anzahl KOP:-Zeilen }
                  xabs       : abslistp;
                  absanz     : integer;       { Anzahl From:-Absender }
                  xsender    : senderp;
                  xreplyto   : rtolistp;
                  replytoanz : integer;       { Anzahl Antwort-an:-Zeilen }
                  followup   : fuplistp;
                  followups  : integer;       { Anzahl Diskussion-in:-Zeilen }
                  betreff    : string[BetreffLen];
                  absender   : string[AdrLen];
                  realname   : string[realnlen];
                  datum      : string[11];    { Netcall-Format }
                  zdatum     : string[22];    { ZConnect-Format }
                  pfad       : string;        { Netcall-Format }
                  msgid,ref  : string[midlen];{ ohne <> }
                  ersetzt    : string[midlen];{ ohne <> }
                  addrefs    : integer;
                  addref     : array[1..maxrefs] of string[midlen];
                  typ        : string[1];     { T / B }
                  crypttyp   : string[1];
                  groesse    : longint;
                  komlen     : longint;       { Kommentar-Lnge }
                  ckomlen    : longint;

                  programm   : string;        { Mailer-Name }
                  datei      : string[40];    { Dateiname }
                  ddatum     : string[22];    { Dateidatum, jjjjmmtthhmmss }
                  prio       : byte;          { 10=direkt, 20=Eilmail }
                  real_box   : string[20];    { falls Adresse = User@Point }
                  hd_point   : string[25];    { eigener Pointname }
                  pm_bstat   : string[20];    { Bearbeitungs-Status }
                  attrib     : word;          { Attribut-Bits }
                  filterattr : word;
                  fido_to    : string[36];
                  organisation: OrgStr;
                  postanschrift : string[PostAdrLen];
                  telefon    : string[TeleLen];
                  homepage   : string[HomepageLen];
                  PmReplyTo  : string[AdrLen];   { Antwort-an, nicht benutzt }
                  AmReplyTo  : string[AdrLen];   { Diskussion-in, nicht benutzt }
                  amrepanz   : integer;
                  error      : string[hdErrLen]; { ERR-Header }
                  ReplyPath  : string[8];
                  ReplyGroup : string[40];
                  wab        : string[AdrLen];   { Envelope-Absender }
                  oemlist    : empfnodep;
                  oem,oab    : string[AdrLen];   { oab/oar werden auch als }
                                                 { 'Zwischenlager' genutzt }
                  oar,war    : string[realnlen]; { Realnames }

                  gateway    : string[80];
                  empfbestto : string[AdrLen];
                  x_charset  : string[30];
                  keywords   : string[242];
                  summary    : string[236];
                  priority   : byte;             { Priority by MH }
                  distribution:string[40];
                  pm_reply   : boolean;
                  MIME       : mimedata;
                  QuoteString: string[20];
                  charset    : string[7];
                  ccharset   : string[7];
                  org_msgid  : string[midlen];
                  org_xref   : string[midlen];
                  pgpflags   : word;
                  pgp_uid    : string[80];
                  vertreter  : string[80];
                  XPointCtl  : longint;
                  nokop      : boolean;
                  boundary   : string[70];
                  mimetyp    : string[30];
                  mimereltyp : string[25];

                  { X-No-Archive Konvertierung }
                  xnoarchive : boolean;
                  Cust1,Cust2: string[custheadlen];
                  control    : string[150];
                  { Envelope-Empfnger }
                  envemp     : string[AdrLen];
                  xpmode     : string[20];

                end;
      charr   = array[0..65530] of char;
      charrp  = ^charr;
      ulinea  = array[1..maxulines] of string;

var   source,dest   : pathstr;       { Quell-/Zieldateien  }
      f1,f2         : file;          { Quell/Zieldatei     }
      u2z           : boolean;       { Richtung; mail/news }
      mails,news    : longint;       { Counter             }
      uuzstart      : datetimest;    { Uhrzeit UUZ-Start               }
      run_time      : real;          { Laufzeitberechnung              } 
      TotalSize     : real;          { Gre Quelldatei(en) in KB      }
      TotalMsgs     : longint;       { Anzahl bearbeiteter Nachrichten }
      buffer        : array[0..bufsize] of char;    { Kopierpuffer }
      bufpos,bufanz : integer;       { Leseposition / Anzahl Zeichen }
      hd            : header;
      empflist      : empfnodep;
      uline         : ^ulinea;
      uunumber      : word;          { fortlaufende Hex-Paketnummer }
      _from,_to     : string[20];    { UUCP-Systemnamen }
      outbuf        : charrp;
      outbufpos     : word;
      s             : String;
      MaxSlen       : longint;       { max. Lnge fr ReadString() }
      qprint,b64    : boolean;       { MIME-Content-TT's (ReadRFCheader) }
      addpath       : string;
      addhd         : array[1..maxaddhds] of string;
      addhdmail     : array[1..maxaddhds] of boolean;
      addhds        : integer;
      InReplyTo     : string[midlen];{ Letzte MsgID in 'In-Reply-To:' }
      convibm       : boolean;       { ist IBM, mu nach ISO }
      mpart         : boolean;       { ist MIME-Multipart }

      { ergnzende Variablen fr aktuelle Headerzeile ('HdrLine') }
      overflow      : boolean;    { Header > 65500 Zeichen? }
      truncated     : boolean;    { Header abgeschnitten?   }
      rest          : string[4];  { '?=' an Pos. 65500 oder 65501 behandeln }

      Ustart,
      Ulauf         : UlisteP;    { verkettete Liste fr RFC-U/X-Header }

      keystart,
      keylauf       : SListeP;    { verkettete Keyword-Liste }

const
      { Wird zum Einlesen der Customizable Headerlines bentigt }
      mheadercustom : array[1..2] of string[custheadlen] = ('','');

      { Dummy-Array zum Reservieren von minimalem Speicher fr bestimmte    }
      { relevante lange dynamische Header bis 65500 Zeichen:                }
      { Der Multiplikator gibt die Mindestanzahl der jeweiligen Variablen   }
      { an, fr die immer ausreichend Speicher zur Verfgung stehen mu     }
      { (fr hd.xkop steht also z.B. immer der Speicher fr mindestens 20   }
      { Adressen und 20 Realnames mit jeweils maximaler Variablenlnge zur  }
      { Verfgung). Fr hd.xoem wird Speicher fr nur 1 Adresse reserviert, }
      { weil in 'WriteHeader' hd.xempf ggf. auf hd.xoem kopiert wird und    }
      { wir danach nur noch den zustzlichen Speicher fr die Envelope-     }
      { Adresse in hd.xempf^[1] und das Array hd.xempf selbst bentigen.    }
      { Falls die Deklaration von 'empflistt' und der brigen entsprechen-  }
      { den Typen gendert werden sollte, ist darauf zu achten, da die     }
      { Berechnung des fr das Anlegen der Arrays mittels "new()" erforder- }
      { lichen Speicherplatzes ("((((4*maxemp)-1) div 8)*8) + 8)") ggf.     }
      { gendert werden mu (der von TP angeforderte Speicher ist immer ein }
      { Vielfaches von 8, deshalb diese Berechnung).                        }

      LEmp = 1;  { Position 'EMP:'           (hd.xempf)    in 'DummyMem' }
      LOem = 2;  { Position 'OEM:'           (hd.xoem)     in 'DummyMem' }
      LKop = 3;  { Position 'KOP:'           (hd.xkop)     in 'DummyMem' }
      LAbs = 4;  { Position 'ABS:'           (hd.xabs)     in 'DummyMem' }
      LWab = 5;  { Position 'WAB:'           (hd.xsender)  in 'DummyMem' }
      LAnt = 6;  { Position 'Antwort-an:'    (hd.xreplyto) in 'DummyMem' }
      LDis = 7;  { Position 'Diskussion-in:' (hd.followup) in 'DummyMem' }

      DummyAnz = 7;  { Anzahl Elemente in DummyMem }

      DummyMem : array[1..DummyAnz] of record
                                         memPtr : LongHdrP;
                                         memVal : word;
                                       end =
        (
         {1}  (memPtr: nil; memVal: 20*(((adrlen div 8)*8)+8)
                                  + ((((4*maxemp)-1) div 8)*8) + 8),
         {2}  (memPtr: nil; memVal:  1*(((adrlen div 8)*8)+8)
                                  + ((((4*maxemp)-1) div 8)*8) + 8), 
         {3}  (memPtr: nil; memVal: 20*((((adrlen div 8)*8)+8) +
                                        (((realnlen div 8)*8)+8))
                                  + (2*((((4*maxkop)-1) div 8)*8) + 8)),
         {4}  (memPtr: nil; memVal:  5*((((adrlen div 8)*8)+8) +
                                        (((realnlen div 8)*8)+8))
                                  + (2*((((4*maxabs)-1) div 8)*8) + 8)),
         {5}  (memPtr: nil; memVal:  1*((((adrlen div 8)*8)+8) +
                                        (((realnlen div 8)*8)+8))
                                  + (2*((((4*maxabs)-1) div 8)*8) + 8)),
         {6}  (memPtr: nil; memVal:  5*((((adrlen div 8)*8)+8) +
                                        (((realnlen div 8)*8)+8))
                                  + (2*((((4*maxkop)-1) div 8)*8) + 8)),
         {7}  (memPtr: nil; memVal: 20*(((adrlen div 8)*8)+8)
                                  + ((((4*maxfollow)-1) div 8)*8) + 8)
        );


procedure logo;
procedure HelpPage;
procedure error(s:string);
procedure GetPar;
procedure initvar;
procedure donevar;
procedure testfiles;
procedure fmove(var f1,f2:file);
function  RFC2Zdate(var s0:string):string;
function  ContainsUmlaut(const s:string):boolean;
procedure AddToEmpflist(empf:string);
procedure DisposeEmpflist(var list:empfnodep);
procedure DisposeKeywordList;
function  compmimetyp(typ:string):string;
procedure FlushOutbuf;
procedure wrfs(var s:Hugestring);
procedure allocMem;
procedure releaseMem(const n:byte);
procedure QuoteStr(var s:string; qspace:boolean);
procedure GetMimeVersion(var s:string);
procedure GetCTencoding(var s:string);
procedure GetContentType(var s:string);
procedure MimeAuswerten;
procedure RFC2047form;
procedure GetBinType(fn:pathstr);
procedure SetMimeData;
procedure setIBM2ISO;
procedure Charset2IBM;
procedure shell(prog:string; space:word);
function  uuztime:string;
function  get_time:datetimest;
function  time_diff(const t1,t2:datetimest):real;
function  strSecs(t:real):datetimest;
function  sizeKB(f:string):real;


implementation  { ----------------------------------------------------- }

procedure logo;
begin
  assign(output, '');
  rewrite(output);
  writeln;
  writeln('ZConnect <-> RFC/UUCP/SMTP Converter with MIME  (c) 1993-1999 Peter Mandrella');
  writeln(xp_display,'-Version ',verstr,betastr,'  ',x_copyright,
          ' by ',author_name,' <',author_mail,'>');
  writeln;
  writeln('"Enhanced UUZ" - improved RFC1036/2047/2822 compliance and long header support');
  writeln;
end;

procedure HelpPage;
begin
  writeln('UUZ -uz [Switches] <Source file(s)> <Destination file> [ownsite.domain]');
  writeln('UUZ -zu [Switches] <Source file> <Dest.Dir.> <fromSite> <toSite> [Number]');
  writeln;
  writeln('uz switches:  -UseEnvTo =  Get envelope recipient from Envelope header');
  writeln('                           ("Envelope-To:", "X-Envelope-To:", "Delivered-To:")');
  writeln('              -graberec =  Grab envelope recipient from "Received:" header');
  writeln('              -rfcMime  =  MIME decoding strictly according to RFC2047');
  writeln('              -client   =  Mode for net type RFC/Client');
  writeln('              -bBoxname =  Name of Serverbox (=> "X-XP-BOX:")');
  writeln;
  writeln('zu switches:  -s      =  Taylor UUCP size negotiation');
  writeln('              -SMTP   =  Batched SMTP (-c/f/zSMTP = compressed)');
  writeln('              -qp     =  MIME: quoted-printable (default: 8bit)');
  writeln('              -uUser  =  User to return error messages to');
  writeln('              -client =  Mode for net type RFC/Client');
  writeln('                         (creates one SMTP file per outgoing message)');
  writeln('              -gate   =  Mode for conversion of plain ZConnect messages');
  writeln('                         (checks message body for 8bit characters)');
  writeln('              -noEuro =  Disable OpenXP/16 Euro support');
  writeln;
  writeln('zu/uz:        -LFN    =  Support Long Filenames');
  halt(1);
end;

procedure error(s:string);
begin
  writeln('Fehler: ',s);
  halt(1);
end;

procedure GetPar;
var i      : integer;
    switch : string[10];
begin
  if (lstr(paramstr(1))<>'-uz') and (lstr(paramstr(1))<>'-zu') then
    HelpPage;
  if lstr(paramstr(1))='-uz' then begin
    if paramcount<3 then helppage;
    u2z:=true;
    source:=''; dest:=''; OwnSite:='';
    for i:=2 to paramcount do
      if left(paramstr(i),1)='-' then
      begin
        switch:=lstr(mid(paramstr(i),2));
        if left(switch,2)='w:' then
          XpWindow:=minmax(ival(mid(switch,3)),15,60) else
        { Envelope-Empfnger aus Received auslesen? }
        if switch='graberec' then
          getrecenvemp:=true else
        if switch='useenvto' then
          UseEnvTo:=true else
        if switch='lfn' then
        begin
          EnableLFN;
          UseLFN:=true;
        end else
        if switch='r' then
          shrinkheader:=true else
        if switch='rfcmime' then
          rfcMime:=true else
        if (switch='client') or (switch='ppp') then
          client:=true else
        if switch[1]='b' then
          boxname:=mid(paramstr(i),3);
      end
      else
        if source=''  then source:=ustr(paramstr(i)) else
        if dest=''    then dest:=ustr(paramstr(i)) else
        if OwnSite='' then OwnSite:=paramstr(i);
    end
  else begin
    u2z:=false;
    if paramcount<3 then helppage;
    source:=''; dest:=''; _from:=''; _to:='';
    for i:=2 to paramcount do
      if left(paramstr(i),1)='-' then
      begin
        switch:=lstr(mid(paramstr(i),2));
        if left(switch,2)='w:' then
          XpWindow:=minmax(ival(mid(switch,3)),15,60) else
        if switch='s' then ParSize:=true else
        if switch='smtp' then SMTP:=true else
        if switch='csmtp' then begin
          SMTP:=true; cSMTP:=true; end else
        if switch='fsmtp' then begin
          SMTP:=true; fSMTP:=true; end else
        if switch='zsmtp' then begin
          SMTP:=true; zSMTP:=true; end else
        if switch='qp' then
          MakeQP:=true else
        if (switch='client') or (switch='ppp') then begin
          SMTP:=true; client:=true; end else
        if switch='lfn' then
          EnableLFN else
        if switch='gate' then
          gate:=true else
        if switch='noeuro' then
          noEuro:=true else
        if switch[1]='u' then
        begin
          MailUser:=mid(paramstr(i),3);
          NewsUser:=Mailuser;
          FileUser:=MailUser;
        end;
      end
      else
        if source='' then source:=paramstr(i) else
        if dest=''   then dest:=paramstr(i) else    { Ziel-*Verzeichnis* }
        if _from=''  then _from:=paramstr(i) else
        if _to=''    then _to:=paramstr(i) else
        uunumber:=hexval(paramstr(i));
    end;
  if exist('igate.exe') then nomailer:=true;
end;

procedure initvar;
var t : text;
    s : string;

  procedure rh(fn:pathstr; mail:boolean);
  begin
    if exist(fn) then begin
      assign(t,fn);
      reset(t);
      while not eof(t) and (addhds<maxaddhds) do begin
        readln(t,s);
        s:=trim(s);
        if s<>'' then
          if cpos(':',s)<3 then
            writeln('Warning: Illegal Line in '+fn+': "'+s+'"'#7)
          else begin
            inc(addhds);
            addhd[addhds]:=s;
            addhdmail[addhds]:=mail;
            end;
        end;
      close(t);
      end;
  end;

begin
  InitWinVersion;

  If (WinVersion = 3) or { Win 9x/ME/... }
     ((WinVersion = 4) and (lo(WinNTVersion)>=5)) then { Win 2k/XP/... }
  begin
    EnableLFN;
    UseLfn := true;
  end;

  mails:=0; news:=0;
  run_time:=0;
  TotalSize:=0;
  TotalMsgs:=0;
  uunumber:=0;
  MaxSlen:=255;
  getmem(outbuf,outbufsize);

  if exist('ADDPATH') then begin    { ADDPATH: Zusatz fr Pfadzeile }
    assign(t,'ADDPATH');
    reset(t);
    readln(t,ADDPATH);
    close(t);
    if (addpath<>'') and (lastchar(addpath)<>'!') then
      addpath:=addpath+'!';
    end
  else
    addpath:='';

  addhds:=0;                        { zustzliche Headerzeilen einlesen }
  rh('NEWS.RFC',false);
  rh('MAIL.RFC',true);
end;

procedure donevar;
begin
  freemem(outbuf,outbufsize);
end;

procedure testfiles;
begin
  if not exist(source) then error('Quelldatei fehlt');
  if u2z and not validfilename(dest) then
    error('ungltige Zieldatei: '+dest);
  if not u2z then begin
    if (right(dest,1)<>':') and (right(dest,1)<>'\') then
      dest:=dest+'\';
    if not IsPath(dest) then
      error('ungltiges Zielverzeichnis: '+dest);
    end;
end;

procedure fmove(var f1,f2:file);
var rr : word;
begin
  while not eof(f1) do begin
    blockread(f1,buffer,bufsize,rr);
    blockwrite(f2,buffer,rr);
    end;
end;


{ Datumsformate:         11 Jan 92 01:02 GMT
                    Mon, 11 Jan 1992 01:02:03 GMT
                    Mon Jan 11, 1992 01:02:03 XYZ  }

function RFC2Zdate(var s0:string):string;
const tzones = 52;
      tzone  : array[0..tzones-1,0..1] of string[7] =
               (('GMT','W+0'),('MST','W-7'),('MET','W+1'),('CET','W+1'),
                ('MEST','S+2'),('MES','S+2'),('MESZ','S+2'),
                ('NT','W-11'),('AHST','W-10'),('YST','W-9'),('PST','W-8'),
                ('PDT','S-7'),('CST','W-6'),('MDT','S-6'),
                ('EST','W-5'),('CDT','S-5'),('AST','W-4'),('EDT','S-4'),
                ('NST','W-3:30'),('GST','W-3'),('ADT','S-3'),('AT','W-2'),
                ('WAT','W-1'),('UT','W+0'),('Z','W+0'),('BST','S+1'),
                ('MEWT','W+1'),('SWT','W+1'),
                ('FWT','W+1'),('HFH','W+1'),('EET','W+2'),
                ('SST','S+2'),('FST','S+2'),('HFE','S+2'),('BT','W+3'),
                ('ZP4','W+4'),('ZP5','W+5'),('IST','W+5:30'),('ZP6','W+6'),
                ('WAST','W+7'),('JT','W+7:30'),('WADT','S+8'),('CCT','W+8'),
                ('JST','W+9'),('CAST','W+9:30'),('SAST','W+9:30'),
                ('EAST','W+10'),('CADT','S+10:30'),('SADT','S+10:30'),
                ('NZT','W+12'),('NZST','W+12'),('NZDT','S+13'));

var p,p2  : byte;
    t,m,j : word;
    h,min,s : integer;
    ti    : datetimest;
    zone  : string[10];
    i     : integer;

  function getstr:string;
  var p : byte;
  begin
    p:=cpos(' ',s0); if p=0 then p:=cpos(#9,s0);
    if p=0 then begin
      getstr:=s0; s0:='';
      end
    else begin
      getstr:=left(s0,p-1);
      s0:=trim(mid(s0,p+1));
      end;
  end;

  procedure CorrTime;           { Zonenoffset zu Zeit addieren }
  var res     : integer;
      off,moff: integer;
      p       : byte;
  begin
    val(copy(ti,1,2),h,res);
    val(copy(ti,4,2),min,res);
    val(copy(ti,7,2),s,res);
    p:=cpos(':',zone);
    if p=0 then begin
      off:=minmax(ival(mid(zone,2)),-13,13);
      moff:=0;
      end
    else begin
      off:=minmax(ival(copy(zone,2,p-2)),-13,13);
      moff:=minmax(ival(mid(zone,p+1)),0,59);
      end;
    zone:=left(zone,2)+formi(abs(off),2)+iifs(moff<>0,':'+formi(moff,2),'');
    dec(min,sgn(off)*moff);
    dec(h,off);
    while min<0  do begin  inc(min,60); dec(h); end;
    while min>59 do begin  dec(min,60); inc(h); end;
    while h<0    do begin  inc(h,24);   dec(t); end;
    while h>23   do begin  dec(h,24);   inc(t); end;
    if t<1 then begin
      dec(m);
      if m=0 then begin m:=12; dec(j); end;
      schalt(j);
      t:=monat[m].zahl;
      end
    else begin
      schalt(j);
      if t>monat[m].zahl then begin
        t:=1; inc(m);
        if m>12 then begin m:=1; inc(j); end;
        end;
      end;
  end;

begin
  p:=cpos(',',s0);
  p2:=cpos(' ',s0);
  if p>0 then
    if (p2=0) or (p2>p) then
      s0:=trim(mid(s0,p+1))   { Mon, 11 Jan ...   Wochentag killen }
    else begin                { [Mon ]Jan 11, ... }
      p2:=p-1;
      while s0[p2]<>' ' do dec(p2);
      s0:=copy(s0,p2+1,p-p2-1)+' '+copy(s0,max(1,p2-3),3)+' '+trim(mid(s0,p+1));
      end;
  t:=minmax(ival(getstr),1,31);
  p:=pos(lstr(getstr),'janfebmaraprmayjunjulaugsepoctnovdec');
  if p>0 then m:=(p+2)div 3 else m:=1;
  j:=minmax(ival(getstr),0,2099);
  if j<100 then
    if j<70 then inc(j,2000)   { 2stellige Jahreszahl ergnzen }
    else inc(j,1900);
  ti:=getstr;
  if cpos(':',ti)=0 then
    if length(ti)=4 then ti:=left(ti,2)+':'+right(ti,2)+':00'  { RFC 822 }
    else ti:='00:00:00';
  zone:=getstr;
  if zone='' then zone:='W+0'
  else if (zone[1]='+') or (zone[1]='-') then begin
    zone:='W'+left(zone,3)+':'+copy(zone,4,2);
    if lastchar(zone)=':' then zone:=zone+'00';
    end
  else begin
    UpString(zone);
    i:=0;
    while (i<tzones) and (zone<>tzone[i,0]) do inc(i);
    if i=tzones then zone:='W+0'
    else zone:=tzone[i,1];
    end;
  CorrTime;
  RFC2Zdate:=formi(j,4)+formi(m,2)+formi(t,2)+formi(h,2)+formi(min,2)+
             formi(s,2)+zone;
end;

function ContainsUmlaut(const s:string):boolean; assembler;
asm
           push  ds
           cld
           lds   si,s
           lodsb
           mov   cl,al
           mov   ch,0
           jcxz  @cu_ende
@cu_loop:  lodsb
           or    al,al
           js    @cu_found
           loop  @cu_loop
           jmp   @cu_ende
@cu_found: mov   cx,1
@cu_ende:  mov   ax,cx
           pop   ds
end;


{ --- ZConnect-Header verarbeiten ----------------------------------- }

procedure AddToEmpflist(empf:string);
var p : empfnodep;
begin
  p:=@empflist;
  while p^.next<>nil do p:=p^.next;
  new(p^.next);
  p^.next^.next:=nil;
  p^.next^.empf:=empf;
end;

procedure DisposeEmpflist(var list:empfnodep);
var p : empfnodep;
begin
  while list<>nil do begin
    p:=list^.next;
    dispose(list);
    list:=p;
    end;
end;

{ my: Keyword-Liste und Speicher freigeben   12/2002 }

procedure DisposeKeywordList;
begin
  while assigned(keystart) do
  begin
    keylauf:=keystart^.next;
    freemem(keystart^.s,length(keystart^.s^)+1);
    dispose(keystart);
    keystart:=keylauf;
  end;
end;

function compmimetyp(typ:string):string;
begin
  if left(typ,12)='application/' then
    compmimetyp:=lstr(mid(typ,12))
  else
    compmimetyp:=lstr(typ);
end;

procedure FlushOutbuf;
begin
  if outbufpos>0 then
    blockwrite(f2,outbuf^,outbufpos);
  outbufpos:=0;
end;

procedure wrfs(var s:Hugestring);
begin
  if outbufpos+length(s)>=outbufsize then
    FlushOutbuf;
  FastMove(s[1],outbuf^[outbufpos],length(s));
  inc(outbufpos,length(s));
end;


{ --- UUCP/RFC -> ZConnect ------------------------------------------ }

{ my: Speicherminimum fr alle dynamischen ZC-Adressen-Header reservieren }
{     [1]=xempf,    [2]=xoem,     [3]=xkop,     [4]=xabs,                 }
{     [5]=xsender,  [6]=xreplyto, [7]=followup                            }

procedure allocMem;
var memVal : longint;
         i : byte;
begin
  memVal:=0;
  for i:=1 to DummyAnz do
    if DummyMem[i].memPtr=nil then
      memVal:=memVal+longint(DummyMem[i].memVal);
  if maxavail<memVal then
  begin
    writeln('Could not allocate sufficient memory for dynamic arrays - conversion halted.');
    halt(1);
  end;
  for i:=1 to DummyAnz do
    if DummyMem[i].memPtr=nil then
      getmem(DummyMem[i].memPtr,DummyMem[i].memVal);
end;


{ my: Reserviertes Speicherminimum fr einzelnen      }
{     dynamischen ZC-Adressen-Header wieder freigeben }

procedure releaseMem(const n:byte);
begin
  if DummyMem[n].memPtr<>nil then
  begin
    freemem(DummyMem[n].memPtr,DummyMem[n].memVal);
    DummyMem[n].memPtr:=nil;
  end;
end;


{ --- MIME ---------------------------------------------------------- }

{ Content-Types:  text        plain            charset=us-ascii
                              richtext                 iso-8859-x

                  multipart   mixed, parallel  boundary=...
                              alternative        "
                              digest             "

                  message     rfc822
                              partial          number=  total=  id=
                              external-body    access-type=  size= ...

                  application octet-stream     name= type= conversions=
                              postscript, oda    x-date=

                  image       gif, jpeg        x-filename=  x-date=
                  audio       basic
                  video       mpeg

  MIMEdata      : mversion : string[10];     MIME-Version
                  encoding : byte;           Content-Transfer-Encoding
                  ctype    : byte;           Content-Type
                  subtype  : string[20];     Content-Subtype
                  charset  : string[30];     text/*; charset=...
                  filetype : string[20];     application/o-s; type=...
                  boundary : string[100];    multipart; boundary=...   }


procedure QuoteStr(var s:string; qspace:boolean);   { Quoting erzeugen }
var p : byte;
begin
  if (qspace and multipos(tspecials2,s)) or
     (not qspace and multipos(tspecials,s)) then begin
    for p:=length(s) downto 1 do
      if s[p] in ['"','\'] then insert('\',s,p);
    s:='"'+s+'"';
    end;
end;


procedure GetMimeVersion(var s:string);
begin
  hd.mime.mversion:=s;
end;

procedure GetCTencoding(var s:string);
begin
  LoString(s);
  with hd.mime do
    if s='7bit' then encoding:=enc7bit else
    if s='8bit' then encoding:=enc8bit else
    if s='quoted-printable' then encoding:=encQP else
    if s='base64' then encoding:=encBase64 else
    if s='binary' then encoding:=encBinary
    else encoding:=enc8bit;       { Default: 8bit }
end;


procedure GetContentType(var s:string);
var p     : byte;
    s1    : string[30];
    value : string;

  procedure SkipWhitespace;
  begin
    inc(p);
    while (p<=length(s)) and (s[p] in [' ',#9]) do inc(p);    { whitespaces berlesen }
    delete(s,1,p-1);
    p:=1;
  end;

  function filename:string;
  var p : byte;
  begin
    p:=length(value);
    while (p>0) and not (value[p] in ['/','\']) do dec(p);
    filename:=mid(value,p+1);
  end;

begin
  with hd.mime do begin
    p:=1;
    while (p<=length(s)) and not (s[p] in ['/',' ',#9]) do inc(p);
    s1:=lstr(left(s,p-1));
    if s1='text'        then ctype:=tText else    { --- Type }
    if s1='application' then ctype:=tApplication else
    if s1='multipart'   then ctype:=tMultipart else
    if s1='message'     then ctype:=tMessage else
    if s1='image'       then ctype:=tImage else
    if s1='audio'       then ctype:=tAudio else
    if s1='video'       then ctype:=tVideo else
    if s1='model'       then ctype:=tModel
    else ctype:=tApplication;     { Default: Application }
    while (p<=length(s)) and (s[p]<>'/') do inc(p)  ;   { / suchen }
    SkipWhitespace;
    if s<>'' then
    begin
      while (p<=length(s)) and not (s[p] in [';',' ',#9]) do inc(p);
      subtype:=lstr(left(s,p-1));       { --- Subtype  }
      if p>1 then delete(s,1,p-1);
      repeat                            { --- Parameter }
        p:=1;
        while (p<=length(s)) and (s[p]<>';') do inc(p);
        SkipWhitespace;
        if s<>'' then begin
          while (p<=length(s)) and (s[p]<>'=') do inc(p);
          s1:=lstr(trim(left(s,p-1)));
          SkipWhitespace;
          if s<>'' then begin
            if s[1]='"' then
              repeat inc(p) until (p=length(s)) or (s[p]='"')
            else
              repeat inc(p) until (p=length(s)) or (s[p]<=' ');
            value:=trim(left(s,p));
            if lastchar(value)=';' then
              dellast(value);
            inc(p);
            RFC2822_Remove(value,false);
            case ctype of
              tText       : if s1='charset'   then charset:=lstr(value);
              tApplication: if s1='name'      then hd.datei:=filename else
                            if s1='type'      then filetype:=value else
                            if s1='x-date'    then hd.ddatum:=RFC2Zdate(value);
              tMultipart  : if s1='boundary'  then boundary:=value;
              tMessage    : ;
              else          if s1='x-filename'then hd.datei:=value else
                            if s1='x-date'    then hd.ddatum:=RFC2Zdate(value);
            end;
          end;
        end;
      until s='';
      end;
    if subtype='' then
      case ctype of
        tText        : subtype:='plain';
        tApplication : subtype:='octet-stream';
        tMultipart   : subtype:='mixed';
        tMessage     : subtype:='rfc822';
      end;
    { my: Default-Charset auf 'ISO-8859-1' gendert. Wenn wir }
    {     bei Nachrichten ganz ohne Content-Type-Header wegen }
    {     des bekannten OE-Verhaltens von ISO1 ausgehen, dann }
    {     ist es unlogisch, wenn wir bei Content-Type-Headern }
    {     ohne Charset-Parameter von 'us-ascii' ausgehen.     }
    if (ctype=tText) and (charset='') then
      charset:=CharsetName(cs_iso8859_1);
    end;
end;


procedure MimeAuswerten;
var ismime : boolean;
    binary : boolean;
begin
  with hd.mime do begin
    (* ignore presence of MIME-Version due to robustness principle *)
    ismime:=true;
    qprint:=ismime and (encoding=encQP);
    b64:=ismime and (encoding=encBase64);
    binary:=ismime and (not (ctype in [tText,tMultipart,tMessage]) or
                        ((encoding=encBinary) and (ctype<>tText)));
    hd.typ:=iifc((binary or b64) and (ctype<>tText),'B','T');
    charset:=LStr(charset);
    if (ctype=tText) and not supported_charset(charset) then
      hd.error:='Unsupported character set: '+charset;
    end;
end;


{ evtl. s mit quoted-printable codieren }

procedure RFC2047form;
var p,p1,p2 : integer;
    encoded : boolean;
    cs      : String[30];
begin
  if not noEuro and (cpos(#164,s)>0) then
    cs:=CharsetName(cs_iso8859_15)
  else
    cs:=CharsetName(cs_iso8859_1);
  p1:=0;
  p2:=0;
  for p:=1 to length(s) do
    if s[p]>#127 then
      if p1=0 then
      begin
        p1:=p;
        p2:=p;
      end
      else p2:=p;
  if p1=0 then
  begin
    p1:=1;
    p2:=length(s);
  end
  else begin
    p:=posn(' ',reverse(s),length(s)-p1+1);
    if p=0 then p1:=1 else p1:=length(s)-p+2;
    p:=posn(' ',s,p2);
    if p=0 then p2:=length(s) else p2:=p-1;
  end;
  p:=p1;
  { wenn =? und ?= von Hand in den Header geschrieben wurden, mssen
    sie codiert werden: }
  encoded:=(pos('=?',copy(s,p1,p2-p1+1))>0) and
           (pos('?=',copy(s,p1,p2-p1+1))>0);
  while p<=p2 do                 { qp-Codierung }
  begin
    if s[p]>=#127 then
    begin
      insert(hex(ord(s[p]),2),s,p+1);
      s[p]:='=';
      inc(p,2);
      inc(p2,2);
      encoded:=true;
    end
    else if s[p]='=' then s[p]:=#255;
    inc(p);
  end;
  if encoded then
  begin
    p:=p1;
    while p<=p2 do               { qp-Codierung }
    begin
      if s[p]=' ' then
        s[p]:='_'
      else
        if (s[p] in [#255,'?','_']) then
        begin
          if s[p]=#255 then s[p]:='=';
          insert(hex(ord(s[p]),2),s,p+1);
          s[p]:='=';
          inc(p,2);
          inc(p2,2);
        end;
      inc(p);
    end;
    insert('?=',s,p2+1);
    insert('=?'+cs+'?Q?',s,p1);
  end
  else
    for p:=1 to length(s) do
      if s[p]=#255 then s[p]:='=';
end;


procedure GetBinType(fn:pathstr);    { vgl. MAGGI.PAS }
var p   : byte;
    ext : string[6];
    t   : text;
    s   : string;
begin
  with hd.mime do begin
    ctype:=tApplication;
    subtype:='octet-stream';
    p:=rightpos('.',fn);
    if p>0 then begin
      ext:=mid(fn,p+1);
      assign(t,'mimetyp.cfg');
      reset(t);
      if ioresult=0 then begin
        while not eof(t) do begin
          readln(t,s);
          if (s<>'') and (firstchar(s)<>'#') and
             stricmp(ext,GetToken(s,'=')) then
            GetContentType(s);
          end;
        close(t);
        end;
      end;
    end;
end;


procedure SetMimeData;
var
  i: Integer;
begin
  xpboundary := '----=_NextPart_';
  mpart:=false;
  for i := 1 to 10 + random (20) do
    xpboundary := xpboundary + char (random (25) + byte ('A'));
  with hd,hd.mime do begin
    mversion:='1.0';
    if typ='M' then
    begin
      mpart:=true;
      encoding:=enc8bit;               { my: Multiparts immer 8bit!         }
    end;                               {     (Body checken dauert zu lange) }
    if typ='T' then
    begin
      if (x_charset='') or
         (lstr(x_charset)=lstr(CharsetName(cs_us_ascii))) then
        encoding:=enc7bit
      else
        if MakeQP then encoding:=encQP
      else
        encoding:=enc8bit;
      if noEuro and (lstr(x_charset)=lstr(CharsetName(cs_iso8859_15))) then
        x_charset:=CharsetName(cs_iso8859_1);

      { multipart/mixed outgoing }

      if left(mimetyp,10)='multipart/' then
      begin
        mpart:=true;
        ctype:=tMultipart;
        subtype:=mid(mimetyp,11);
        xpboundary:=hd.boundary;
        encoding:=enc8bit;             { my: Multiparts immer 8bit!         }
      end                              {     (Body checken dauert zu lange) }
      else begin
        ctype:=tText;
        subtype:='plain';
      end;
    end

    else if attrib and AttrMPbin <> 0 then
    begin
      mpart:=true;
      ctype:=tMultipart;
      subtype:='mixed';
      encoding:=enc7bit;  { my: Hier ist 7bit OK (reines binary)! }
    end
    else begin
      encoding:=encBase64;
      if datei='' then
      begin
        ctype:=tApplication;
        subtype:='octet-stream';
      end
      else
        GetBinType(datei);
    end;
    if not mpart then
      if not convibm then
        charset:=CharsetName(ival(mid(hd.charset,4)))
      else
        charset:=iifs(x_charset='',CharsetName(cs_us_ascii),x_charset);
  end;
end;


procedure setIBM2ISO;
begin
  if not iso15 then           { ISO1 }
  begin
    IBM2ISOtab[171]:=189;
    IBM2ISOtab[172]:=188;
    IBM2ISOtab[euro]:=101;
  end
  else begin                  { ISO15 }
    IBM2ISOtab[171]:=46;
    IBM2ISOtab[172]:=46;
    IBM2ISOtab[euro]:=164;
  end;
end;


procedure Charset2IBM;
begin
  with hd.mime do
  begin
    if mpart or (subtype='html') then exit;
    CharsetToIBM(charset,s);
  end;
end;

{ --- Shell --------------------------------------------------------- }

procedure shell(prog:string; space:word);  { Externer Aufruf }
{$ifndef ver55}
  const freeptr : pointer = nil;
{$endif}
type so = record
            o,s : word;
          end;
var regs  : registers;
    p     : pointer;
    fs    : word;
    brk   : boolean;
    paras : word;            { belegte Paragraphs von M2  }
    free  : word;            { freie Paras nach Set Block }
    envir : array[0..1023+18] of byte;    { neues Environment }
    dpath : pathstr;
    para  : string;
    pp    : byte;
    sm2t  : boolean;

    swapfile : file;
    swappars : word;        { auszulagernde Paragraphen }
    EMShandle: word;        { EMS-Handle, oder 0        }
    heapfree : word;
    swapok   : boolean;


  function memfree:word;
  var regs : registers;
  begin
    with regs do begin
      ah:=$48;                { Test, ob residentes Prog. geladen }
      bx:=$ffff;
      msdos(regs);
      memfree:=bx;
      end;
  end;

  procedure SwapOut(swapp,count:word);
  var page,spar,rr : word;
  begin
    if EmsAvail>=count div 1024 +1 then
    begin
      EMSAlloc(count div 1024+1,EMShandle);
      page:=0;
      repeat
        EmsPage(EMShandle,0,page);
        if count>=1024 then spar:=1024
        else spar:=count;
        FastMove(mem[swapp:0],mem[emsbase:0],spar*16);
        inc(swapp,spar);
        dec(count,spar);
        inc(page);
      until count=0;
      swapok:=true;
      end
    else begin
      EmsHandle:=0;
      assign(swapfile,SwapFileName);
      rewrite(swapfile,1);
      repeat
        blockwrite(swapfile,mem[swapp:0],min(count,$ff0)*16,rr);
        if (count>0) and (rr=0) then
          inoutres:=101;
        inc(swapp,rr div 16);
        dec(count,rr div 16);
      until (count=0) or (inoutres<>0);
      close(swapfile);
      if inoutres=0 then
        setfattr(swapfile,readonly);
      swapok:=inoutres=0;
      if not swapok then begin
        error('Fehler beim Speicherauslagern!');
        if existf(swapfile) then erase(swapfile);
        end;
      end;
  end;

  procedure SwapIn(swapp,count:word);
  var rr,page,spar : word;
  begin
    if emshandle<>0 then begin
      page:=0;
      repeat
        EmsPage(EMShandle,0,page);
        if count>=1024 then spar:=1024
        else spar:=count;
        FastMove(mem[emsbase:0],mem[swapp:0],spar*16);
        inc(swapp,spar);
        dec(count,spar);
        inc(page);
      until count=0;
      EmsFree(EMShandle);
      end
    else begin
      setfattr(swapfile,0);
      reset(swapfile,1);
      if ioresult<>0 then error('SWAP-File nicht mehr vorhanden!');
      { swapp:=so(heapptr).s-swappars+2; count:=swappars; }
      repeat
        blockread(swapfile,mem[swapp:0],min(count,$ff0)*16,rr);
        inc(swapp,rr div 16);
        dec(count,rr div 16);
      until (count=0) or (rr=0) or (inoutres<>0);
      if (count<>0) or (inoutres<>0) then
        error('Fehler beim Lesen des SWAP-Files');
      close(swapfile);
      erase(swapfile);
      end;
  end;

  { MK Funktion ist eigentlich sinnlos, rausnehmen ? }
{
  procedure geterrorlevel;
  var
    regs : registers;
  begin
    errorlevel:=lo(dosexitcode);
    if errorlevel=0 then begin
      regs.ah:=$4d;
      msdos(regs);
      errorlevel:=regs.al;
      end;
  end;
}

begin
  doserror:=0;
  if maxavail<$8000 then
    writeln('Zu wenig freier Speicher fr externen Programmaufruf!')
  else
  begin
    pp:=cpos(' ',prog);
    if pp=0 then para:=''
    else begin
      para:=' '+trim(copy(prog,pp+1,127));
      prog:=left(prog,pp-1);
      end;
    prog:=ustr(prog);

    {$IFDEF DPMI}
      exec(prog,para);
    {$ELSE}

      if so(freeptr).o>0 then          { Gre der Free-Liste ermitteln }
        fs:=$1000a-so(freeptr).o
      else
        fs:=0;
      if fs>0 then begin               { Freeliste sichern }
        getmem(p,fs);
        FastMove(freeptr^,p^,fs);
        end;


      paras:=memw[prefixseg:2]-prefixseg+1;
      space:=(space+1)*64;   { KB -> Paragraphs, + 1 extra-KB }
      heapfree:=prefixseg+paras-so(heapptr).s;
      swapok:=true;
      if (heapfree>=space) or (so(heapptr).s-ovrheaporg<64) then
        swappars:=0
      else begin
        swappars:=min(space-heapfree,so(heapptr).s-ovrheaporg-2);
        SwapOut(so(heapptr).s-swappars+2,swappars);
        end;

      if swapok then begin
        with regs do begin
          ah:=$4a;          { set block }
          bx:=so(heapptr).s+3-prefixseg-swappars;
          es:=prefixseg;
          msdos(regs);                   { Speicher freigeben }
          end;
        free:=memfree;

        if (cpos('|',para)>0) or (cpos('>',para)>0) or (cpos('<',para)>0) then
          dpath:=''
        else begin
          if exist(prog) then dpath:=prog
          else dpath:=UStr(fsearch(prog,getenv('PATH')));
          if (right(dpath,4)<>'.EXE') and (right(dpath,4)<>'.COM') then
            dpath:='';
          end;
        swapvectors;
        if (para<>'') and (para[1]<>' ') then para:=' '+para;
        if dpath<>'' then
          exec(dpath,para)
        else
          exec(getenv('comspec'),' /c '+prog+iifs(para<>'',para,''));
        swapvectors;
{        geterrorlevel; }

        with regs do begin
          ah:=$4a;                { Speicherblock wieder herstellen }
         { bx:=paras;  - klappt nicht bei DR-DOS 3.41 }
          bx:=$ffff;
          es:=prefixseg;
          msdos(regs);
          ah:=$4a;
          es:=prefixseg;
          msdos(regs);
          end;

        if swappars>0 then SwapIn(so(heapptr).s-swappars+2,swappars);
        end;  { is swapok }

      if fs>0 then begin
        FastMove(p^,freeptr^,fs);
        freemem(p,fs);
        end;

    {$ENDIF}    { not DPMI }

    if doserror<>0 then
      error('Fehler '+strs(doserror)+' bei Programm-Aufruf');
    end;
end;


{ Erstelldatum von UUZ.EXE als String bergeben }
{ Format: 1105001824 }
function uuztime:string;
var
 d:datetime;
begin
  unpacktime(filetime(paramstr(0)),d);
  uuztime:=(formi(d.day,2)+formi(d.month,2)+right(formi(d.year,2),2)
    +formi(d.hour,2)+formi(d.min,2));
end;

function get_time:datetimest;
var hh,mm,ss,proz : word;
begin
  gettime(hh,mm,ss,proz);
  get_time:=formi(hh,2)+':'+formi(mm,2)+':'+formi(ss,2)+''''+formi(proz,2);
end;

function time_diff(const t1,t2:datetimest):real;

  function TimeSecs(const t:datetimest):real;
  begin
    TimeSecs:=3600*ival(left(t,2))+60*ival(copy(t,4,2))+ival(copy(t,7,2))+ival(right(t,2))/100;
  end;

begin
  if t2>=t1 then
    time_diff:=round(TimeSecs(t2)-TimeSecs(t1),2)
  else
    time_diff:=round((24*3600-TimeSecs(t1))+TimeSecs(t2),2);
end;

function strSecs(t:real):datetimest;
var hh,mm,ss,proz : longint;
begin
  hh:=0; mm:=0; ss:=0; proz:=0;
  t:=round(t,2);
  if t>=3600 then
  begin
    hh:=trunc(t) div 3600;
    t:=t-hh*3600;
  end;
  if t>=60 then
  begin
    mm:=trunc(t) div 60;
    t:=t-mm*60;
  end;
  ss:=trunc(t);
  proz:=trunc(frac(t)*100);
  strSecs:=strs(hh)+':'+formi(mm,2)+':'+formi(ss,2)+''''+formi(proz,2);
end;

function sizeKB(f:string):real;
begin
  sizeKB:=_filesize(f)/1024;
end;

end.

{
  $Log$
}
